#pragma section REPRO
/**
 * @file
 * @brief  テレメトリ定義
 * @note   このコードは自動生成されています！
 */
#include "../../src_core/TlmCmd/telemetry_frame.h"
#include "telemetry_definitions.h"
#include "telemetry_source.h"

static int Tlm_MOBC_(unsigned char* contents, int max_len);
static int Tlm_MEM_(unsigned char* contents, int max_len);
static int Tlm_TLM_MGR_(unsigned char* contents, int max_len);
static int Tlm_TL_(unsigned char* contents, int max_len);
static int Tlm_BL_(unsigned char* contents, int max_len);
static int Tlm_CA_(unsigned char* contents, int max_len);
static int Tlm_TF_(unsigned char* contents, int max_len);
static int Tlm_DCU_(unsigned char* contents, int max_len);
static int Tlm_MM_(unsigned char* contents, int max_len);
static int Tlm_AM_(unsigned char* contents, int max_len);
static int Tlm_APP_TIME_(unsigned char* contents, int max_len);
static int Tlm_EL_(unsigned char* contents, int max_len);
static int Tlm_EL_TLOG_(unsigned char* contents, int max_len);
static int Tlm_EL_CLOG_(unsigned char* contents, int max_len);
static int Tlm_EH_(unsigned char* contents, int max_len);
static int Tlm_EH_RULE_(unsigned char* contents, int max_len);
static int Tlm_EH_LOG_(unsigned char* contents, int max_len);
static int Tlm_EH_INDEX_(unsigned char* contents, int max_len);
static int Tlm_GS_(unsigned char* contents, int max_len);
static int Tlm_HK_(unsigned char* contents, int max_len);
static int Tlm_GIT_REV_(unsigned char* contents, int max_len);
static int Tlm_UART_TEST_(unsigned char* contents, int max_len);

void TF_load_tlm_table(TF_TlmInfo tlm_table[TF_MAX_TLMS])
{
  tlm_table[Tlm_CODE_MOBC].tlm_func = Tlm_MOBC_;
  tlm_table[Tlm_CODE_MEM].tlm_func = Tlm_MEM_;
  tlm_table[Tlm_CODE_TLM_MGR].tlm_func = Tlm_TLM_MGR_;
  tlm_table[Tlm_CODE_TL].tlm_func = Tlm_TL_;
  tlm_table[Tlm_CODE_BL].tlm_func = Tlm_BL_;
  tlm_table[Tlm_CODE_CA].tlm_func = Tlm_CA_;
  tlm_table[Tlm_CODE_TF].tlm_func = Tlm_TF_;
  tlm_table[Tlm_CODE_DCU].tlm_func = Tlm_DCU_;
  tlm_table[Tlm_CODE_MM].tlm_func = Tlm_MM_;
  tlm_table[Tlm_CODE_AM].tlm_func = Tlm_AM_;
  tlm_table[Tlm_CODE_APP_TIME].tlm_func = Tlm_APP_TIME_;
  tlm_table[Tlm_CODE_EL].tlm_func = Tlm_EL_;
  tlm_table[Tlm_CODE_EL_TLOG].tlm_func = Tlm_EL_TLOG_;
  tlm_table[Tlm_CODE_EL_CLOG].tlm_func = Tlm_EL_CLOG_;
  tlm_table[Tlm_CODE_EH].tlm_func = Tlm_EH_;
  tlm_table[Tlm_CODE_EH_RULE].tlm_func = Tlm_EH_RULE_;
  tlm_table[Tlm_CODE_EH_LOG].tlm_func = Tlm_EH_LOG_;
  tlm_table[Tlm_CODE_EH_INDEX].tlm_func = Tlm_EH_INDEX_;
  tlm_table[Tlm_CODE_GS].tlm_func = Tlm_GS_;
  tlm_table[Tlm_CODE_HK].tlm_func = Tlm_HK_;
  tlm_table[Tlm_CODE_GIT_REV].tlm_func = Tlm_GIT_REV_;
  tlm_table[Tlm_CODE_UART_TEST].tlm_func = Tlm_UART_TEST_;
}

static int Tlm_MOBC_(unsigned char* contents, int max_len)
{
  if (252 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u32(&contents[0], (uint32_t)(TMGR_get_master_clock().mode_cycle));
  TF_copy_double(&contents[4], (double)(time_manager->utl_unixtime_epoch_));
  TF_copy_u8(&contents[12], (uint8_t)(mode_manager->stat));
  TF_copy_u8(&contents[13], (uint8_t)(mode_manager->current_id));
  TF_copy_u8(&contents[14], (uint8_t)(mode_manager->previous_id));
  TF_copy_u8(&contents[15], (uint8_t)(TDSP_info->task_list_id));
  TF_copy_u32(&contents[16], (uint32_t)(TDSP_info->tskd.prev_err.time.total_cycle));
  TF_copy_u8(&contents[20], (uint8_t)(TDSP_info->tskd.prev_err.time.step));
  TF_copy_u16(&contents[21], (uint16_t)(TDSP_info->tskd.prev_err.code));
  TF_copy_i32(&contents[23], (int32_t)(TDSP_info->tskd.prev_err.sts));
  TF_copy_i32(&contents[27], (int32_t)gs_driver->latest_info->ret_from_if_rx);
  TF_copy_u8(&contents[31], (uint8_t)gs_driver->latest_info->rec_status);
  TF_copy_u8(&contents[32], (uint8_t)gs_driver->latest_info->tc_frame_validate_status);
  TF_copy_u32(&contents[33], (uint32_t)gs_driver->latest_info->last_rec_time);
  TF_copy_u8(&contents[37], (uint8_t)gs_validate_info->positive_window_width);
  TF_copy_u8(&contents[38], (uint8_t)gs_driver->latest_info->cmd_ack);
  TF_copy_u8(&contents[39], (uint8_t)gs_driver->tlm_tx_port_type);
  TF_copy_u32(&contents[40], PL_count_executed_nodes(&PH_gs_cmd_list));
  TF_copy_u32(&contents[44], (uint32_t)(gs_command_dispatcher->prev.time.total_cycle));
  TF_copy_u16(&contents[48], (uint16_t)(gs_command_dispatcher->prev.code));
  TF_copy_i32(&contents[50], (int32_t)(gs_command_dispatcher->prev.sts));
  TF_copy_u32(&contents[54], (uint32_t)(gs_command_dispatcher->prev_err.time.total_cycle));
  TF_copy_u16(&contents[58], (uint16_t)(gs_command_dispatcher->prev_err.code));
  TF_copy_i32(&contents[60], (int32_t)(gs_command_dispatcher->prev_err.sts));
  TF_copy_u32(&contents[64], (uint32_t)(gs_command_dispatcher->error_counter));
  TF_copy_u32(&contents[68], PL_count_executed_nodes(&PH_rt_cmd_list));
  TF_copy_u32(&contents[72], (uint32_t)(realtime_command_dispatcher->prev.time.total_cycle));
  TF_copy_u16(&contents[76], (uint16_t)(realtime_command_dispatcher->prev.code));
  TF_copy_i32(&contents[78], (int32_t)(realtime_command_dispatcher->prev.sts));
  TF_copy_u32(&contents[82], (uint32_t)(realtime_command_dispatcher->prev_err.time.total_cycle));
  TF_copy_u16(&contents[86], (uint16_t)(realtime_command_dispatcher->prev_err.code));
  TF_copy_i32(&contents[88], (int32_t)(realtime_command_dispatcher->prev_err.sts));
  TF_copy_u32(&contents[92], (uint32_t)(realtime_command_dispatcher->error_counter));
  TF_copy_u32(&contents[96], PL_count_executed_nodes(&PH_tl_cmd_list[0]));
  TF_copy_u8(&contents[100], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[0])));
  TF_copy_u32(&contents[101], (uint32_t)(timeline_command_dispatcher[0].prev.time.total_cycle));
  TF_copy_u16(&contents[105], (uint16_t)(timeline_command_dispatcher[0].prev.code));
  TF_copy_i32(&contents[107], (int32_t)(timeline_command_dispatcher[0].prev.sts));
  TF_copy_u32(&contents[111], (uint32_t)(timeline_command_dispatcher[0].prev_err.time.total_cycle));
  TF_copy_u16(&contents[115], (uint16_t)(timeline_command_dispatcher[0].prev_err.code));
  TF_copy_i32(&contents[117], (int32_t)(timeline_command_dispatcher[0].prev_err.sts));
  TF_copy_u32(&contents[121], (uint32_t)(timeline_command_dispatcher[0].error_counter));
  TF_copy_u8(&contents[125], (uint8_t)(timeline_command_dispatcher[0].stop_on_error));
  TF_copy_u8(&contents[126], (uint8_t)(timeline_command_dispatcher[0].lockout));
  TF_copy_u32(&contents[127], (PL_is_empty(&(PH_tl_cmd_list[0])) ? 0 : (uint32_t)CCP_get_ti(&(PL_get_head(&(PH_tl_cmd_list[0]))->packet))));
  TF_copy_u16(&contents[131], (uint16_t)(PL_is_empty(&(PH_tl_cmd_list[0])) ? 0 : CCP_get_id(&(PL_get_head(&(PH_tl_cmd_list[0]))->packet))));
  TF_copy_u32(&contents[133], PL_count_executed_nodes(&PH_tl_cmd_list[1]));
  TF_copy_u8(&contents[137], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[1])));
  TF_copy_u32(&contents[138], (uint32_t)(timeline_command_dispatcher[1].prev.time.total_cycle));
  TF_copy_u16(&contents[142], (uint16_t)(timeline_command_dispatcher[1].prev.code));
  TF_copy_i32(&contents[144], (int32_t)(timeline_command_dispatcher[1].prev.sts));
  TF_copy_u32(&contents[148], (uint32_t)(timeline_command_dispatcher[1].prev_err.time.total_cycle));
  TF_copy_u16(&contents[152], (uint16_t)(timeline_command_dispatcher[1].prev_err.code));
  TF_copy_i32(&contents[154], (int32_t)(timeline_command_dispatcher[1].prev_err.sts));
  TF_copy_u32(&contents[158], (uint32_t)(timeline_command_dispatcher[1].error_counter));
  TF_copy_u8(&contents[162], (uint8_t)(timeline_command_dispatcher[1].stop_on_error));
  TF_copy_u8(&contents[163], (uint8_t)(timeline_command_dispatcher[1].lockout));
  TF_copy_u32(&contents[164], (PL_is_empty(&(PH_tl_cmd_list[1])) ? 0 : (uint32_t)CCP_get_ti(&(PL_get_head(&(PH_tl_cmd_list[1]))->packet))));
  TF_copy_u16(&contents[168], (uint16_t)(PL_is_empty(&(PH_tl_cmd_list[1])) ? 0 : CCP_get_id(&(PL_get_head(&(PH_tl_cmd_list[1]))->packet))));
  TF_copy_u32(&contents[170], PL_count_executed_nodes(&PH_tl_cmd_list[2]));
  TF_copy_u8(&contents[174], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[2])));
  TF_copy_u32(&contents[175], (uint32_t)(timeline_command_dispatcher[2].prev.time.total_cycle));
  TF_copy_u16(&contents[179], (uint16_t)(timeline_command_dispatcher[2].prev.code));
  TF_copy_i32(&contents[181], (int32_t)(timeline_command_dispatcher[2].prev.sts));
  TF_copy_u32(&contents[185], (uint32_t)(timeline_command_dispatcher[2].prev_err.time.total_cycle));
  TF_copy_u16(&contents[189], (uint16_t)(timeline_command_dispatcher[2].prev_err.code));
  TF_copy_i32(&contents[191], (int32_t)(timeline_command_dispatcher[2].prev_err.sts));
  TF_copy_u32(&contents[195], (uint32_t)(timeline_command_dispatcher[2].error_counter));
  TF_copy_u8(&contents[199], (uint8_t)(timeline_command_dispatcher[2].stop_on_error));
  TF_copy_u8(&contents[200], (uint8_t)(timeline_command_dispatcher[2].lockout));
  TF_copy_u32(&contents[201], (PL_is_empty(&(PH_tl_cmd_list[2])) ? 0 : (uint32_t)CCP_get_ti(&(PL_get_head(&(PH_tl_cmd_list[2]))->packet))));
  TF_copy_u16(&contents[205], (uint16_t)(PL_is_empty(&(PH_tl_cmd_list[2])) ? 0 : CCP_get_id(&(PL_get_head(&(PH_tl_cmd_list[2]))->packet))));
  TF_copy_u8(&contents[207], (uint8_t)(block_command_table->pos.block));
  TF_copy_u8(&contents[208], (uint8_t)(block_command_table->pos.cmd));
  TF_copy_u32(&contents[209], ((block_command_table->pos.cmd == 0) ? 0 : (uint32_t)BCT_get_ti(block_command_table->pos.block, (uint8_t)(block_command_table->pos.cmd-1))));
  TF_copy_u16(&contents[213], (uint16_t)((block_command_table->pos.cmd == 0) ? 0 : BCT_get_id(block_command_table->pos.block, (uint8_t)(block_command_table->pos.cmd-1))));
  TF_copy_u8(&contents[215], gs_driver->ccsds_info.buffer_num);
  TF_copy_u32(&contents[216], (uint32_t)(DI_GS_ms_tlm_packet_handler->tc_packet_to_m_pdu.flush_interval));
  TF_copy_u32(&contents[220], (uint32_t)(DI_GS_rp_tlm_packet_handler->tc_packet_to_m_pdu.flush_interval));
  TF_copy_u32(&contents[224], PL_count_executed_nodes(&PH_ms_tlm_list));
  TF_copy_u8(&contents[228], (uint8_t)(PL_count_active_nodes(&PH_ms_tlm_list)));
  TF_copy_u32(&contents[229], PL_count_executed_nodes(&PH_st_tlm_list));
  TF_copy_u8(&contents[233], (uint8_t)(PL_count_active_nodes(&PH_st_tlm_list)));
  TF_copy_u32(&contents[234], PL_count_executed_nodes(&PH_rp_tlm_list));
  TF_copy_u8(&contents[238], (uint8_t)(PL_count_active_nodes(&PH_rp_tlm_list)));
  TF_copy_u32(&contents[239], (uint32_t)gs_driver->latest_info->send_cycle);
  TF_copy_u32(&contents[243], gs_driver->driver_ccsds.ccsds_config.bitrate);
  TF_copy_u8(&contents[247], (uint8_t)(gs_driver->info[2].vcid));
  TF_copy_u32(&contents[248], gs_driver->latest_info->vcdu_counter);
#endif

  return 252;
}

static int Tlm_MEM_(unsigned char* contents, int max_len)
{
  if (23 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u32(&contents[0], memory_dump->begin);
  TF_copy_u32(&contents[4], memory_dump->end);
  TF_copy_u32(&contents[8], memory_dump->adu_size);
  TF_copy_u16(&contents[12], memory_dump->adu_seq);
  TF_copy_u8(&contents[14], memory_dump->adu_counter);
  TF_copy_u32(&contents[15], memory_dump->dest);
  TF_copy_u32(&contents[19], memory_dump->rp);
#endif

  return 23;
}

static int Tlm_TLM_MGR_(unsigned char* contents, int max_len)
{
  if (111 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u16(&contents[0], telemetry_manager->master_bc_id);
  TF_copy_u16(&contents[2], telemetry_manager->bc_info[0].bc_id);
  TF_copy_u8(&contents[4], (uint8_t)telemetry_manager->bc_info[0].bc_type);
  TF_copy_u16(&contents[5], telemetry_manager->bc_info[1].bc_id);
  TF_copy_u8(&contents[7], (uint8_t)telemetry_manager->bc_info[1].bc_type);
  TF_copy_u16(&contents[8], telemetry_manager->bc_info[2].bc_id);
  TF_copy_u8(&contents[10], (uint8_t)telemetry_manager->bc_info[2].bc_type);
  TF_copy_u16(&contents[11], telemetry_manager->bc_info[3].bc_id);
  TF_copy_u8(&contents[13], (uint8_t)telemetry_manager->bc_info[3].bc_type);
  TF_copy_u16(&contents[14], telemetry_manager->bc_info[4].bc_id);
  TF_copy_u8(&contents[16], (uint8_t)telemetry_manager->bc_info[4].bc_type);
  TF_copy_u16(&contents[17], telemetry_manager->bc_info[5].bc_id);
  TF_copy_u8(&contents[19], (uint8_t)telemetry_manager->bc_info[5].bc_type);
  TF_copy_u16(&contents[20], telemetry_manager->bc_info[6].bc_id);
  TF_copy_u8(&contents[22], (uint8_t)telemetry_manager->bc_info[6].bc_type);
  TF_copy_u16(&contents[23], telemetry_manager->bc_info[7].bc_id);
  TF_copy_u8(&contents[25], (uint8_t)telemetry_manager->bc_info[7].bc_type);
  TF_copy_u16(&contents[26], telemetry_manager->bc_info[8].bc_id);
  TF_copy_u8(&contents[28], (uint8_t)telemetry_manager->bc_info[8].bc_type);
  TF_copy_u16(&contents[29], telemetry_manager->bc_info[9].bc_id);
  TF_copy_u8(&contents[31], (uint8_t)telemetry_manager->bc_info[9].bc_type);
  TF_copy_u8(&contents[32], telemetry_manager->register_info.master.bc_info_idx[0]);
  TF_copy_u8(&contents[33], telemetry_manager->register_info.master.bc_info_idx[1]);
  TF_copy_u8(&contents[34], telemetry_manager->register_info.master.bc_info_idx[2]);
  TF_copy_u8(&contents[35], telemetry_manager->register_info.master.bc_info_idx[3]);
  TF_copy_u8(&contents[36], telemetry_manager->register_info.master.bc_info_idx[4]);
  TF_copy_u8(&contents[37], telemetry_manager->register_info.master.bc_info_idx[5]);
  TF_copy_u8(&contents[38], telemetry_manager->register_info.master.bc_info_idx[6]);
  TF_copy_u8(&contents[39], telemetry_manager->register_info.master.bc_info_idx[7]);
  TF_copy_u8(&contents[40], telemetry_manager->register_info.master.bc_info_idx[8]);
  TF_copy_u8(&contents[41], telemetry_manager->register_info.master.bc_info_idx[9]);
  TF_copy_u8(&contents[42], telemetry_manager->register_info.master.bc_info_idx_used_num);
  TF_copy_u8(&contents[43], telemetry_manager->register_info.master.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[44], telemetry_manager->register_info.master.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[45], telemetry_manager->register_info.hk_tlm.bc_info_idx[0]);
  TF_copy_u8(&contents[46], telemetry_manager->register_info.hk_tlm.bc_info_idx[1]);
  TF_copy_u8(&contents[47], telemetry_manager->register_info.hk_tlm.bc_info_idx[2]);
  TF_copy_u8(&contents[48], telemetry_manager->register_info.hk_tlm.bc_info_idx[3]);
  TF_copy_u8(&contents[49], telemetry_manager->register_info.hk_tlm.bc_info_idx[4]);
  TF_copy_u8(&contents[50], telemetry_manager->register_info.hk_tlm.bc_info_idx[5]);
  TF_copy_u8(&contents[51], telemetry_manager->register_info.hk_tlm.bc_info_idx[6]);
  TF_copy_u8(&contents[52], telemetry_manager->register_info.hk_tlm.bc_info_idx[7]);
  TF_copy_u8(&contents[53], telemetry_manager->register_info.hk_tlm.bc_info_idx[8]);
  TF_copy_u8(&contents[54], telemetry_manager->register_info.hk_tlm.bc_info_idx[9]);
  TF_copy_u8(&contents[55], telemetry_manager->register_info.hk_tlm.bc_info_idx_used_num);
  TF_copy_u8(&contents[56], telemetry_manager->register_info.hk_tlm.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[57], telemetry_manager->register_info.hk_tlm.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[58], telemetry_manager->register_info.system_tlm.bc_info_idx[0]);
  TF_copy_u8(&contents[59], telemetry_manager->register_info.system_tlm.bc_info_idx[1]);
  TF_copy_u8(&contents[60], telemetry_manager->register_info.system_tlm.bc_info_idx[2]);
  TF_copy_u8(&contents[61], telemetry_manager->register_info.system_tlm.bc_info_idx[3]);
  TF_copy_u8(&contents[62], telemetry_manager->register_info.system_tlm.bc_info_idx[4]);
  TF_copy_u8(&contents[63], telemetry_manager->register_info.system_tlm.bc_info_idx[5]);
  TF_copy_u8(&contents[64], telemetry_manager->register_info.system_tlm.bc_info_idx[6]);
  TF_copy_u8(&contents[65], telemetry_manager->register_info.system_tlm.bc_info_idx[7]);
  TF_copy_u8(&contents[66], telemetry_manager->register_info.system_tlm.bc_info_idx[8]);
  TF_copy_u8(&contents[67], telemetry_manager->register_info.system_tlm.bc_info_idx[9]);
  TF_copy_u8(&contents[68], telemetry_manager->register_info.system_tlm.bc_info_idx_used_num);
  TF_copy_u8(&contents[69], telemetry_manager->register_info.system_tlm.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[70], telemetry_manager->register_info.system_tlm.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[71], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[0]);
  TF_copy_u8(&contents[72], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[1]);
  TF_copy_u8(&contents[73], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[2]);
  TF_copy_u8(&contents[74], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[3]);
  TF_copy_u8(&contents[75], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[4]);
  TF_copy_u8(&contents[76], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[5]);
  TF_copy_u8(&contents[77], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[6]);
  TF_copy_u8(&contents[78], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[7]);
  TF_copy_u8(&contents[79], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[8]);
  TF_copy_u8(&contents[80], telemetry_manager->register_info.high_freq_tlm.bc_info_idx[9]);
  TF_copy_u8(&contents[81], telemetry_manager->register_info.high_freq_tlm.bc_info_idx_used_num);
  TF_copy_u8(&contents[82], telemetry_manager->register_info.high_freq_tlm.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[83], telemetry_manager->register_info.high_freq_tlm.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[84], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[0]);
  TF_copy_u8(&contents[85], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[1]);
  TF_copy_u8(&contents[86], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[2]);
  TF_copy_u8(&contents[87], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[3]);
  TF_copy_u8(&contents[88], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[4]);
  TF_copy_u8(&contents[89], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[5]);
  TF_copy_u8(&contents[90], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[6]);
  TF_copy_u8(&contents[91], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[7]);
  TF_copy_u8(&contents[92], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[8]);
  TF_copy_u8(&contents[93], telemetry_manager->register_info.low_freq_tlm.bc_info_idx[9]);
  TF_copy_u8(&contents[94], telemetry_manager->register_info.low_freq_tlm.bc_info_idx_used_num);
  TF_copy_u8(&contents[95], telemetry_manager->register_info.low_freq_tlm.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[96], telemetry_manager->register_info.low_freq_tlm.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[97], telemetry_manager->register_info.reserve.bc_info_idx[0]);
  TF_copy_u8(&contents[98], telemetry_manager->register_info.reserve.bc_info_idx[1]);
  TF_copy_u8(&contents[99], telemetry_manager->register_info.reserve.bc_info_idx[2]);
  TF_copy_u8(&contents[100], telemetry_manager->register_info.reserve.bc_info_idx[3]);
  TF_copy_u8(&contents[101], telemetry_manager->register_info.reserve.bc_info_idx[4]);
  TF_copy_u8(&contents[102], telemetry_manager->register_info.reserve.bc_info_idx[5]);
  TF_copy_u8(&contents[103], telemetry_manager->register_info.reserve.bc_info_idx[6]);
  TF_copy_u8(&contents[104], telemetry_manager->register_info.reserve.bc_info_idx[7]);
  TF_copy_u8(&contents[105], telemetry_manager->register_info.reserve.bc_info_idx[8]);
  TF_copy_u8(&contents[106], telemetry_manager->register_info.reserve.bc_info_idx[9]);
  TF_copy_u8(&contents[107], telemetry_manager->register_info.reserve.bc_info_idx_used_num);
  TF_copy_u8(&contents[108], telemetry_manager->register_info.reserve.tlm_register_pointer_to_idx_of_bc_info_idx);
  TF_copy_u8(&contents[109], telemetry_manager->register_info.reserve.tlm_register_pointer_to_bc_cmd_idx);
  TF_copy_u8(&contents[110], telemetry_manager->is_inited);
#endif

  return 111;
}

static int Tlm_TL_(unsigned char* contents, int max_len)
{
  if (390 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], TLCD_update_tl_list_for_tlm((uint8_t)*TLCD_line_no_for_tlm));
  TF_copy_u8(&contents[1], (uint8_t)(*TLCD_page_no));
  TF_copy_u32(&contents[2], (uint32_t)(*TLCD_tl_tlm_updated_at));
  TF_copy_u16(&contents[6], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0]));
  TF_copy_u32(&contents[8], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0]));
  TF_copy_u8(&contents[12], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[0]);
  TF_copy_u8(&contents[13], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[1]);
  TF_copy_u8(&contents[14], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[2]);
  TF_copy_u8(&contents[15], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[3]);
  TF_copy_u8(&contents[16], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[4]);
  TF_copy_u8(&contents[17], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+0])[5]);
  TF_copy_u16(&contents[18], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1]));
  TF_copy_u32(&contents[20], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1]));
  TF_copy_u8(&contents[24], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[0]);
  TF_copy_u8(&contents[25], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[1]);
  TF_copy_u8(&contents[26], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[2]);
  TF_copy_u8(&contents[27], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[3]);
  TF_copy_u8(&contents[28], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[4]);
  TF_copy_u8(&contents[29], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+1])[5]);
  TF_copy_u16(&contents[30], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2]));
  TF_copy_u32(&contents[32], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2]));
  TF_copy_u8(&contents[36], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[0]);
  TF_copy_u8(&contents[37], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[1]);
  TF_copy_u8(&contents[38], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[2]);
  TF_copy_u8(&contents[39], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[3]);
  TF_copy_u8(&contents[40], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[4]);
  TF_copy_u8(&contents[41], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+2])[5]);
  TF_copy_u16(&contents[42], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3]));
  TF_copy_u32(&contents[44], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3]));
  TF_copy_u8(&contents[48], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[0]);
  TF_copy_u8(&contents[49], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[1]);
  TF_copy_u8(&contents[50], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[2]);
  TF_copy_u8(&contents[51], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[3]);
  TF_copy_u8(&contents[52], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[4]);
  TF_copy_u8(&contents[53], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+3])[5]);
  TF_copy_u16(&contents[54], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4]));
  TF_copy_u32(&contents[56], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4]));
  TF_copy_u8(&contents[60], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[0]);
  TF_copy_u8(&contents[61], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[1]);
  TF_copy_u8(&contents[62], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[2]);
  TF_copy_u8(&contents[63], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[3]);
  TF_copy_u8(&contents[64], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[4]);
  TF_copy_u8(&contents[65], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+4])[5]);
  TF_copy_u16(&contents[66], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5]));
  TF_copy_u32(&contents[68], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5]));
  TF_copy_u8(&contents[72], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[0]);
  TF_copy_u8(&contents[73], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[1]);
  TF_copy_u8(&contents[74], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[2]);
  TF_copy_u8(&contents[75], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[3]);
  TF_copy_u8(&contents[76], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[4]);
  TF_copy_u8(&contents[77], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+5])[5]);
  TF_copy_u16(&contents[78], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6]));
  TF_copy_u32(&contents[80], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6]));
  TF_copy_u8(&contents[84], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[0]);
  TF_copy_u8(&contents[85], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[1]);
  TF_copy_u8(&contents[86], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[2]);
  TF_copy_u8(&contents[87], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[3]);
  TF_copy_u8(&contents[88], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[4]);
  TF_copy_u8(&contents[89], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+6])[5]);
  TF_copy_u16(&contents[90], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7]));
  TF_copy_u32(&contents[92], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7]));
  TF_copy_u8(&contents[96], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[0]);
  TF_copy_u8(&contents[97], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[1]);
  TF_copy_u8(&contents[98], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[2]);
  TF_copy_u8(&contents[99], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[3]);
  TF_copy_u8(&contents[100], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[4]);
  TF_copy_u8(&contents[101], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+7])[5]);
  TF_copy_u16(&contents[102], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8]));
  TF_copy_u32(&contents[104], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8]));
  TF_copy_u8(&contents[108], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[0]);
  TF_copy_u8(&contents[109], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[1]);
  TF_copy_u8(&contents[110], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[2]);
  TF_copy_u8(&contents[111], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[3]);
  TF_copy_u8(&contents[112], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[4]);
  TF_copy_u8(&contents[113], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+8])[5]);
  TF_copy_u16(&contents[114], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9]));
  TF_copy_u32(&contents[116], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9]));
  TF_copy_u8(&contents[120], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[0]);
  TF_copy_u8(&contents[121], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[1]);
  TF_copy_u8(&contents[122], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[2]);
  TF_copy_u8(&contents[123], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[3]);
  TF_copy_u8(&contents[124], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[4]);
  TF_copy_u8(&contents[125], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+9])[5]);
  TF_copy_u16(&contents[126], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10]));
  TF_copy_u32(&contents[128], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10]));
  TF_copy_u8(&contents[132], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[0]);
  TF_copy_u8(&contents[133], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[1]);
  TF_copy_u8(&contents[134], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[2]);
  TF_copy_u8(&contents[135], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[3]);
  TF_copy_u8(&contents[136], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[4]);
  TF_copy_u8(&contents[137], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+10])[5]);
  TF_copy_u16(&contents[138], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11]));
  TF_copy_u32(&contents[140], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11]));
  TF_copy_u8(&contents[144], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[0]);
  TF_copy_u8(&contents[145], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[1]);
  TF_copy_u8(&contents[146], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[2]);
  TF_copy_u8(&contents[147], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[3]);
  TF_copy_u8(&contents[148], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[4]);
  TF_copy_u8(&contents[149], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+11])[5]);
  TF_copy_u16(&contents[150], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12]));
  TF_copy_u32(&contents[152], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12]));
  TF_copy_u8(&contents[156], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[0]);
  TF_copy_u8(&contents[157], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[1]);
  TF_copy_u8(&contents[158], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[2]);
  TF_copy_u8(&contents[159], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[3]);
  TF_copy_u8(&contents[160], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[4]);
  TF_copy_u8(&contents[161], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+12])[5]);
  TF_copy_u16(&contents[162], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13]));
  TF_copy_u32(&contents[164], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13]));
  TF_copy_u8(&contents[168], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[0]);
  TF_copy_u8(&contents[169], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[1]);
  TF_copy_u8(&contents[170], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[2]);
  TF_copy_u8(&contents[171], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[3]);
  TF_copy_u8(&contents[172], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[4]);
  TF_copy_u8(&contents[173], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+13])[5]);
  TF_copy_u16(&contents[174], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14]));
  TF_copy_u32(&contents[176], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14]));
  TF_copy_u8(&contents[180], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[0]);
  TF_copy_u8(&contents[181], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[1]);
  TF_copy_u8(&contents[182], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[2]);
  TF_copy_u8(&contents[183], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[3]);
  TF_copy_u8(&contents[184], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[4]);
  TF_copy_u8(&contents[185], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+14])[5]);
  TF_copy_u16(&contents[186], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15]));
  TF_copy_u32(&contents[188], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15]));
  TF_copy_u8(&contents[192], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[0]);
  TF_copy_u8(&contents[193], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[1]);
  TF_copy_u8(&contents[194], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[2]);
  TF_copy_u8(&contents[195], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[3]);
  TF_copy_u8(&contents[196], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[4]);
  TF_copy_u8(&contents[197], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+15])[5]);
  TF_copy_u16(&contents[198], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16]));
  TF_copy_u32(&contents[200], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16]));
  TF_copy_u8(&contents[204], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[0]);
  TF_copy_u8(&contents[205], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[1]);
  TF_copy_u8(&contents[206], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[2]);
  TF_copy_u8(&contents[207], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[3]);
  TF_copy_u8(&contents[208], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[4]);
  TF_copy_u8(&contents[209], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+16])[5]);
  TF_copy_u16(&contents[210], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17]));
  TF_copy_u32(&contents[212], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17]));
  TF_copy_u8(&contents[216], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[0]);
  TF_copy_u8(&contents[217], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[1]);
  TF_copy_u8(&contents[218], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[2]);
  TF_copy_u8(&contents[219], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[3]);
  TF_copy_u8(&contents[220], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[4]);
  TF_copy_u8(&contents[221], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+17])[5]);
  TF_copy_u16(&contents[222], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18]));
  TF_copy_u32(&contents[224], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18]));
  TF_copy_u8(&contents[228], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[0]);
  TF_copy_u8(&contents[229], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[1]);
  TF_copy_u8(&contents[230], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[2]);
  TF_copy_u8(&contents[231], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[3]);
  TF_copy_u8(&contents[232], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[4]);
  TF_copy_u8(&contents[233], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+18])[5]);
  TF_copy_u16(&contents[234], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19]));
  TF_copy_u32(&contents[236], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19]));
  TF_copy_u8(&contents[240], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[0]);
  TF_copy_u8(&contents[241], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[1]);
  TF_copy_u8(&contents[242], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[2]);
  TF_copy_u8(&contents[243], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[3]);
  TF_copy_u8(&contents[244], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[4]);
  TF_copy_u8(&contents[245], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+19])[5]);
  TF_copy_u16(&contents[246], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20]));
  TF_copy_u32(&contents[248], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20]));
  TF_copy_u8(&contents[252], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[0]);
  TF_copy_u8(&contents[253], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[1]);
  TF_copy_u8(&contents[254], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[2]);
  TF_copy_u8(&contents[255], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[3]);
  TF_copy_u8(&contents[256], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[4]);
  TF_copy_u8(&contents[257], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+20])[5]);
  TF_copy_u16(&contents[258], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21]));
  TF_copy_u32(&contents[260], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21]));
  TF_copy_u8(&contents[264], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[0]);
  TF_copy_u8(&contents[265], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[1]);
  TF_copy_u8(&contents[266], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[2]);
  TF_copy_u8(&contents[267], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[3]);
  TF_copy_u8(&contents[268], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[4]);
  TF_copy_u8(&contents[269], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+21])[5]);
  TF_copy_u16(&contents[270], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22]));
  TF_copy_u32(&contents[272], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22]));
  TF_copy_u8(&contents[276], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[0]);
  TF_copy_u8(&contents[277], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[1]);
  TF_copy_u8(&contents[278], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[2]);
  TF_copy_u8(&contents[279], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[3]);
  TF_copy_u8(&contents[280], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[4]);
  TF_copy_u8(&contents[281], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+22])[5]);
  TF_copy_u16(&contents[282], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23]));
  TF_copy_u32(&contents[284], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23]));
  TF_copy_u8(&contents[288], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[0]);
  TF_copy_u8(&contents[289], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[1]);
  TF_copy_u8(&contents[290], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[2]);
  TF_copy_u8(&contents[291], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[3]);
  TF_copy_u8(&contents[292], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[4]);
  TF_copy_u8(&contents[293], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+23])[5]);
  TF_copy_u16(&contents[294], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24]));
  TF_copy_u32(&contents[296], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24]));
  TF_copy_u8(&contents[300], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[0]);
  TF_copy_u8(&contents[301], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[1]);
  TF_copy_u8(&contents[302], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[2]);
  TF_copy_u8(&contents[303], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[3]);
  TF_copy_u8(&contents[304], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[4]);
  TF_copy_u8(&contents[305], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+24])[5]);
  TF_copy_u16(&contents[306], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25]));
  TF_copy_u32(&contents[308], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25]));
  TF_copy_u8(&contents[312], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[0]);
  TF_copy_u8(&contents[313], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[1]);
  TF_copy_u8(&contents[314], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[2]);
  TF_copy_u8(&contents[315], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[3]);
  TF_copy_u8(&contents[316], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[4]);
  TF_copy_u8(&contents[317], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+25])[5]);
  TF_copy_u16(&contents[318], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26]));
  TF_copy_u32(&contents[320], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26]));
  TF_copy_u8(&contents[324], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[0]);
  TF_copy_u8(&contents[325], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[1]);
  TF_copy_u8(&contents[326], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[2]);
  TF_copy_u8(&contents[327], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[3]);
  TF_copy_u8(&contents[328], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[4]);
  TF_copy_u8(&contents[329], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+26])[5]);
  TF_copy_u16(&contents[330], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27]));
  TF_copy_u32(&contents[332], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27]));
  TF_copy_u8(&contents[336], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[0]);
  TF_copy_u8(&contents[337], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[1]);
  TF_copy_u8(&contents[338], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[2]);
  TF_copy_u8(&contents[339], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[3]);
  TF_copy_u8(&contents[340], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[4]);
  TF_copy_u8(&contents[341], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+27])[5]);
  TF_copy_u16(&contents[342], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28]));
  TF_copy_u32(&contents[344], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28]));
  TF_copy_u8(&contents[348], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[0]);
  TF_copy_u8(&contents[349], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[1]);
  TF_copy_u8(&contents[350], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[2]);
  TF_copy_u8(&contents[351], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[3]);
  TF_copy_u8(&contents[352], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[4]);
  TF_copy_u8(&contents[353], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+28])[5]);
  TF_copy_u16(&contents[354], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29]));
  TF_copy_u32(&contents[356], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29]));
  TF_copy_u8(&contents[360], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[0]);
  TF_copy_u8(&contents[361], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[1]);
  TF_copy_u8(&contents[362], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[2]);
  TF_copy_u8(&contents[363], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[3]);
  TF_copy_u8(&contents[364], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[4]);
  TF_copy_u8(&contents[365], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+29])[5]);
  TF_copy_u16(&contents[366], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30]));
  TF_copy_u32(&contents[368], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30]));
  TF_copy_u8(&contents[372], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[0]);
  TF_copy_u8(&contents[373], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[1]);
  TF_copy_u8(&contents[374], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[2]);
  TF_copy_u8(&contents[375], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[3]);
  TF_copy_u8(&contents[376], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[4]);
  TF_copy_u8(&contents[377], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+30])[5]);
  TF_copy_u16(&contents[378], (uint16_t)CCP_get_id(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31]));
  TF_copy_u32(&contents[380], (uint32_t)CCP_get_ti(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31]));
  TF_copy_u8(&contents[384], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[0]);
  TF_copy_u8(&contents[385], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[1]);
  TF_copy_u8(&contents[386], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[2]);
  TF_copy_u8(&contents[387], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[3]);
  TF_copy_u8(&contents[388], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[4]);
  TF_copy_u8(&contents[389], CCP_get_param_head(TLCD_tl_list_for_tlm[TL_TLM_PAGE_SIZE*(*TLCD_page_no)+31])[5]);
#endif

  return 390;
}

static int Tlm_BL_(unsigned char* contents, int max_len)
{
  if (400 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u16(&contents[0], block_command_table->pos.block);
  TF_copy_u8(&contents[2], block_command_table->pos.cmd);
  TF_copy_u8(&contents[3], BCT_get_bc_length(block_command_table->pos.block));
  TF_copy_u8(&contents[4], BCE_get_bc_exe_params(block_command_table->pos.block)->rotate.next_cmd);
  TF_copy_u16(&contents[5], BCE_get_bc_exe_params(block_command_table->pos.block)->rotate.counter);
  TF_copy_u16(&contents[7], BCE_get_bc_exe_params(block_command_table->pos.block)->rotate.interval);
  TF_copy_u16(&contents[9], BCE_get_bc_exe_params(block_command_table->pos.block)->timelimit_combine.call_num);
  TF_copy_u16(&contents[11], BCE_get_bc_exe_params(block_command_table->pos.block)->timelimit_combine.timeover_num);
  TF_copy_u8(&contents[13], BCE_get_bc_exe_params(block_command_table->pos.block)->timelimit_combine.last_timeover_cmd_pos);
  TF_copy_u8(&contents[14], BCE_get_bc_exe_params(block_command_table->pos.block)->timelimit_combine.worst_cmd_pos);
  TF_copy_u8(&contents[15], BCE_get_bc_exe_params(block_command_table->pos.block)->is_active);
  TF_copy_u16(&contents[16], (uint16_t)BCT_get_id(block_command_table->pos.block, 0));
  TF_copy_u32(&contents[18], (uint32_t)BCT_get_ti(block_command_table->pos.block, 0));
  TF_copy_u8(&contents[22], BCT_get_param_head(block_command_table->pos.block, 0)[0]);
  TF_copy_u8(&contents[23], BCT_get_param_head(block_command_table->pos.block, 0)[1]);
  TF_copy_u8(&contents[24], BCT_get_param_head(block_command_table->pos.block, 0)[2]);
  TF_copy_u8(&contents[25], BCT_get_param_head(block_command_table->pos.block, 0)[3]);
  TF_copy_u8(&contents[26], BCT_get_param_head(block_command_table->pos.block, 0)[4]);
  TF_copy_u8(&contents[27], BCT_get_param_head(block_command_table->pos.block, 0)[5]);
  TF_copy_u16(&contents[28], (uint16_t)BCT_get_id(block_command_table->pos.block, 1));
  TF_copy_u32(&contents[30], (uint32_t)BCT_get_ti(block_command_table->pos.block, 1));
  TF_copy_u8(&contents[34], BCT_get_param_head(block_command_table->pos.block, 1)[0]);
  TF_copy_u8(&contents[35], BCT_get_param_head(block_command_table->pos.block, 1)[1]);
  TF_copy_u8(&contents[36], BCT_get_param_head(block_command_table->pos.block, 1)[2]);
  TF_copy_u8(&contents[37], BCT_get_param_head(block_command_table->pos.block, 1)[3]);
  TF_copy_u8(&contents[38], BCT_get_param_head(block_command_table->pos.block, 1)[4]);
  TF_copy_u8(&contents[39], BCT_get_param_head(block_command_table->pos.block, 1)[5]);
  TF_copy_u16(&contents[40], (uint16_t)BCT_get_id(block_command_table->pos.block, 2));
  TF_copy_u32(&contents[42], (uint32_t)BCT_get_ti(block_command_table->pos.block, 2));
  TF_copy_u8(&contents[46], BCT_get_param_head(block_command_table->pos.block, 2)[0]);
  TF_copy_u8(&contents[47], BCT_get_param_head(block_command_table->pos.block, 2)[1]);
  TF_copy_u8(&contents[48], BCT_get_param_head(block_command_table->pos.block, 2)[2]);
  TF_copy_u8(&contents[49], BCT_get_param_head(block_command_table->pos.block, 2)[3]);
  TF_copy_u8(&contents[50], BCT_get_param_head(block_command_table->pos.block, 2)[4]);
  TF_copy_u8(&contents[51], BCT_get_param_head(block_command_table->pos.block, 2)[5]);
  TF_copy_u16(&contents[52], (uint16_t)BCT_get_id(block_command_table->pos.block, 3));
  TF_copy_u32(&contents[54], (uint32_t)BCT_get_ti(block_command_table->pos.block, 3));
  TF_copy_u8(&contents[58], BCT_get_param_head(block_command_table->pos.block, 3)[0]);
  TF_copy_u8(&contents[59], BCT_get_param_head(block_command_table->pos.block, 3)[1]);
  TF_copy_u8(&contents[60], BCT_get_param_head(block_command_table->pos.block, 3)[2]);
  TF_copy_u8(&contents[61], BCT_get_param_head(block_command_table->pos.block, 3)[3]);
  TF_copy_u8(&contents[62], BCT_get_param_head(block_command_table->pos.block, 3)[4]);
  TF_copy_u8(&contents[63], BCT_get_param_head(block_command_table->pos.block, 3)[5]);
  TF_copy_u16(&contents[64], (uint16_t)BCT_get_id(block_command_table->pos.block, 4));
  TF_copy_u32(&contents[66], (uint32_t)BCT_get_ti(block_command_table->pos.block, 4));
  TF_copy_u8(&contents[70], BCT_get_param_head(block_command_table->pos.block, 4)[0]);
  TF_copy_u8(&contents[71], BCT_get_param_head(block_command_table->pos.block, 4)[1]);
  TF_copy_u8(&contents[72], BCT_get_param_head(block_command_table->pos.block, 4)[2]);
  TF_copy_u8(&contents[73], BCT_get_param_head(block_command_table->pos.block, 4)[3]);
  TF_copy_u8(&contents[74], BCT_get_param_head(block_command_table->pos.block, 4)[4]);
  TF_copy_u8(&contents[75], BCT_get_param_head(block_command_table->pos.block, 4)[5]);
  TF_copy_u16(&contents[76], (uint16_t)BCT_get_id(block_command_table->pos.block, 5));
  TF_copy_u32(&contents[78], (uint32_t)BCT_get_ti(block_command_table->pos.block, 5));
  TF_copy_u8(&contents[82], BCT_get_param_head(block_command_table->pos.block, 5)[0]);
  TF_copy_u8(&contents[83], BCT_get_param_head(block_command_table->pos.block, 5)[1]);
  TF_copy_u8(&contents[84], BCT_get_param_head(block_command_table->pos.block, 5)[2]);
  TF_copy_u8(&contents[85], BCT_get_param_head(block_command_table->pos.block, 5)[3]);
  TF_copy_u8(&contents[86], BCT_get_param_head(block_command_table->pos.block, 5)[4]);
  TF_copy_u8(&contents[87], BCT_get_param_head(block_command_table->pos.block, 5)[5]);
  TF_copy_u16(&contents[88], (uint16_t)BCT_get_id(block_command_table->pos.block, 6));
  TF_copy_u32(&contents[90], (uint32_t)BCT_get_ti(block_command_table->pos.block, 6));
  TF_copy_u8(&contents[94], BCT_get_param_head(block_command_table->pos.block, 6)[0]);
  TF_copy_u8(&contents[95], BCT_get_param_head(block_command_table->pos.block, 6)[1]);
  TF_copy_u8(&contents[96], BCT_get_param_head(block_command_table->pos.block, 6)[2]);
  TF_copy_u8(&contents[97], BCT_get_param_head(block_command_table->pos.block, 6)[3]);
  TF_copy_u8(&contents[98], BCT_get_param_head(block_command_table->pos.block, 6)[4]);
  TF_copy_u8(&contents[99], BCT_get_param_head(block_command_table->pos.block, 6)[5]);
  TF_copy_u16(&contents[100], (uint16_t)BCT_get_id(block_command_table->pos.block, 7));
  TF_copy_u32(&contents[102], (uint32_t)BCT_get_ti(block_command_table->pos.block, 7));
  TF_copy_u8(&contents[106], BCT_get_param_head(block_command_table->pos.block, 7)[0]);
  TF_copy_u8(&contents[107], BCT_get_param_head(block_command_table->pos.block, 7)[1]);
  TF_copy_u8(&contents[108], BCT_get_param_head(block_command_table->pos.block, 7)[2]);
  TF_copy_u8(&contents[109], BCT_get_param_head(block_command_table->pos.block, 7)[3]);
  TF_copy_u8(&contents[110], BCT_get_param_head(block_command_table->pos.block, 7)[4]);
  TF_copy_u8(&contents[111], BCT_get_param_head(block_command_table->pos.block, 7)[5]);
  TF_copy_u16(&contents[112], (uint16_t)BCT_get_id(block_command_table->pos.block, 8));
  TF_copy_u32(&contents[114], (uint32_t)BCT_get_ti(block_command_table->pos.block, 8));
  TF_copy_u8(&contents[118], BCT_get_param_head(block_command_table->pos.block, 8)[0]);
  TF_copy_u8(&contents[119], BCT_get_param_head(block_command_table->pos.block, 8)[1]);
  TF_copy_u8(&contents[120], BCT_get_param_head(block_command_table->pos.block, 8)[2]);
  TF_copy_u8(&contents[121], BCT_get_param_head(block_command_table->pos.block, 8)[3]);
  TF_copy_u8(&contents[122], BCT_get_param_head(block_command_table->pos.block, 8)[4]);
  TF_copy_u8(&contents[123], BCT_get_param_head(block_command_table->pos.block, 8)[5]);
  TF_copy_u16(&contents[124], (uint16_t)BCT_get_id(block_command_table->pos.block, 9));
  TF_copy_u32(&contents[126], (uint32_t)BCT_get_ti(block_command_table->pos.block, 9));
  TF_copy_u8(&contents[130], BCT_get_param_head(block_command_table->pos.block, 9)[0]);
  TF_copy_u8(&contents[131], BCT_get_param_head(block_command_table->pos.block, 9)[1]);
  TF_copy_u8(&contents[132], BCT_get_param_head(block_command_table->pos.block, 9)[2]);
  TF_copy_u8(&contents[133], BCT_get_param_head(block_command_table->pos.block, 9)[3]);
  TF_copy_u8(&contents[134], BCT_get_param_head(block_command_table->pos.block, 9)[4]);
  TF_copy_u8(&contents[135], BCT_get_param_head(block_command_table->pos.block, 9)[5]);
  TF_copy_u16(&contents[136], (uint16_t)BCT_get_id(block_command_table->pos.block, 10));
  TF_copy_u32(&contents[138], (uint32_t)BCT_get_ti(block_command_table->pos.block, 10));
  TF_copy_u8(&contents[142], BCT_get_param_head(block_command_table->pos.block, 10)[0]);
  TF_copy_u8(&contents[143], BCT_get_param_head(block_command_table->pos.block, 10)[1]);
  TF_copy_u8(&contents[144], BCT_get_param_head(block_command_table->pos.block, 10)[2]);
  TF_copy_u8(&contents[145], BCT_get_param_head(block_command_table->pos.block, 10)[3]);
  TF_copy_u8(&contents[146], BCT_get_param_head(block_command_table->pos.block, 10)[4]);
  TF_copy_u8(&contents[147], BCT_get_param_head(block_command_table->pos.block, 10)[5]);
  TF_copy_u16(&contents[148], (uint16_t)BCT_get_id(block_command_table->pos.block, 11));
  TF_copy_u32(&contents[150], (uint32_t)BCT_get_ti(block_command_table->pos.block, 11));
  TF_copy_u8(&contents[154], BCT_get_param_head(block_command_table->pos.block, 11)[0]);
  TF_copy_u8(&contents[155], BCT_get_param_head(block_command_table->pos.block, 11)[1]);
  TF_copy_u8(&contents[156], BCT_get_param_head(block_command_table->pos.block, 11)[2]);
  TF_copy_u8(&contents[157], BCT_get_param_head(block_command_table->pos.block, 11)[3]);
  TF_copy_u8(&contents[158], BCT_get_param_head(block_command_table->pos.block, 11)[4]);
  TF_copy_u8(&contents[159], BCT_get_param_head(block_command_table->pos.block, 11)[5]);
  TF_copy_u16(&contents[160], (uint16_t)BCT_get_id(block_command_table->pos.block, 12));
  TF_copy_u32(&contents[162], (uint32_t)BCT_get_ti(block_command_table->pos.block, 12));
  TF_copy_u8(&contents[166], BCT_get_param_head(block_command_table->pos.block, 12)[0]);
  TF_copy_u8(&contents[167], BCT_get_param_head(block_command_table->pos.block, 12)[1]);
  TF_copy_u8(&contents[168], BCT_get_param_head(block_command_table->pos.block, 12)[2]);
  TF_copy_u8(&contents[169], BCT_get_param_head(block_command_table->pos.block, 12)[3]);
  TF_copy_u8(&contents[170], BCT_get_param_head(block_command_table->pos.block, 12)[4]);
  TF_copy_u8(&contents[171], BCT_get_param_head(block_command_table->pos.block, 12)[5]);
  TF_copy_u16(&contents[172], (uint16_t)BCT_get_id(block_command_table->pos.block, 13));
  TF_copy_u32(&contents[174], (uint32_t)BCT_get_ti(block_command_table->pos.block, 13));
  TF_copy_u8(&contents[178], BCT_get_param_head(block_command_table->pos.block, 13)[0]);
  TF_copy_u8(&contents[179], BCT_get_param_head(block_command_table->pos.block, 13)[1]);
  TF_copy_u8(&contents[180], BCT_get_param_head(block_command_table->pos.block, 13)[2]);
  TF_copy_u8(&contents[181], BCT_get_param_head(block_command_table->pos.block, 13)[3]);
  TF_copy_u8(&contents[182], BCT_get_param_head(block_command_table->pos.block, 13)[4]);
  TF_copy_u8(&contents[183], BCT_get_param_head(block_command_table->pos.block, 13)[5]);
  TF_copy_u16(&contents[184], (uint16_t)BCT_get_id(block_command_table->pos.block, 14));
  TF_copy_u32(&contents[186], (uint32_t)BCT_get_ti(block_command_table->pos.block, 14));
  TF_copy_u8(&contents[190], BCT_get_param_head(block_command_table->pos.block, 14)[0]);
  TF_copy_u8(&contents[191], BCT_get_param_head(block_command_table->pos.block, 14)[1]);
  TF_copy_u8(&contents[192], BCT_get_param_head(block_command_table->pos.block, 14)[2]);
  TF_copy_u8(&contents[193], BCT_get_param_head(block_command_table->pos.block, 14)[3]);
  TF_copy_u8(&contents[194], BCT_get_param_head(block_command_table->pos.block, 14)[4]);
  TF_copy_u8(&contents[195], BCT_get_param_head(block_command_table->pos.block, 14)[5]);
  TF_copy_u16(&contents[196], (uint16_t)BCT_get_id(block_command_table->pos.block, 15));
  TF_copy_u32(&contents[198], (uint32_t)BCT_get_ti(block_command_table->pos.block, 15));
  TF_copy_u8(&contents[202], BCT_get_param_head(block_command_table->pos.block, 15)[0]);
  TF_copy_u8(&contents[203], BCT_get_param_head(block_command_table->pos.block, 15)[1]);
  TF_copy_u8(&contents[204], BCT_get_param_head(block_command_table->pos.block, 15)[2]);
  TF_copy_u8(&contents[205], BCT_get_param_head(block_command_table->pos.block, 15)[3]);
  TF_copy_u8(&contents[206], BCT_get_param_head(block_command_table->pos.block, 15)[4]);
  TF_copy_u8(&contents[207], BCT_get_param_head(block_command_table->pos.block, 15)[5]);
  TF_copy_u16(&contents[208], (uint16_t)BCT_get_id(block_command_table->pos.block, 16));
  TF_copy_u32(&contents[210], (uint32_t)BCT_get_ti(block_command_table->pos.block, 16));
  TF_copy_u8(&contents[214], BCT_get_param_head(block_command_table->pos.block, 16)[0]);
  TF_copy_u8(&contents[215], BCT_get_param_head(block_command_table->pos.block, 16)[1]);
  TF_copy_u8(&contents[216], BCT_get_param_head(block_command_table->pos.block, 16)[2]);
  TF_copy_u8(&contents[217], BCT_get_param_head(block_command_table->pos.block, 16)[3]);
  TF_copy_u8(&contents[218], BCT_get_param_head(block_command_table->pos.block, 16)[4]);
  TF_copy_u8(&contents[219], BCT_get_param_head(block_command_table->pos.block, 16)[5]);
  TF_copy_u16(&contents[220], (uint16_t)BCT_get_id(block_command_table->pos.block, 17));
  TF_copy_u32(&contents[222], (uint32_t)BCT_get_ti(block_command_table->pos.block, 17));
  TF_copy_u8(&contents[226], BCT_get_param_head(block_command_table->pos.block, 17)[0]);
  TF_copy_u8(&contents[227], BCT_get_param_head(block_command_table->pos.block, 17)[1]);
  TF_copy_u8(&contents[228], BCT_get_param_head(block_command_table->pos.block, 17)[2]);
  TF_copy_u8(&contents[229], BCT_get_param_head(block_command_table->pos.block, 17)[3]);
  TF_copy_u8(&contents[230], BCT_get_param_head(block_command_table->pos.block, 17)[4]);
  TF_copy_u8(&contents[231], BCT_get_param_head(block_command_table->pos.block, 17)[5]);
  TF_copy_u16(&contents[232], (uint16_t)BCT_get_id(block_command_table->pos.block, 18));
  TF_copy_u32(&contents[234], (uint32_t)BCT_get_ti(block_command_table->pos.block, 18));
  TF_copy_u8(&contents[238], BCT_get_param_head(block_command_table->pos.block, 18)[0]);
  TF_copy_u8(&contents[239], BCT_get_param_head(block_command_table->pos.block, 18)[1]);
  TF_copy_u8(&contents[240], BCT_get_param_head(block_command_table->pos.block, 18)[2]);
  TF_copy_u8(&contents[241], BCT_get_param_head(block_command_table->pos.block, 18)[3]);
  TF_copy_u8(&contents[242], BCT_get_param_head(block_command_table->pos.block, 18)[4]);
  TF_copy_u8(&contents[243], BCT_get_param_head(block_command_table->pos.block, 18)[5]);
  TF_copy_u16(&contents[244], (uint16_t)BCT_get_id(block_command_table->pos.block, 19));
  TF_copy_u32(&contents[246], (uint32_t)BCT_get_ti(block_command_table->pos.block, 19));
  TF_copy_u8(&contents[250], BCT_get_param_head(block_command_table->pos.block, 19)[0]);
  TF_copy_u8(&contents[251], BCT_get_param_head(block_command_table->pos.block, 19)[1]);
  TF_copy_u8(&contents[252], BCT_get_param_head(block_command_table->pos.block, 19)[2]);
  TF_copy_u8(&contents[253], BCT_get_param_head(block_command_table->pos.block, 19)[3]);
  TF_copy_u8(&contents[254], BCT_get_param_head(block_command_table->pos.block, 19)[4]);
  TF_copy_u8(&contents[255], BCT_get_param_head(block_command_table->pos.block, 19)[5]);
  TF_copy_u16(&contents[256], (uint16_t)BCT_get_id(block_command_table->pos.block, 20));
  TF_copy_u32(&contents[258], (uint32_t)BCT_get_ti(block_command_table->pos.block, 20));
  TF_copy_u8(&contents[262], BCT_get_param_head(block_command_table->pos.block, 20)[0]);
  TF_copy_u8(&contents[263], BCT_get_param_head(block_command_table->pos.block, 20)[1]);
  TF_copy_u8(&contents[264], BCT_get_param_head(block_command_table->pos.block, 20)[2]);
  TF_copy_u8(&contents[265], BCT_get_param_head(block_command_table->pos.block, 20)[3]);
  TF_copy_u8(&contents[266], BCT_get_param_head(block_command_table->pos.block, 20)[4]);
  TF_copy_u8(&contents[267], BCT_get_param_head(block_command_table->pos.block, 20)[5]);
  TF_copy_u16(&contents[268], (uint16_t)BCT_get_id(block_command_table->pos.block, 21));
  TF_copy_u32(&contents[270], (uint32_t)BCT_get_ti(block_command_table->pos.block, 21));
  TF_copy_u8(&contents[274], BCT_get_param_head(block_command_table->pos.block, 21)[0]);
  TF_copy_u8(&contents[275], BCT_get_param_head(block_command_table->pos.block, 21)[1]);
  TF_copy_u8(&contents[276], BCT_get_param_head(block_command_table->pos.block, 21)[2]);
  TF_copy_u8(&contents[277], BCT_get_param_head(block_command_table->pos.block, 21)[3]);
  TF_copy_u8(&contents[278], BCT_get_param_head(block_command_table->pos.block, 21)[4]);
  TF_copy_u8(&contents[279], BCT_get_param_head(block_command_table->pos.block, 21)[5]);
  TF_copy_u16(&contents[280], (uint16_t)BCT_get_id(block_command_table->pos.block, 22));
  TF_copy_u32(&contents[282], (uint32_t)BCT_get_ti(block_command_table->pos.block, 22));
  TF_copy_u8(&contents[286], BCT_get_param_head(block_command_table->pos.block, 22)[0]);
  TF_copy_u8(&contents[287], BCT_get_param_head(block_command_table->pos.block, 22)[1]);
  TF_copy_u8(&contents[288], BCT_get_param_head(block_command_table->pos.block, 22)[2]);
  TF_copy_u8(&contents[289], BCT_get_param_head(block_command_table->pos.block, 22)[3]);
  TF_copy_u8(&contents[290], BCT_get_param_head(block_command_table->pos.block, 22)[4]);
  TF_copy_u8(&contents[291], BCT_get_param_head(block_command_table->pos.block, 22)[5]);
  TF_copy_u16(&contents[292], (uint16_t)BCT_get_id(block_command_table->pos.block, 23));
  TF_copy_u32(&contents[294], (uint32_t)BCT_get_ti(block_command_table->pos.block, 23));
  TF_copy_u8(&contents[298], BCT_get_param_head(block_command_table->pos.block, 23)[0]);
  TF_copy_u8(&contents[299], BCT_get_param_head(block_command_table->pos.block, 23)[1]);
  TF_copy_u8(&contents[300], BCT_get_param_head(block_command_table->pos.block, 23)[2]);
  TF_copy_u8(&contents[301], BCT_get_param_head(block_command_table->pos.block, 23)[3]);
  TF_copy_u8(&contents[302], BCT_get_param_head(block_command_table->pos.block, 23)[4]);
  TF_copy_u8(&contents[303], BCT_get_param_head(block_command_table->pos.block, 23)[5]);
  TF_copy_u16(&contents[304], (uint16_t)BCT_get_id(block_command_table->pos.block, 24));
  TF_copy_u32(&contents[306], (uint32_t)BCT_get_ti(block_command_table->pos.block, 24));
  TF_copy_u8(&contents[310], BCT_get_param_head(block_command_table->pos.block, 24)[0]);
  TF_copy_u8(&contents[311], BCT_get_param_head(block_command_table->pos.block, 24)[1]);
  TF_copy_u8(&contents[312], BCT_get_param_head(block_command_table->pos.block, 24)[2]);
  TF_copy_u8(&contents[313], BCT_get_param_head(block_command_table->pos.block, 24)[3]);
  TF_copy_u8(&contents[314], BCT_get_param_head(block_command_table->pos.block, 24)[4]);
  TF_copy_u8(&contents[315], BCT_get_param_head(block_command_table->pos.block, 24)[5]);
  TF_copy_u16(&contents[316], (uint16_t)BCT_get_id(block_command_table->pos.block, 25));
  TF_copy_u32(&contents[318], (uint32_t)BCT_get_ti(block_command_table->pos.block, 25));
  TF_copy_u8(&contents[322], BCT_get_param_head(block_command_table->pos.block, 25)[0]);
  TF_copy_u8(&contents[323], BCT_get_param_head(block_command_table->pos.block, 25)[1]);
  TF_copy_u8(&contents[324], BCT_get_param_head(block_command_table->pos.block, 25)[2]);
  TF_copy_u8(&contents[325], BCT_get_param_head(block_command_table->pos.block, 25)[3]);
  TF_copy_u8(&contents[326], BCT_get_param_head(block_command_table->pos.block, 25)[4]);
  TF_copy_u8(&contents[327], BCT_get_param_head(block_command_table->pos.block, 25)[5]);
  TF_copy_u16(&contents[328], (uint16_t)BCT_get_id(block_command_table->pos.block, 26));
  TF_copy_u32(&contents[330], (uint32_t)BCT_get_ti(block_command_table->pos.block, 26));
  TF_copy_u8(&contents[334], BCT_get_param_head(block_command_table->pos.block, 26)[0]);
  TF_copy_u8(&contents[335], BCT_get_param_head(block_command_table->pos.block, 26)[1]);
  TF_copy_u8(&contents[336], BCT_get_param_head(block_command_table->pos.block, 26)[2]);
  TF_copy_u8(&contents[337], BCT_get_param_head(block_command_table->pos.block, 26)[3]);
  TF_copy_u8(&contents[338], BCT_get_param_head(block_command_table->pos.block, 26)[4]);
  TF_copy_u8(&contents[339], BCT_get_param_head(block_command_table->pos.block, 26)[5]);
  TF_copy_u16(&contents[340], (uint16_t)BCT_get_id(block_command_table->pos.block, 27));
  TF_copy_u32(&contents[342], (uint32_t)BCT_get_ti(block_command_table->pos.block, 27));
  TF_copy_u8(&contents[346], BCT_get_param_head(block_command_table->pos.block, 27)[0]);
  TF_copy_u8(&contents[347], BCT_get_param_head(block_command_table->pos.block, 27)[1]);
  TF_copy_u8(&contents[348], BCT_get_param_head(block_command_table->pos.block, 27)[2]);
  TF_copy_u8(&contents[349], BCT_get_param_head(block_command_table->pos.block, 27)[3]);
  TF_copy_u8(&contents[350], BCT_get_param_head(block_command_table->pos.block, 27)[4]);
  TF_copy_u8(&contents[351], BCT_get_param_head(block_command_table->pos.block, 27)[5]);
  TF_copy_u16(&contents[352], (uint16_t)BCT_get_id(block_command_table->pos.block, 28));
  TF_copy_u32(&contents[354], (uint32_t)BCT_get_ti(block_command_table->pos.block, 28));
  TF_copy_u8(&contents[358], BCT_get_param_head(block_command_table->pos.block, 28)[0]);
  TF_copy_u8(&contents[359], BCT_get_param_head(block_command_table->pos.block, 28)[1]);
  TF_copy_u8(&contents[360], BCT_get_param_head(block_command_table->pos.block, 28)[2]);
  TF_copy_u8(&contents[361], BCT_get_param_head(block_command_table->pos.block, 28)[3]);
  TF_copy_u8(&contents[362], BCT_get_param_head(block_command_table->pos.block, 28)[4]);
  TF_copy_u8(&contents[363], BCT_get_param_head(block_command_table->pos.block, 28)[5]);
  TF_copy_u16(&contents[364], (uint16_t)BCT_get_id(block_command_table->pos.block, 29));
  TF_copy_u32(&contents[366], (uint32_t)BCT_get_ti(block_command_table->pos.block, 29));
  TF_copy_u8(&contents[370], BCT_get_param_head(block_command_table->pos.block, 29)[0]);
  TF_copy_u8(&contents[371], BCT_get_param_head(block_command_table->pos.block, 29)[1]);
  TF_copy_u8(&contents[372], BCT_get_param_head(block_command_table->pos.block, 29)[2]);
  TF_copy_u8(&contents[373], BCT_get_param_head(block_command_table->pos.block, 29)[3]);
  TF_copy_u8(&contents[374], BCT_get_param_head(block_command_table->pos.block, 29)[4]);
  TF_copy_u8(&contents[375], BCT_get_param_head(block_command_table->pos.block, 29)[5]);
  TF_copy_u16(&contents[376], (uint16_t)BCT_get_id(block_command_table->pos.block, 30));
  TF_copy_u32(&contents[378], (uint32_t)BCT_get_ti(block_command_table->pos.block, 30));
  TF_copy_u8(&contents[382], BCT_get_param_head(block_command_table->pos.block, 30)[0]);
  TF_copy_u8(&contents[383], BCT_get_param_head(block_command_table->pos.block, 30)[1]);
  TF_copy_u8(&contents[384], BCT_get_param_head(block_command_table->pos.block, 30)[2]);
  TF_copy_u8(&contents[385], BCT_get_param_head(block_command_table->pos.block, 30)[3]);
  TF_copy_u8(&contents[386], BCT_get_param_head(block_command_table->pos.block, 30)[4]);
  TF_copy_u8(&contents[387], BCT_get_param_head(block_command_table->pos.block, 30)[5]);
  TF_copy_u16(&contents[388], (uint16_t)BCT_get_id(block_command_table->pos.block, 31));
  TF_copy_u32(&contents[390], (uint32_t)BCT_get_ti(block_command_table->pos.block, 31));
  TF_copy_u8(&contents[394], BCT_get_param_head(block_command_table->pos.block, 31)[0]);
  TF_copy_u8(&contents[395], BCT_get_param_head(block_command_table->pos.block, 31)[1]);
  TF_copy_u8(&contents[396], BCT_get_param_head(block_command_table->pos.block, 31)[2]);
  TF_copy_u8(&contents[397], BCT_get_param_head(block_command_table->pos.block, 31)[3]);
  TF_copy_u8(&contents[398], BCT_get_param_head(block_command_table->pos.block, 31)[4]);
  TF_copy_u8(&contents[399], BCT_get_param_head(block_command_table->pos.block, 31)[5]);
#endif

  return 400;
}

static int Tlm_CA_(unsigned char* contents, int max_len)
{
  if (225 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(command_analyze->tlm_page_no));
  TF_copy_u32(&contents[1], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].cmd_func));
  TF_copy_u8(&contents[5], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[6], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[7], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+0].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[8], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].cmd_func));
  TF_copy_u8(&contents[12], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[13], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[14], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+1].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[15], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].cmd_func));
  TF_copy_u8(&contents[19], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[20], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[21], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+2].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[22], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].cmd_func));
  TF_copy_u8(&contents[26], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[27], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[28], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+3].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[29], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].cmd_func));
  TF_copy_u8(&contents[33], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[34], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[35], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+4].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[36], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].cmd_func));
  TF_copy_u8(&contents[40], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[41], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[42], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+5].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[43], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].cmd_func));
  TF_copy_u8(&contents[47], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[48], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[49], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+6].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[50], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].cmd_func));
  TF_copy_u8(&contents[54], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[55], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[56], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+7].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[57], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].cmd_func));
  TF_copy_u8(&contents[61], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[62], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[63], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+8].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[64], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].cmd_func));
  TF_copy_u8(&contents[68], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[69], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[70], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+9].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[71], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].cmd_func));
  TF_copy_u8(&contents[75], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[76], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[77], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+10].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[78], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].cmd_func));
  TF_copy_u8(&contents[82], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[83], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[84], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+11].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[85], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].cmd_func));
  TF_copy_u8(&contents[89], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[90], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[91], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+12].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[92], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].cmd_func));
  TF_copy_u8(&contents[96], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[97], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[98], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+13].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[99], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].cmd_func));
  TF_copy_u8(&contents[103], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[104], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[105], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+14].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[106], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].cmd_func));
  TF_copy_u8(&contents[110], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[111], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[112], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+15].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[113], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].cmd_func));
  TF_copy_u8(&contents[117], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[118], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[119], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+16].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[120], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].cmd_func));
  TF_copy_u8(&contents[124], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[125], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[126], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+17].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[127], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].cmd_func));
  TF_copy_u8(&contents[131], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[132], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[133], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+18].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[134], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].cmd_func));
  TF_copy_u8(&contents[138], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[139], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[140], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+19].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[141], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].cmd_func));
  TF_copy_u8(&contents[145], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[146], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[147], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+20].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[148], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].cmd_func));
  TF_copy_u8(&contents[152], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[153], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[154], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+21].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[155], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].cmd_func));
  TF_copy_u8(&contents[159], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[160], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[161], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+22].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[162], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].cmd_func));
  TF_copy_u8(&contents[166], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[167], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[168], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+23].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[169], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].cmd_func));
  TF_copy_u8(&contents[173], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[174], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[175], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+24].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[176], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].cmd_func));
  TF_copy_u8(&contents[180], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[181], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[182], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+25].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[183], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].cmd_func));
  TF_copy_u8(&contents[187], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[188], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[189], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+26].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[190], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].cmd_func));
  TF_copy_u8(&contents[194], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[195], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[196], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+27].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[197], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].cmd_func));
  TF_copy_u8(&contents[201], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[202], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[203], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+28].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[204], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].cmd_func));
  TF_copy_u8(&contents[208], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[209], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[210], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+29].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[211], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].cmd_func));
  TF_copy_u8(&contents[215], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[216], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[217], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+30].param_size_infos[2].packed_info.bit.second & 0x0f)));
  TF_copy_u32(&contents[218], (uint32_t)(command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].cmd_func));
  TF_copy_u8(&contents[222], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[0].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[0].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[223], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[1].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[1].packed_info.bit.second & 0x0f)));
  TF_copy_u8(&contents[224], (uint8_t)(((command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[2].packed_info.bit.first & 0x0f) << 4) | (command_analyze->cmd_table[CA_TLM_PAGE_SIZE*(command_analyze->tlm_page_no)+31].param_size_infos[2].packed_info.bit.second & 0x0f)));
#endif

  return 225;
}

static int Tlm_TF_(unsigned char* contents, int max_len)
{
  if (257 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(telemetry_frame->tlm_page_no));
  TF_copy_u32(&contents[1], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+0].tlm_func));
  TF_copy_u32(&contents[5], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+1].tlm_func));
  TF_copy_u32(&contents[9], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+2].tlm_func));
  TF_copy_u32(&contents[13], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+3].tlm_func));
  TF_copy_u32(&contents[17], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+4].tlm_func));
  TF_copy_u32(&contents[21], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+5].tlm_func));
  TF_copy_u32(&contents[25], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+6].tlm_func));
  TF_copy_u32(&contents[29], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+7].tlm_func));
  TF_copy_u32(&contents[33], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+8].tlm_func));
  TF_copy_u32(&contents[37], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+9].tlm_func));
  TF_copy_u32(&contents[41], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+10].tlm_func));
  TF_copy_u32(&contents[45], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+11].tlm_func));
  TF_copy_u32(&contents[49], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+12].tlm_func));
  TF_copy_u32(&contents[53], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+13].tlm_func));
  TF_copy_u32(&contents[57], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+14].tlm_func));
  TF_copy_u32(&contents[61], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+15].tlm_func));
  TF_copy_u32(&contents[65], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+16].tlm_func));
  TF_copy_u32(&contents[69], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+17].tlm_func));
  TF_copy_u32(&contents[73], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+18].tlm_func));
  TF_copy_u32(&contents[77], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+19].tlm_func));
  TF_copy_u32(&contents[81], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+20].tlm_func));
  TF_copy_u32(&contents[85], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+21].tlm_func));
  TF_copy_u32(&contents[89], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+22].tlm_func));
  TF_copy_u32(&contents[93], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+23].tlm_func));
  TF_copy_u32(&contents[97], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+24].tlm_func));
  TF_copy_u32(&contents[101], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+25].tlm_func));
  TF_copy_u32(&contents[105], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+26].tlm_func));
  TF_copy_u32(&contents[109], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+27].tlm_func));
  TF_copy_u32(&contents[113], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+28].tlm_func));
  TF_copy_u32(&contents[117], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+29].tlm_func));
  TF_copy_u32(&contents[121], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+30].tlm_func));
  TF_copy_u32(&contents[125], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+31].tlm_func));
  TF_copy_u32(&contents[129], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+32].tlm_func));
  TF_copy_u32(&contents[133], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+33].tlm_func));
  TF_copy_u32(&contents[137], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+34].tlm_func));
  TF_copy_u32(&contents[141], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+35].tlm_func));
  TF_copy_u32(&contents[145], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+36].tlm_func));
  TF_copy_u32(&contents[149], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+37].tlm_func));
  TF_copy_u32(&contents[153], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+38].tlm_func));
  TF_copy_u32(&contents[157], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+39].tlm_func));
  TF_copy_u32(&contents[161], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+40].tlm_func));
  TF_copy_u32(&contents[165], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+41].tlm_func));
  TF_copy_u32(&contents[169], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+42].tlm_func));
  TF_copy_u32(&contents[173], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+43].tlm_func));
  TF_copy_u32(&contents[177], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+44].tlm_func));
  TF_copy_u32(&contents[181], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+45].tlm_func));
  TF_copy_u32(&contents[185], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+46].tlm_func));
  TF_copy_u32(&contents[189], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+47].tlm_func));
  TF_copy_u32(&contents[193], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+48].tlm_func));
  TF_copy_u32(&contents[197], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+49].tlm_func));
  TF_copy_u32(&contents[201], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+50].tlm_func));
  TF_copy_u32(&contents[205], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+51].tlm_func));
  TF_copy_u32(&contents[209], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+52].tlm_func));
  TF_copy_u32(&contents[213], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+53].tlm_func));
  TF_copy_u32(&contents[217], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+54].tlm_func));
  TF_copy_u32(&contents[221], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+55].tlm_func));
  TF_copy_u32(&contents[225], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+56].tlm_func));
  TF_copy_u32(&contents[229], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+57].tlm_func));
  TF_copy_u32(&contents[233], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+58].tlm_func));
  TF_copy_u32(&contents[237], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+59].tlm_func));
  TF_copy_u32(&contents[241], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+60].tlm_func));
  TF_copy_u32(&contents[245], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+61].tlm_func));
  TF_copy_u32(&contents[249], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+62].tlm_func));
  TF_copy_u32(&contents[253], (uint32_t)(telemetry_frame->tlm_table[TF_TLM_PAGE_SIZE*(telemetry_frame->tlm_page_no)+63].tlm_func));
#endif

  return 257;
}

static int Tlm_DCU_(unsigned char* contents, int max_len)
{
  if (176 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], divided_cmd_utility->exec_log_order[0]);
  TF_copy_u8(&contents[1], divided_cmd_utility->exec_log_order[1]);
  TF_copy_u8(&contents[2], divided_cmd_utility->exec_log_order[2]);
  TF_copy_u8(&contents[3], divided_cmd_utility->exec_log_order[3]);
  TF_copy_u8(&contents[4], divided_cmd_utility->exec_log_order[4]);
  TF_copy_u8(&contents[5], divided_cmd_utility->exec_log_order[5]);
  TF_copy_u8(&contents[6], divided_cmd_utility->exec_log_order[6]);
  TF_copy_u8(&contents[7], divided_cmd_utility->exec_log_order[7]);
  TF_copy_u8(&contents[8], divided_cmd_utility->exec_log_order[8]);
  TF_copy_u8(&contents[9], divided_cmd_utility->exec_log_order[9]);
  TF_copy_u8(&contents[10], divided_cmd_utility->exec_log_order[10]);
  TF_copy_u8(&contents[11], divided_cmd_utility->exec_log_order[11]);
  TF_copy_u8(&contents[12], divided_cmd_utility->exec_log_order[12]);
  TF_copy_u8(&contents[13], divided_cmd_utility->exec_log_order[13]);
  TF_copy_u8(&contents[14], divided_cmd_utility->exec_log_order[14]);
  TF_copy_u8(&contents[15], divided_cmd_utility->exec_log_order[15]);
  TF_copy_u16(&contents[16], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].cmd_code));
  TF_copy_u8(&contents[18], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].status));
  TF_copy_u16(&contents[19], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].exec_counter));
  TF_copy_i8(&contents[21], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].last_exec_sts));
  TF_copy_u32(&contents[22], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[26], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].cmd_code));
  TF_copy_u8(&contents[28], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].status));
  TF_copy_u16(&contents[29], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].exec_counter));
  TF_copy_i8(&contents[31], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].last_exec_sts));
  TF_copy_u32(&contents[32], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[36], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[2]].cmd_code));
  TF_copy_u8(&contents[38], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[2]].status));
  TF_copy_u16(&contents[39], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[2]].exec_counter));
  TF_copy_i8(&contents[41], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[2]].last_exec_sts));
  TF_copy_u32(&contents[42], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[2]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[46], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[3]].cmd_code));
  TF_copy_u8(&contents[48], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[3]].status));
  TF_copy_u16(&contents[49], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[3]].exec_counter));
  TF_copy_i8(&contents[51], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[3]].last_exec_sts));
  TF_copy_u32(&contents[52], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[3]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[56], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[4]].cmd_code));
  TF_copy_u8(&contents[58], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[4]].status));
  TF_copy_u16(&contents[59], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[4]].exec_counter));
  TF_copy_i8(&contents[61], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[4]].last_exec_sts));
  TF_copy_u32(&contents[62], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[4]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[66], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[5]].cmd_code));
  TF_copy_u8(&contents[68], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[5]].status));
  TF_copy_u16(&contents[69], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[5]].exec_counter));
  TF_copy_i8(&contents[71], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[5]].last_exec_sts));
  TF_copy_u32(&contents[72], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[5]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[76], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[6]].cmd_code));
  TF_copy_u8(&contents[78], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[6]].status));
  TF_copy_u16(&contents[79], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[6]].exec_counter));
  TF_copy_i8(&contents[81], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[6]].last_exec_sts));
  TF_copy_u32(&contents[82], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[6]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[86], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[7]].cmd_code));
  TF_copy_u8(&contents[88], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[7]].status));
  TF_copy_u16(&contents[89], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[7]].exec_counter));
  TF_copy_i8(&contents[91], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[7]].last_exec_sts));
  TF_copy_u32(&contents[92], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[7]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[96], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[8]].cmd_code));
  TF_copy_u8(&contents[98], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[8]].status));
  TF_copy_u16(&contents[99], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[8]].exec_counter));
  TF_copy_i8(&contents[101], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[8]].last_exec_sts));
  TF_copy_u32(&contents[102], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[8]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[106], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[9]].cmd_code));
  TF_copy_u8(&contents[108], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[9]].status));
  TF_copy_u16(&contents[109], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[9]].exec_counter));
  TF_copy_i8(&contents[111], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[9]].last_exec_sts));
  TF_copy_u32(&contents[112], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[9]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[116], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[10]].cmd_code));
  TF_copy_u8(&contents[118], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[10]].status));
  TF_copy_u16(&contents[119], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[10]].exec_counter));
  TF_copy_i8(&contents[121], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[10]].last_exec_sts));
  TF_copy_u32(&contents[122], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[10]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[126], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[11]].cmd_code));
  TF_copy_u8(&contents[128], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[11]].status));
  TF_copy_u16(&contents[129], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[11]].exec_counter));
  TF_copy_i8(&contents[131], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[11]].last_exec_sts));
  TF_copy_u32(&contents[132], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[11]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[136], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[12]].cmd_code));
  TF_copy_u8(&contents[138], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[12]].status));
  TF_copy_u16(&contents[139], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[12]].exec_counter));
  TF_copy_i8(&contents[141], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[12]].last_exec_sts));
  TF_copy_u32(&contents[142], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[12]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[146], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[13]].cmd_code));
  TF_copy_u8(&contents[148], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[13]].status));
  TF_copy_u16(&contents[149], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[13]].exec_counter));
  TF_copy_i8(&contents[151], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[13]].last_exec_sts));
  TF_copy_u32(&contents[152], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[13]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[156], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[14]].cmd_code));
  TF_copy_u8(&contents[158], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[14]].status));
  TF_copy_u16(&contents[159], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[14]].exec_counter));
  TF_copy_i8(&contents[161], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[14]].last_exec_sts));
  TF_copy_u32(&contents[162], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[14]].last_exec_time.total_cycle));
  TF_copy_u16(&contents[166], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[15]].cmd_code));
  TF_copy_u8(&contents[168], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[15]].status));
  TF_copy_u16(&contents[169], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[15]].exec_counter));
  TF_copy_i8(&contents[171], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[15]].last_exec_sts));
  TF_copy_u32(&contents[172], (uint32_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[15]].last_exec_time.total_cycle));
#endif

  return 176;
}

static int Tlm_MM_(unsigned char* contents, int max_len)
{
  if (398 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(mode_manager->current_id));
  TF_copy_u8(&contents[1], (uint8_t)(mode_manager->previous_id));
  TF_copy_u8(&contents[2], (uint8_t)(mode_manager->stat));
  TF_copy_u8(&contents[3], (uint8_t)(mode_manager->mm_ack));
  TF_copy_u16(&contents[4], (uint16_t)(mode_manager->mode_list[0]));
  TF_copy_u16(&contents[6], (uint16_t)(mode_manager->mode_list[1]));
  TF_copy_u16(&contents[8], (uint16_t)(mode_manager->mode_list[2]));
  TF_copy_u16(&contents[10], (uint16_t)(mode_manager->mode_list[3]));
  TF_copy_u16(&contents[12], (uint16_t)(mode_manager->mode_list[4]));
  TF_copy_u16(&contents[14], (uint16_t)(mode_manager->mode_list[5]));
  TF_copy_u16(&contents[16], (uint16_t)(mode_manager->mode_list[6]));
  TF_copy_u16(&contents[18], (uint16_t)(mode_manager->mode_list[7]));
  TF_copy_u16(&contents[20], (uint16_t)(mode_manager->mode_list[8]));
  TF_copy_u16(&contents[22], (uint16_t)(mode_manager->mode_list[9]));
  TF_copy_u16(&contents[24], (uint16_t)(mode_manager->mode_list[10]));
  TF_copy_u16(&contents[26], (uint16_t)(mode_manager->mode_list[11]));
  TF_copy_u16(&contents[28], (uint16_t)(mode_manager->mode_list[12]));
  TF_copy_u16(&contents[30], (uint16_t)(mode_manager->mode_list[13]));
  TF_copy_u16(&contents[32], (uint16_t)(mode_manager->mode_list[14]));
  TF_copy_u16(&contents[34], (uint16_t)(mode_manager->mode_list[15]));
  TF_copy_u16(&contents[36], MM_update_transition_table_for_tlm());
  TF_copy_u8(&contents[38], mode_manager->transition_table_for_tlm[0].from);
  TF_copy_u8(&contents[39], mode_manager->transition_table_for_tlm[0].to);
  TF_copy_u16(&contents[40], (uint16_t)(mode_manager->transition_table_for_tlm[0].bc_index));
  TF_copy_u8(&contents[42], mode_manager->transition_table_for_tlm[1].from);
  TF_copy_u8(&contents[43], mode_manager->transition_table_for_tlm[1].to);
  TF_copy_u16(&contents[44], (uint16_t)(mode_manager->transition_table_for_tlm[1].bc_index));
  TF_copy_u8(&contents[46], mode_manager->transition_table_for_tlm[2].from);
  TF_copy_u8(&contents[47], mode_manager->transition_table_for_tlm[2].to);
  TF_copy_u16(&contents[48], (uint16_t)(mode_manager->transition_table_for_tlm[2].bc_index));
  TF_copy_u8(&contents[50], mode_manager->transition_table_for_tlm[3].from);
  TF_copy_u8(&contents[51], mode_manager->transition_table_for_tlm[3].to);
  TF_copy_u16(&contents[52], (uint16_t)(mode_manager->transition_table_for_tlm[3].bc_index));
  TF_copy_u8(&contents[54], mode_manager->transition_table_for_tlm[4].from);
  TF_copy_u8(&contents[55], mode_manager->transition_table_for_tlm[4].to);
  TF_copy_u16(&contents[56], (uint16_t)(mode_manager->transition_table_for_tlm[4].bc_index));
  TF_copy_u8(&contents[58], mode_manager->transition_table_for_tlm[5].from);
  TF_copy_u8(&contents[59], mode_manager->transition_table_for_tlm[5].to);
  TF_copy_u16(&contents[60], (uint16_t)(mode_manager->transition_table_for_tlm[5].bc_index));
  TF_copy_u8(&contents[62], mode_manager->transition_table_for_tlm[6].from);
  TF_copy_u8(&contents[63], mode_manager->transition_table_for_tlm[6].to);
  TF_copy_u16(&contents[64], (uint16_t)(mode_manager->transition_table_for_tlm[6].bc_index));
  TF_copy_u8(&contents[66], mode_manager->transition_table_for_tlm[7].from);
  TF_copy_u8(&contents[67], mode_manager->transition_table_for_tlm[7].to);
  TF_copy_u16(&contents[68], (uint16_t)(mode_manager->transition_table_for_tlm[7].bc_index));
  TF_copy_u8(&contents[70], mode_manager->transition_table_for_tlm[8].from);
  TF_copy_u8(&contents[71], mode_manager->transition_table_for_tlm[8].to);
  TF_copy_u16(&contents[72], (uint16_t)(mode_manager->transition_table_for_tlm[8].bc_index));
  TF_copy_u8(&contents[74], mode_manager->transition_table_for_tlm[9].from);
  TF_copy_u8(&contents[75], mode_manager->transition_table_for_tlm[9].to);
  TF_copy_u16(&contents[76], (uint16_t)(mode_manager->transition_table_for_tlm[9].bc_index));
  TF_copy_u8(&contents[78], mode_manager->transition_table_for_tlm[10].from);
  TF_copy_u8(&contents[79], mode_manager->transition_table_for_tlm[10].to);
  TF_copy_u16(&contents[80], (uint16_t)(mode_manager->transition_table_for_tlm[10].bc_index));
  TF_copy_u8(&contents[82], mode_manager->transition_table_for_tlm[11].from);
  TF_copy_u8(&contents[83], mode_manager->transition_table_for_tlm[11].to);
  TF_copy_u16(&contents[84], (uint16_t)(mode_manager->transition_table_for_tlm[11].bc_index));
  TF_copy_u8(&contents[86], mode_manager->transition_table_for_tlm[12].from);
  TF_copy_u8(&contents[87], mode_manager->transition_table_for_tlm[12].to);
  TF_copy_u16(&contents[88], (uint16_t)(mode_manager->transition_table_for_tlm[12].bc_index));
  TF_copy_u8(&contents[90], mode_manager->transition_table_for_tlm[13].from);
  TF_copy_u8(&contents[91], mode_manager->transition_table_for_tlm[13].to);
  TF_copy_u16(&contents[92], (uint16_t)(mode_manager->transition_table_for_tlm[13].bc_index));
  TF_copy_u8(&contents[94], mode_manager->transition_table_for_tlm[14].from);
  TF_copy_u8(&contents[95], mode_manager->transition_table_for_tlm[14].to);
  TF_copy_u16(&contents[96], (uint16_t)(mode_manager->transition_table_for_tlm[14].bc_index));
  TF_copy_u8(&contents[98], mode_manager->transition_table_for_tlm[15].from);
  TF_copy_u8(&contents[99], mode_manager->transition_table_for_tlm[15].to);
  TF_copy_u16(&contents[100], (uint16_t)(mode_manager->transition_table_for_tlm[15].bc_index));
  TF_copy_u8(&contents[102], mode_manager->transition_table_for_tlm[16].from);
  TF_copy_u8(&contents[103], mode_manager->transition_table_for_tlm[16].to);
  TF_copy_u16(&contents[104], (uint16_t)(mode_manager->transition_table_for_tlm[16].bc_index));
  TF_copy_u8(&contents[106], mode_manager->transition_table_for_tlm[17].from);
  TF_copy_u8(&contents[107], mode_manager->transition_table_for_tlm[17].to);
  TF_copy_u16(&contents[108], (uint16_t)(mode_manager->transition_table_for_tlm[17].bc_index));
  TF_copy_u8(&contents[110], mode_manager->transition_table_for_tlm[18].from);
  TF_copy_u8(&contents[111], mode_manager->transition_table_for_tlm[18].to);
  TF_copy_u16(&contents[112], (uint16_t)(mode_manager->transition_table_for_tlm[18].bc_index));
  TF_copy_u8(&contents[114], mode_manager->transition_table_for_tlm[19].from);
  TF_copy_u8(&contents[115], mode_manager->transition_table_for_tlm[19].to);
  TF_copy_u16(&contents[116], (uint16_t)(mode_manager->transition_table_for_tlm[19].bc_index));
  TF_copy_u8(&contents[118], mode_manager->transition_table_for_tlm[20].from);
  TF_copy_u8(&contents[119], mode_manager->transition_table_for_tlm[20].to);
  TF_copy_u16(&contents[120], (uint16_t)(mode_manager->transition_table_for_tlm[20].bc_index));
  TF_copy_u8(&contents[122], mode_manager->transition_table_for_tlm[21].from);
  TF_copy_u8(&contents[123], mode_manager->transition_table_for_tlm[21].to);
  TF_copy_u16(&contents[124], (uint16_t)(mode_manager->transition_table_for_tlm[21].bc_index));
  TF_copy_u8(&contents[126], mode_manager->transition_table_for_tlm[22].from);
  TF_copy_u8(&contents[127], mode_manager->transition_table_for_tlm[22].to);
  TF_copy_u16(&contents[128], (uint16_t)(mode_manager->transition_table_for_tlm[22].bc_index));
  TF_copy_u8(&contents[130], mode_manager->transition_table_for_tlm[23].from);
  TF_copy_u8(&contents[131], mode_manager->transition_table_for_tlm[23].to);
  TF_copy_u16(&contents[132], (uint16_t)(mode_manager->transition_table_for_tlm[23].bc_index));
  TF_copy_u8(&contents[134], mode_manager->transition_table_for_tlm[24].from);
  TF_copy_u8(&contents[135], mode_manager->transition_table_for_tlm[24].to);
  TF_copy_u16(&contents[136], (uint16_t)(mode_manager->transition_table_for_tlm[24].bc_index));
  TF_copy_u8(&contents[138], mode_manager->transition_table_for_tlm[25].from);
  TF_copy_u8(&contents[139], mode_manager->transition_table_for_tlm[25].to);
  TF_copy_u16(&contents[140], (uint16_t)(mode_manager->transition_table_for_tlm[25].bc_index));
  TF_copy_u8(&contents[142], mode_manager->transition_table_for_tlm[26].from);
  TF_copy_u8(&contents[143], mode_manager->transition_table_for_tlm[26].to);
  TF_copy_u16(&contents[144], (uint16_t)(mode_manager->transition_table_for_tlm[26].bc_index));
  TF_copy_u8(&contents[146], mode_manager->transition_table_for_tlm[27].from);
  TF_copy_u8(&contents[147], mode_manager->transition_table_for_tlm[27].to);
  TF_copy_u16(&contents[148], (uint16_t)(mode_manager->transition_table_for_tlm[27].bc_index));
  TF_copy_u8(&contents[150], mode_manager->transition_table_for_tlm[28].from);
  TF_copy_u8(&contents[151], mode_manager->transition_table_for_tlm[28].to);
  TF_copy_u16(&contents[152], (uint16_t)(mode_manager->transition_table_for_tlm[28].bc_index));
  TF_copy_u8(&contents[154], mode_manager->transition_table_for_tlm[29].from);
  TF_copy_u8(&contents[155], mode_manager->transition_table_for_tlm[29].to);
  TF_copy_u16(&contents[156], (uint16_t)(mode_manager->transition_table_for_tlm[29].bc_index));
  TF_copy_u8(&contents[158], mode_manager->transition_table_for_tlm[30].from);
  TF_copy_u8(&contents[159], mode_manager->transition_table_for_tlm[30].to);
  TF_copy_u16(&contents[160], (uint16_t)(mode_manager->transition_table_for_tlm[30].bc_index));
  TF_copy_u8(&contents[162], mode_manager->transition_table_for_tlm[31].from);
  TF_copy_u8(&contents[163], mode_manager->transition_table_for_tlm[31].to);
  TF_copy_u16(&contents[164], (uint16_t)(mode_manager->transition_table_for_tlm[31].bc_index));
  TF_copy_u8(&contents[166], mode_manager->transition_table_for_tlm[32].from);
  TF_copy_u8(&contents[167], mode_manager->transition_table_for_tlm[32].to);
  TF_copy_u16(&contents[168], (uint16_t)(mode_manager->transition_table_for_tlm[32].bc_index));
  TF_copy_u8(&contents[170], mode_manager->transition_table_for_tlm[33].from);
  TF_copy_u8(&contents[171], mode_manager->transition_table_for_tlm[33].to);
  TF_copy_u16(&contents[172], (uint16_t)(mode_manager->transition_table_for_tlm[33].bc_index));
  TF_copy_u8(&contents[174], mode_manager->transition_table_for_tlm[34].from);
  TF_copy_u8(&contents[175], mode_manager->transition_table_for_tlm[34].to);
  TF_copy_u16(&contents[176], (uint16_t)(mode_manager->transition_table_for_tlm[34].bc_index));
  TF_copy_u8(&contents[178], mode_manager->transition_table_for_tlm[35].from);
  TF_copy_u8(&contents[179], mode_manager->transition_table_for_tlm[35].to);
  TF_copy_u16(&contents[180], (uint16_t)(mode_manager->transition_table_for_tlm[35].bc_index));
  TF_copy_u8(&contents[182], mode_manager->transition_table_for_tlm[36].from);
  TF_copy_u8(&contents[183], mode_manager->transition_table_for_tlm[36].to);
  TF_copy_u16(&contents[184], (uint16_t)(mode_manager->transition_table_for_tlm[36].bc_index));
  TF_copy_u8(&contents[186], mode_manager->transition_table_for_tlm[37].from);
  TF_copy_u8(&contents[187], mode_manager->transition_table_for_tlm[37].to);
  TF_copy_u16(&contents[188], (uint16_t)(mode_manager->transition_table_for_tlm[37].bc_index));
  TF_copy_u8(&contents[190], mode_manager->transition_table_for_tlm[38].from);
  TF_copy_u8(&contents[191], mode_manager->transition_table_for_tlm[38].to);
  TF_copy_u16(&contents[192], (uint16_t)(mode_manager->transition_table_for_tlm[38].bc_index));
  TF_copy_u8(&contents[194], mode_manager->transition_table_for_tlm[39].from);
  TF_copy_u8(&contents[195], mode_manager->transition_table_for_tlm[39].to);
  TF_copy_u16(&contents[196], (uint16_t)(mode_manager->transition_table_for_tlm[39].bc_index));
  TF_copy_u8(&contents[198], mode_manager->transition_table_for_tlm[40].from);
  TF_copy_u8(&contents[199], mode_manager->transition_table_for_tlm[40].to);
  TF_copy_u16(&contents[200], (uint16_t)(mode_manager->transition_table_for_tlm[40].bc_index));
  TF_copy_u8(&contents[202], mode_manager->transition_table_for_tlm[41].from);
  TF_copy_u8(&contents[203], mode_manager->transition_table_for_tlm[41].to);
  TF_copy_u16(&contents[204], (uint16_t)(mode_manager->transition_table_for_tlm[41].bc_index));
  TF_copy_u8(&contents[206], mode_manager->transition_table_for_tlm[42].from);
  TF_copy_u8(&contents[207], mode_manager->transition_table_for_tlm[42].to);
  TF_copy_u16(&contents[208], (uint16_t)(mode_manager->transition_table_for_tlm[42].bc_index));
  TF_copy_u8(&contents[210], mode_manager->transition_table_for_tlm[43].from);
  TF_copy_u8(&contents[211], mode_manager->transition_table_for_tlm[43].to);
  TF_copy_u16(&contents[212], (uint16_t)(mode_manager->transition_table_for_tlm[43].bc_index));
  TF_copy_u8(&contents[214], mode_manager->transition_table_for_tlm[44].from);
  TF_copy_u8(&contents[215], mode_manager->transition_table_for_tlm[44].to);
  TF_copy_u16(&contents[216], (uint16_t)(mode_manager->transition_table_for_tlm[44].bc_index));
  TF_copy_u8(&contents[218], mode_manager->transition_table_for_tlm[45].from);
  TF_copy_u8(&contents[219], mode_manager->transition_table_for_tlm[45].to);
  TF_copy_u16(&contents[220], (uint16_t)(mode_manager->transition_table_for_tlm[45].bc_index));
  TF_copy_u8(&contents[222], mode_manager->transition_table_for_tlm[46].from);
  TF_copy_u8(&contents[223], mode_manager->transition_table_for_tlm[46].to);
  TF_copy_u16(&contents[224], (uint16_t)(mode_manager->transition_table_for_tlm[46].bc_index));
  TF_copy_u8(&contents[226], mode_manager->transition_table_for_tlm[47].from);
  TF_copy_u8(&contents[227], mode_manager->transition_table_for_tlm[47].to);
  TF_copy_u16(&contents[228], (uint16_t)(mode_manager->transition_table_for_tlm[47].bc_index));
  TF_copy_u8(&contents[230], mode_manager->transition_table_for_tlm[48].from);
  TF_copy_u8(&contents[231], mode_manager->transition_table_for_tlm[48].to);
  TF_copy_u16(&contents[232], (uint16_t)(mode_manager->transition_table_for_tlm[48].bc_index));
  TF_copy_u8(&contents[234], mode_manager->transition_table_for_tlm[49].from);
  TF_copy_u8(&contents[235], mode_manager->transition_table_for_tlm[49].to);
  TF_copy_u16(&contents[236], (uint16_t)(mode_manager->transition_table_for_tlm[49].bc_index));
  TF_copy_u8(&contents[238], mode_manager->transition_table_for_tlm[50].from);
  TF_copy_u8(&contents[239], mode_manager->transition_table_for_tlm[50].to);
  TF_copy_u16(&contents[240], (uint16_t)(mode_manager->transition_table_for_tlm[50].bc_index));
  TF_copy_u8(&contents[242], mode_manager->transition_table_for_tlm[51].from);
  TF_copy_u8(&contents[243], mode_manager->transition_table_for_tlm[51].to);
  TF_copy_u16(&contents[244], (uint16_t)(mode_manager->transition_table_for_tlm[51].bc_index));
  TF_copy_u8(&contents[246], mode_manager->transition_table_for_tlm[52].from);
  TF_copy_u8(&contents[247], mode_manager->transition_table_for_tlm[52].to);
  TF_copy_u16(&contents[248], (uint16_t)(mode_manager->transition_table_for_tlm[52].bc_index));
  TF_copy_u8(&contents[250], mode_manager->transition_table_for_tlm[53].from);
  TF_copy_u8(&contents[251], mode_manager->transition_table_for_tlm[53].to);
  TF_copy_u16(&contents[252], (uint16_t)(mode_manager->transition_table_for_tlm[53].bc_index));
  TF_copy_u8(&contents[254], mode_manager->transition_table_for_tlm[54].from);
  TF_copy_u8(&contents[255], mode_manager->transition_table_for_tlm[54].to);
  TF_copy_u16(&contents[256], (uint16_t)(mode_manager->transition_table_for_tlm[54].bc_index));
  TF_copy_u8(&contents[258], mode_manager->transition_table_for_tlm[55].from);
  TF_copy_u8(&contents[259], mode_manager->transition_table_for_tlm[55].to);
  TF_copy_u16(&contents[260], (uint16_t)(mode_manager->transition_table_for_tlm[55].bc_index));
  TF_copy_u8(&contents[262], mode_manager->transition_table_for_tlm[56].from);
  TF_copy_u8(&contents[263], mode_manager->transition_table_for_tlm[56].to);
  TF_copy_u16(&contents[264], (uint16_t)(mode_manager->transition_table_for_tlm[56].bc_index));
  TF_copy_u8(&contents[266], mode_manager->transition_table_for_tlm[57].from);
  TF_copy_u8(&contents[267], mode_manager->transition_table_for_tlm[57].to);
  TF_copy_u16(&contents[268], (uint16_t)(mode_manager->transition_table_for_tlm[57].bc_index));
  TF_copy_u8(&contents[270], mode_manager->transition_table_for_tlm[58].from);
  TF_copy_u8(&contents[271], mode_manager->transition_table_for_tlm[58].to);
  TF_copy_u16(&contents[272], (uint16_t)(mode_manager->transition_table_for_tlm[58].bc_index));
  TF_copy_u8(&contents[274], mode_manager->transition_table_for_tlm[59].from);
  TF_copy_u8(&contents[275], mode_manager->transition_table_for_tlm[59].to);
  TF_copy_u16(&contents[276], (uint16_t)(mode_manager->transition_table_for_tlm[59].bc_index));
  TF_copy_u8(&contents[278], mode_manager->transition_table_for_tlm[60].from);
  TF_copy_u8(&contents[279], mode_manager->transition_table_for_tlm[60].to);
  TF_copy_u16(&contents[280], (uint16_t)(mode_manager->transition_table_for_tlm[60].bc_index));
  TF_copy_u8(&contents[282], mode_manager->transition_table_for_tlm[61].from);
  TF_copy_u8(&contents[283], mode_manager->transition_table_for_tlm[61].to);
  TF_copy_u16(&contents[284], (uint16_t)(mode_manager->transition_table_for_tlm[61].bc_index));
  TF_copy_u8(&contents[286], mode_manager->transition_table_for_tlm[62].from);
  TF_copy_u8(&contents[287], mode_manager->transition_table_for_tlm[62].to);
  TF_copy_u16(&contents[288], (uint16_t)(mode_manager->transition_table_for_tlm[62].bc_index));
  TF_copy_u8(&contents[290], mode_manager->transition_table_for_tlm[63].from);
  TF_copy_u8(&contents[291], mode_manager->transition_table_for_tlm[63].to);
  TF_copy_u16(&contents[292], (uint16_t)(mode_manager->transition_table_for_tlm[63].bc_index));
  TF_copy_u8(&contents[294], mode_manager->transition_table_for_tlm[64].from);
  TF_copy_u8(&contents[295], mode_manager->transition_table_for_tlm[64].to);
  TF_copy_u16(&contents[296], (uint16_t)(mode_manager->transition_table_for_tlm[64].bc_index));
  TF_copy_u8(&contents[298], mode_manager->transition_table_for_tlm[65].from);
  TF_copy_u8(&contents[299], mode_manager->transition_table_for_tlm[65].to);
  TF_copy_u16(&contents[300], (uint16_t)(mode_manager->transition_table_for_tlm[65].bc_index));
  TF_copy_u8(&contents[302], mode_manager->transition_table_for_tlm[66].from);
  TF_copy_u8(&contents[303], mode_manager->transition_table_for_tlm[66].to);
  TF_copy_u16(&contents[304], (uint16_t)(mode_manager->transition_table_for_tlm[66].bc_index));
  TF_copy_u8(&contents[306], mode_manager->transition_table_for_tlm[67].from);
  TF_copy_u8(&contents[307], mode_manager->transition_table_for_tlm[67].to);
  TF_copy_u16(&contents[308], (uint16_t)(mode_manager->transition_table_for_tlm[67].bc_index));
  TF_copy_u8(&contents[310], mode_manager->transition_table_for_tlm[68].from);
  TF_copy_u8(&contents[311], mode_manager->transition_table_for_tlm[68].to);
  TF_copy_u16(&contents[312], (uint16_t)(mode_manager->transition_table_for_tlm[68].bc_index));
  TF_copy_u8(&contents[314], mode_manager->transition_table_for_tlm[69].from);
  TF_copy_u8(&contents[315], mode_manager->transition_table_for_tlm[69].to);
  TF_copy_u16(&contents[316], (uint16_t)(mode_manager->transition_table_for_tlm[69].bc_index));
  TF_copy_u8(&contents[318], mode_manager->transition_table_for_tlm[70].from);
  TF_copy_u8(&contents[319], mode_manager->transition_table_for_tlm[70].to);
  TF_copy_u16(&contents[320], (uint16_t)(mode_manager->transition_table_for_tlm[70].bc_index));
  TF_copy_u8(&contents[322], mode_manager->transition_table_for_tlm[71].from);
  TF_copy_u8(&contents[323], mode_manager->transition_table_for_tlm[71].to);
  TF_copy_u16(&contents[324], (uint16_t)(mode_manager->transition_table_for_tlm[71].bc_index));
  TF_copy_u8(&contents[326], mode_manager->transition_table_for_tlm[72].from);
  TF_copy_u8(&contents[327], mode_manager->transition_table_for_tlm[72].to);
  TF_copy_u16(&contents[328], (uint16_t)(mode_manager->transition_table_for_tlm[72].bc_index));
  TF_copy_u8(&contents[330], mode_manager->transition_table_for_tlm[73].from);
  TF_copy_u8(&contents[331], mode_manager->transition_table_for_tlm[73].to);
  TF_copy_u16(&contents[332], (uint16_t)(mode_manager->transition_table_for_tlm[73].bc_index));
  TF_copy_u8(&contents[334], mode_manager->transition_table_for_tlm[74].from);
  TF_copy_u8(&contents[335], mode_manager->transition_table_for_tlm[74].to);
  TF_copy_u16(&contents[336], (uint16_t)(mode_manager->transition_table_for_tlm[74].bc_index));
  TF_copy_u8(&contents[338], mode_manager->transition_table_for_tlm[75].from);
  TF_copy_u8(&contents[339], mode_manager->transition_table_for_tlm[75].to);
  TF_copy_u16(&contents[340], (uint16_t)(mode_manager->transition_table_for_tlm[75].bc_index));
  TF_copy_u8(&contents[342], mode_manager->transition_table_for_tlm[76].from);
  TF_copy_u8(&contents[343], mode_manager->transition_table_for_tlm[76].to);
  TF_copy_u16(&contents[344], (uint16_t)(mode_manager->transition_table_for_tlm[76].bc_index));
  TF_copy_u8(&contents[346], mode_manager->transition_table_for_tlm[77].from);
  TF_copy_u8(&contents[347], mode_manager->transition_table_for_tlm[77].to);
  TF_copy_u16(&contents[348], (uint16_t)(mode_manager->transition_table_for_tlm[77].bc_index));
  TF_copy_u8(&contents[350], mode_manager->transition_table_for_tlm[78].from);
  TF_copy_u8(&contents[351], mode_manager->transition_table_for_tlm[78].to);
  TF_copy_u16(&contents[352], (uint16_t)(mode_manager->transition_table_for_tlm[78].bc_index));
  TF_copy_u8(&contents[354], mode_manager->transition_table_for_tlm[79].from);
  TF_copy_u8(&contents[355], mode_manager->transition_table_for_tlm[79].to);
  TF_copy_u16(&contents[356], (uint16_t)(mode_manager->transition_table_for_tlm[79].bc_index));
  TF_copy_u8(&contents[358], mode_manager->transition_table_for_tlm[80].from);
  TF_copy_u8(&contents[359], mode_manager->transition_table_for_tlm[80].to);
  TF_copy_u16(&contents[360], (uint16_t)(mode_manager->transition_table_for_tlm[80].bc_index));
  TF_copy_u8(&contents[362], mode_manager->transition_table_for_tlm[81].from);
  TF_copy_u8(&contents[363], mode_manager->transition_table_for_tlm[81].to);
  TF_copy_u16(&contents[364], (uint16_t)(mode_manager->transition_table_for_tlm[81].bc_index));
  TF_copy_u8(&contents[366], mode_manager->transition_table_for_tlm[82].from);
  TF_copy_u8(&contents[367], mode_manager->transition_table_for_tlm[82].to);
  TF_copy_u16(&contents[368], (uint16_t)(mode_manager->transition_table_for_tlm[82].bc_index));
  TF_copy_u8(&contents[370], mode_manager->transition_table_for_tlm[83].from);
  TF_copy_u8(&contents[371], mode_manager->transition_table_for_tlm[83].to);
  TF_copy_u16(&contents[372], (uint16_t)(mode_manager->transition_table_for_tlm[83].bc_index));
  TF_copy_u8(&contents[374], mode_manager->transition_table_for_tlm[84].from);
  TF_copy_u8(&contents[375], mode_manager->transition_table_for_tlm[84].to);
  TF_copy_u16(&contents[376], (uint16_t)(mode_manager->transition_table_for_tlm[84].bc_index));
  TF_copy_u8(&contents[378], mode_manager->transition_table_for_tlm[85].from);
  TF_copy_u8(&contents[379], mode_manager->transition_table_for_tlm[85].to);
  TF_copy_u16(&contents[380], (uint16_t)(mode_manager->transition_table_for_tlm[85].bc_index));
  TF_copy_u8(&contents[382], mode_manager->transition_table_for_tlm[86].from);
  TF_copy_u8(&contents[383], mode_manager->transition_table_for_tlm[86].to);
  TF_copy_u16(&contents[384], (uint16_t)(mode_manager->transition_table_for_tlm[86].bc_index));
  TF_copy_u8(&contents[386], mode_manager->transition_table_for_tlm[87].from);
  TF_copy_u8(&contents[387], mode_manager->transition_table_for_tlm[87].to);
  TF_copy_u16(&contents[388], (uint16_t)(mode_manager->transition_table_for_tlm[87].bc_index));
  TF_copy_u8(&contents[390], mode_manager->transition_table_for_tlm[88].from);
  TF_copy_u8(&contents[391], mode_manager->transition_table_for_tlm[88].to);
  TF_copy_u16(&contents[392], (uint16_t)(mode_manager->transition_table_for_tlm[88].bc_index));
  TF_copy_u8(&contents[394], mode_manager->transition_table_for_tlm[89].from);
  TF_copy_u8(&contents[395], mode_manager->transition_table_for_tlm[89].to);
  TF_copy_u16(&contents[396], (uint16_t)(mode_manager->transition_table_for_tlm[89].bc_index));
#endif

  return 398;
}

static int Tlm_AM_(unsigned char* contents, int max_len)
{
  if (385 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(app_manager->page_no));
  TF_copy_u32(&contents[1], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].initializer));
  TF_copy_u32(&contents[5], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].entry_point));
  TF_copy_u8(&contents[9], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].init_duration));
  TF_copy_u8(&contents[10], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].prev));
  TF_copy_u8(&contents[11], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].min));
  TF_copy_u8(&contents[12], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+0].max));
  TF_copy_u32(&contents[13], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].initializer));
  TF_copy_u32(&contents[17], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].entry_point));
  TF_copy_u8(&contents[21], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].init_duration));
  TF_copy_u8(&contents[22], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].prev));
  TF_copy_u8(&contents[23], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].min));
  TF_copy_u8(&contents[24], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+1].max));
  TF_copy_u32(&contents[25], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].initializer));
  TF_copy_u32(&contents[29], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].entry_point));
  TF_copy_u8(&contents[33], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].init_duration));
  TF_copy_u8(&contents[34], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].prev));
  TF_copy_u8(&contents[35], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].min));
  TF_copy_u8(&contents[36], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+2].max));
  TF_copy_u32(&contents[37], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].initializer));
  TF_copy_u32(&contents[41], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].entry_point));
  TF_copy_u8(&contents[45], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].init_duration));
  TF_copy_u8(&contents[46], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].prev));
  TF_copy_u8(&contents[47], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].min));
  TF_copy_u8(&contents[48], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+3].max));
  TF_copy_u32(&contents[49], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].initializer));
  TF_copy_u32(&contents[53], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].entry_point));
  TF_copy_u8(&contents[57], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].init_duration));
  TF_copy_u8(&contents[58], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].prev));
  TF_copy_u8(&contents[59], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].min));
  TF_copy_u8(&contents[60], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+4].max));
  TF_copy_u32(&contents[61], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].initializer));
  TF_copy_u32(&contents[65], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].entry_point));
  TF_copy_u8(&contents[69], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].init_duration));
  TF_copy_u8(&contents[70], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].prev));
  TF_copy_u8(&contents[71], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].min));
  TF_copy_u8(&contents[72], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+5].max));
  TF_copy_u32(&contents[73], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].initializer));
  TF_copy_u32(&contents[77], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].entry_point));
  TF_copy_u8(&contents[81], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].init_duration));
  TF_copy_u8(&contents[82], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].prev));
  TF_copy_u8(&contents[83], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].min));
  TF_copy_u8(&contents[84], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+6].max));
  TF_copy_u32(&contents[85], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].initializer));
  TF_copy_u32(&contents[89], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].entry_point));
  TF_copy_u8(&contents[93], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].init_duration));
  TF_copy_u8(&contents[94], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].prev));
  TF_copy_u8(&contents[95], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].min));
  TF_copy_u8(&contents[96], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+7].max));
  TF_copy_u32(&contents[97], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].initializer));
  TF_copy_u32(&contents[101], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].entry_point));
  TF_copy_u8(&contents[105], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].init_duration));
  TF_copy_u8(&contents[106], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].prev));
  TF_copy_u8(&contents[107], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].min));
  TF_copy_u8(&contents[108], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+8].max));
  TF_copy_u32(&contents[109], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].initializer));
  TF_copy_u32(&contents[113], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].entry_point));
  TF_copy_u8(&contents[117], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].init_duration));
  TF_copy_u8(&contents[118], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].prev));
  TF_copy_u8(&contents[119], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].min));
  TF_copy_u8(&contents[120], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+9].max));
  TF_copy_u32(&contents[121], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].initializer));
  TF_copy_u32(&contents[125], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].entry_point));
  TF_copy_u8(&contents[129], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].init_duration));
  TF_copy_u8(&contents[130], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].prev));
  TF_copy_u8(&contents[131], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].min));
  TF_copy_u8(&contents[132], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+10].max));
  TF_copy_u32(&contents[133], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].initializer));
  TF_copy_u32(&contents[137], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].entry_point));
  TF_copy_u8(&contents[141], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].init_duration));
  TF_copy_u8(&contents[142], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].prev));
  TF_copy_u8(&contents[143], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].min));
  TF_copy_u8(&contents[144], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+11].max));
  TF_copy_u32(&contents[145], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].initializer));
  TF_copy_u32(&contents[149], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].entry_point));
  TF_copy_u8(&contents[153], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].init_duration));
  TF_copy_u8(&contents[154], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].prev));
  TF_copy_u8(&contents[155], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].min));
  TF_copy_u8(&contents[156], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+12].max));
  TF_copy_u32(&contents[157], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].initializer));
  TF_copy_u32(&contents[161], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].entry_point));
  TF_copy_u8(&contents[165], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].init_duration));
  TF_copy_u8(&contents[166], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].prev));
  TF_copy_u8(&contents[167], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].min));
  TF_copy_u8(&contents[168], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+13].max));
  TF_copy_u32(&contents[169], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].initializer));
  TF_copy_u32(&contents[173], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].entry_point));
  TF_copy_u8(&contents[177], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].init_duration));
  TF_copy_u8(&contents[178], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].prev));
  TF_copy_u8(&contents[179], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].min));
  TF_copy_u8(&contents[180], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+14].max));
  TF_copy_u32(&contents[181], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].initializer));
  TF_copy_u32(&contents[185], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].entry_point));
  TF_copy_u8(&contents[189], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].init_duration));
  TF_copy_u8(&contents[190], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].prev));
  TF_copy_u8(&contents[191], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].min));
  TF_copy_u8(&contents[192], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+15].max));
  TF_copy_u32(&contents[193], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].initializer));
  TF_copy_u32(&contents[197], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].entry_point));
  TF_copy_u8(&contents[201], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].init_duration));
  TF_copy_u8(&contents[202], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].prev));
  TF_copy_u8(&contents[203], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].min));
  TF_copy_u8(&contents[204], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+16].max));
  TF_copy_u32(&contents[205], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].initializer));
  TF_copy_u32(&contents[209], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].entry_point));
  TF_copy_u8(&contents[213], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].init_duration));
  TF_copy_u8(&contents[214], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].prev));
  TF_copy_u8(&contents[215], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].min));
  TF_copy_u8(&contents[216], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+17].max));
  TF_copy_u32(&contents[217], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].initializer));
  TF_copy_u32(&contents[221], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].entry_point));
  TF_copy_u8(&contents[225], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].init_duration));
  TF_copy_u8(&contents[226], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].prev));
  TF_copy_u8(&contents[227], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].min));
  TF_copy_u8(&contents[228], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+18].max));
  TF_copy_u32(&contents[229], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].initializer));
  TF_copy_u32(&contents[233], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].entry_point));
  TF_copy_u8(&contents[237], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].init_duration));
  TF_copy_u8(&contents[238], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].prev));
  TF_copy_u8(&contents[239], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].min));
  TF_copy_u8(&contents[240], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+19].max));
  TF_copy_u32(&contents[241], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].initializer));
  TF_copy_u32(&contents[245], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].entry_point));
  TF_copy_u8(&contents[249], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].init_duration));
  TF_copy_u8(&contents[250], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].prev));
  TF_copy_u8(&contents[251], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].min));
  TF_copy_u8(&contents[252], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+20].max));
  TF_copy_u32(&contents[253], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].initializer));
  TF_copy_u32(&contents[257], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].entry_point));
  TF_copy_u8(&contents[261], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].init_duration));
  TF_copy_u8(&contents[262], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].prev));
  TF_copy_u8(&contents[263], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].min));
  TF_copy_u8(&contents[264], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+21].max));
  TF_copy_u32(&contents[265], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].initializer));
  TF_copy_u32(&contents[269], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].entry_point));
  TF_copy_u8(&contents[273], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].init_duration));
  TF_copy_u8(&contents[274], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].prev));
  TF_copy_u8(&contents[275], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].min));
  TF_copy_u8(&contents[276], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+22].max));
  TF_copy_u32(&contents[277], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].initializer));
  TF_copy_u32(&contents[281], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].entry_point));
  TF_copy_u8(&contents[285], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].init_duration));
  TF_copy_u8(&contents[286], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].prev));
  TF_copy_u8(&contents[287], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].min));
  TF_copy_u8(&contents[288], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+23].max));
  TF_copy_u32(&contents[289], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].initializer));
  TF_copy_u32(&contents[293], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].entry_point));
  TF_copy_u8(&contents[297], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].init_duration));
  TF_copy_u8(&contents[298], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].prev));
  TF_copy_u8(&contents[299], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].min));
  TF_copy_u8(&contents[300], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+24].max));
  TF_copy_u32(&contents[301], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].initializer));
  TF_copy_u32(&contents[305], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].entry_point));
  TF_copy_u8(&contents[309], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].init_duration));
  TF_copy_u8(&contents[310], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].prev));
  TF_copy_u8(&contents[311], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].min));
  TF_copy_u8(&contents[312], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+25].max));
  TF_copy_u32(&contents[313], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].initializer));
  TF_copy_u32(&contents[317], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].entry_point));
  TF_copy_u8(&contents[321], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].init_duration));
  TF_copy_u8(&contents[322], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].prev));
  TF_copy_u8(&contents[323], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].min));
  TF_copy_u8(&contents[324], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+26].max));
  TF_copy_u32(&contents[325], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].initializer));
  TF_copy_u32(&contents[329], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].entry_point));
  TF_copy_u8(&contents[333], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].init_duration));
  TF_copy_u8(&contents[334], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].prev));
  TF_copy_u8(&contents[335], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].min));
  TF_copy_u8(&contents[336], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+27].max));
  TF_copy_u32(&contents[337], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].initializer));
  TF_copy_u32(&contents[341], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].entry_point));
  TF_copy_u8(&contents[345], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].init_duration));
  TF_copy_u8(&contents[346], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].prev));
  TF_copy_u8(&contents[347], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].min));
  TF_copy_u8(&contents[348], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+28].max));
  TF_copy_u32(&contents[349], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].initializer));
  TF_copy_u32(&contents[353], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].entry_point));
  TF_copy_u8(&contents[357], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].init_duration));
  TF_copy_u8(&contents[358], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].prev));
  TF_copy_u8(&contents[359], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].min));
  TF_copy_u8(&contents[360], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+29].max));
  TF_copy_u32(&contents[361], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].initializer));
  TF_copy_u32(&contents[365], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].entry_point));
  TF_copy_u8(&contents[369], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].init_duration));
  TF_copy_u8(&contents[370], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].prev));
  TF_copy_u8(&contents[371], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].min));
  TF_copy_u8(&contents[372], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+30].max));
  TF_copy_u32(&contents[373], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].initializer));
  TF_copy_u32(&contents[377], (uint32_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].entry_point));
  TF_copy_u8(&contents[381], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].init_duration));
  TF_copy_u8(&contents[382], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].prev));
  TF_copy_u8(&contents[383], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].min));
  TF_copy_u8(&contents[384], (uint8_t)(app_manager->ais[(AM_TLM_PAGE_SIZE*app_manager->page_no)+31].max));
#endif

  return 385;
}

static int Tlm_APP_TIME_(unsigned char* contents, int max_len)
{
  if (400 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(app_manager->ais[0].init_duration));
  TF_copy_u8(&contents[1], (uint8_t)(app_manager->ais[0].prev));
  TF_copy_u8(&contents[2], (uint8_t)(app_manager->ais[0].min));
  TF_copy_u8(&contents[3], (uint8_t)(app_manager->ais[0].max));
  TF_copy_u8(&contents[4], (uint8_t)(app_manager->ais[1].init_duration));
  TF_copy_u8(&contents[5], (uint8_t)(app_manager->ais[1].prev));
  TF_copy_u8(&contents[6], (uint8_t)(app_manager->ais[1].min));
  TF_copy_u8(&contents[7], (uint8_t)(app_manager->ais[1].max));
  TF_copy_u8(&contents[8], (uint8_t)(app_manager->ais[2].init_duration));
  TF_copy_u8(&contents[9], (uint8_t)(app_manager->ais[2].prev));
  TF_copy_u8(&contents[10], (uint8_t)(app_manager->ais[2].min));
  TF_copy_u8(&contents[11], (uint8_t)(app_manager->ais[2].max));
  TF_copy_u8(&contents[12], (uint8_t)(app_manager->ais[3].init_duration));
  TF_copy_u8(&contents[13], (uint8_t)(app_manager->ais[3].prev));
  TF_copy_u8(&contents[14], (uint8_t)(app_manager->ais[3].min));
  TF_copy_u8(&contents[15], (uint8_t)(app_manager->ais[3].max));
  TF_copy_u8(&contents[16], (uint8_t)(app_manager->ais[4].init_duration));
  TF_copy_u8(&contents[17], (uint8_t)(app_manager->ais[4].prev));
  TF_copy_u8(&contents[18], (uint8_t)(app_manager->ais[4].min));
  TF_copy_u8(&contents[19], (uint8_t)(app_manager->ais[4].max));
  TF_copy_u8(&contents[20], (uint8_t)(app_manager->ais[5].init_duration));
  TF_copy_u8(&contents[21], (uint8_t)(app_manager->ais[5].prev));
  TF_copy_u8(&contents[22], (uint8_t)(app_manager->ais[5].min));
  TF_copy_u8(&contents[23], (uint8_t)(app_manager->ais[5].max));
  TF_copy_u8(&contents[24], (uint8_t)(app_manager->ais[6].init_duration));
  TF_copy_u8(&contents[25], (uint8_t)(app_manager->ais[6].prev));
  TF_copy_u8(&contents[26], (uint8_t)(app_manager->ais[6].min));
  TF_copy_u8(&contents[27], (uint8_t)(app_manager->ais[6].max));
  TF_copy_u8(&contents[28], (uint8_t)(app_manager->ais[7].init_duration));
  TF_copy_u8(&contents[29], (uint8_t)(app_manager->ais[7].prev));
  TF_copy_u8(&contents[30], (uint8_t)(app_manager->ais[7].min));
  TF_copy_u8(&contents[31], (uint8_t)(app_manager->ais[7].max));
  TF_copy_u8(&contents[32], (uint8_t)(app_manager->ais[8].init_duration));
  TF_copy_u8(&contents[33], (uint8_t)(app_manager->ais[8].prev));
  TF_copy_u8(&contents[34], (uint8_t)(app_manager->ais[8].min));
  TF_copy_u8(&contents[35], (uint8_t)(app_manager->ais[8].max));
  TF_copy_u8(&contents[36], (uint8_t)(app_manager->ais[9].init_duration));
  TF_copy_u8(&contents[37], (uint8_t)(app_manager->ais[9].prev));
  TF_copy_u8(&contents[38], (uint8_t)(app_manager->ais[9].min));
  TF_copy_u8(&contents[39], (uint8_t)(app_manager->ais[9].max));
  TF_copy_u8(&contents[40], (uint8_t)(app_manager->ais[10].init_duration));
  TF_copy_u8(&contents[41], (uint8_t)(app_manager->ais[10].prev));
  TF_copy_u8(&contents[42], (uint8_t)(app_manager->ais[10].min));
  TF_copy_u8(&contents[43], (uint8_t)(app_manager->ais[10].max));
  TF_copy_u8(&contents[44], (uint8_t)(app_manager->ais[11].init_duration));
  TF_copy_u8(&contents[45], (uint8_t)(app_manager->ais[11].prev));
  TF_copy_u8(&contents[46], (uint8_t)(app_manager->ais[11].min));
  TF_copy_u8(&contents[47], (uint8_t)(app_manager->ais[11].max));
  TF_copy_u8(&contents[48], (uint8_t)(app_manager->ais[12].init_duration));
  TF_copy_u8(&contents[49], (uint8_t)(app_manager->ais[12].prev));
  TF_copy_u8(&contents[50], (uint8_t)(app_manager->ais[12].min));
  TF_copy_u8(&contents[51], (uint8_t)(app_manager->ais[12].max));
  TF_copy_u8(&contents[52], (uint8_t)(app_manager->ais[13].init_duration));
  TF_copy_u8(&contents[53], (uint8_t)(app_manager->ais[13].prev));
  TF_copy_u8(&contents[54], (uint8_t)(app_manager->ais[13].min));
  TF_copy_u8(&contents[55], (uint8_t)(app_manager->ais[13].max));
  TF_copy_u8(&contents[56], (uint8_t)(app_manager->ais[14].init_duration));
  TF_copy_u8(&contents[57], (uint8_t)(app_manager->ais[14].prev));
  TF_copy_u8(&contents[58], (uint8_t)(app_manager->ais[14].min));
  TF_copy_u8(&contents[59], (uint8_t)(app_manager->ais[14].max));
  TF_copy_u8(&contents[60], (uint8_t)(app_manager->ais[15].init_duration));
  TF_copy_u8(&contents[61], (uint8_t)(app_manager->ais[15].prev));
  TF_copy_u8(&contents[62], (uint8_t)(app_manager->ais[15].min));
  TF_copy_u8(&contents[63], (uint8_t)(app_manager->ais[15].max));
  TF_copy_u8(&contents[64], (uint8_t)(app_manager->ais[16].init_duration));
  TF_copy_u8(&contents[65], (uint8_t)(app_manager->ais[16].prev));
  TF_copy_u8(&contents[66], (uint8_t)(app_manager->ais[16].min));
  TF_copy_u8(&contents[67], (uint8_t)(app_manager->ais[16].max));
  TF_copy_u8(&contents[68], (uint8_t)(app_manager->ais[17].init_duration));
  TF_copy_u8(&contents[69], (uint8_t)(app_manager->ais[17].prev));
  TF_copy_u8(&contents[70], (uint8_t)(app_manager->ais[17].min));
  TF_copy_u8(&contents[71], (uint8_t)(app_manager->ais[17].max));
  TF_copy_u8(&contents[72], (uint8_t)(app_manager->ais[18].init_duration));
  TF_copy_u8(&contents[73], (uint8_t)(app_manager->ais[18].prev));
  TF_copy_u8(&contents[74], (uint8_t)(app_manager->ais[18].min));
  TF_copy_u8(&contents[75], (uint8_t)(app_manager->ais[18].max));
  TF_copy_u8(&contents[76], (uint8_t)(app_manager->ais[19].init_duration));
  TF_copy_u8(&contents[77], (uint8_t)(app_manager->ais[19].prev));
  TF_copy_u8(&contents[78], (uint8_t)(app_manager->ais[19].min));
  TF_copy_u8(&contents[79], (uint8_t)(app_manager->ais[19].max));
  TF_copy_u8(&contents[80], (uint8_t)(app_manager->ais[20].init_duration));
  TF_copy_u8(&contents[81], (uint8_t)(app_manager->ais[20].prev));
  TF_copy_u8(&contents[82], (uint8_t)(app_manager->ais[20].min));
  TF_copy_u8(&contents[83], (uint8_t)(app_manager->ais[20].max));
  TF_copy_u8(&contents[84], (uint8_t)(app_manager->ais[21].init_duration));
  TF_copy_u8(&contents[85], (uint8_t)(app_manager->ais[21].prev));
  TF_copy_u8(&contents[86], (uint8_t)(app_manager->ais[21].min));
  TF_copy_u8(&contents[87], (uint8_t)(app_manager->ais[21].max));
  TF_copy_u8(&contents[88], (uint8_t)(app_manager->ais[22].init_duration));
  TF_copy_u8(&contents[89], (uint8_t)(app_manager->ais[22].prev));
  TF_copy_u8(&contents[90], (uint8_t)(app_manager->ais[22].min));
  TF_copy_u8(&contents[91], (uint8_t)(app_manager->ais[22].max));
  TF_copy_u8(&contents[92], (uint8_t)(app_manager->ais[23].init_duration));
  TF_copy_u8(&contents[93], (uint8_t)(app_manager->ais[23].prev));
  TF_copy_u8(&contents[94], (uint8_t)(app_manager->ais[23].min));
  TF_copy_u8(&contents[95], (uint8_t)(app_manager->ais[23].max));
  TF_copy_u8(&contents[96], (uint8_t)(app_manager->ais[24].init_duration));
  TF_copy_u8(&contents[97], (uint8_t)(app_manager->ais[24].prev));
  TF_copy_u8(&contents[98], (uint8_t)(app_manager->ais[24].min));
  TF_copy_u8(&contents[99], (uint8_t)(app_manager->ais[24].max));
  TF_copy_u8(&contents[100], (uint8_t)(app_manager->ais[25].init_duration));
  TF_copy_u8(&contents[101], (uint8_t)(app_manager->ais[25].prev));
  TF_copy_u8(&contents[102], (uint8_t)(app_manager->ais[25].min));
  TF_copy_u8(&contents[103], (uint8_t)(app_manager->ais[25].max));
  TF_copy_u8(&contents[104], (uint8_t)(app_manager->ais[26].init_duration));
  TF_copy_u8(&contents[105], (uint8_t)(app_manager->ais[26].prev));
  TF_copy_u8(&contents[106], (uint8_t)(app_manager->ais[26].min));
  TF_copy_u8(&contents[107], (uint8_t)(app_manager->ais[26].max));
  TF_copy_u8(&contents[108], (uint8_t)(app_manager->ais[27].init_duration));
  TF_copy_u8(&contents[109], (uint8_t)(app_manager->ais[27].prev));
  TF_copy_u8(&contents[110], (uint8_t)(app_manager->ais[27].min));
  TF_copy_u8(&contents[111], (uint8_t)(app_manager->ais[27].max));
  TF_copy_u8(&contents[112], (uint8_t)(app_manager->ais[28].init_duration));
  TF_copy_u8(&contents[113], (uint8_t)(app_manager->ais[28].prev));
  TF_copy_u8(&contents[114], (uint8_t)(app_manager->ais[28].min));
  TF_copy_u8(&contents[115], (uint8_t)(app_manager->ais[28].max));
  TF_copy_u8(&contents[116], (uint8_t)(app_manager->ais[29].init_duration));
  TF_copy_u8(&contents[117], (uint8_t)(app_manager->ais[29].prev));
  TF_copy_u8(&contents[118], (uint8_t)(app_manager->ais[29].min));
  TF_copy_u8(&contents[119], (uint8_t)(app_manager->ais[29].max));
  TF_copy_u8(&contents[120], (uint8_t)(app_manager->ais[30].init_duration));
  TF_copy_u8(&contents[121], (uint8_t)(app_manager->ais[30].prev));
  TF_copy_u8(&contents[122], (uint8_t)(app_manager->ais[30].min));
  TF_copy_u8(&contents[123], (uint8_t)(app_manager->ais[30].max));
  TF_copy_u8(&contents[124], (uint8_t)(app_manager->ais[31].init_duration));
  TF_copy_u8(&contents[125], (uint8_t)(app_manager->ais[31].prev));
  TF_copy_u8(&contents[126], (uint8_t)(app_manager->ais[31].min));
  TF_copy_u8(&contents[127], (uint8_t)(app_manager->ais[31].max));
  TF_copy_u8(&contents[128], (uint8_t)(app_manager->ais[32].init_duration));
  TF_copy_u8(&contents[129], (uint8_t)(app_manager->ais[32].prev));
  TF_copy_u8(&contents[130], (uint8_t)(app_manager->ais[32].min));
  TF_copy_u8(&contents[131], (uint8_t)(app_manager->ais[32].max));
  TF_copy_u8(&contents[132], (uint8_t)(app_manager->ais[33].init_duration));
  TF_copy_u8(&contents[133], (uint8_t)(app_manager->ais[33].prev));
  TF_copy_u8(&contents[134], (uint8_t)(app_manager->ais[33].min));
  TF_copy_u8(&contents[135], (uint8_t)(app_manager->ais[33].max));
  TF_copy_u8(&contents[136], (uint8_t)(app_manager->ais[34].init_duration));
  TF_copy_u8(&contents[137], (uint8_t)(app_manager->ais[34].prev));
  TF_copy_u8(&contents[138], (uint8_t)(app_manager->ais[34].min));
  TF_copy_u8(&contents[139], (uint8_t)(app_manager->ais[34].max));
  TF_copy_u8(&contents[140], (uint8_t)(app_manager->ais[35].init_duration));
  TF_copy_u8(&contents[141], (uint8_t)(app_manager->ais[35].prev));
  TF_copy_u8(&contents[142], (uint8_t)(app_manager->ais[35].min));
  TF_copy_u8(&contents[143], (uint8_t)(app_manager->ais[35].max));
  TF_copy_u8(&contents[144], (uint8_t)(app_manager->ais[36].init_duration));
  TF_copy_u8(&contents[145], (uint8_t)(app_manager->ais[36].prev));
  TF_copy_u8(&contents[146], (uint8_t)(app_manager->ais[36].min));
  TF_copy_u8(&contents[147], (uint8_t)(app_manager->ais[36].max));
  TF_copy_u8(&contents[148], (uint8_t)(app_manager->ais[37].init_duration));
  TF_copy_u8(&contents[149], (uint8_t)(app_manager->ais[37].prev));
  TF_copy_u8(&contents[150], (uint8_t)(app_manager->ais[37].min));
  TF_copy_u8(&contents[151], (uint8_t)(app_manager->ais[37].max));
  TF_copy_u8(&contents[152], (uint8_t)(app_manager->ais[38].init_duration));
  TF_copy_u8(&contents[153], (uint8_t)(app_manager->ais[38].prev));
  TF_copy_u8(&contents[154], (uint8_t)(app_manager->ais[38].min));
  TF_copy_u8(&contents[155], (uint8_t)(app_manager->ais[38].max));
  TF_copy_u8(&contents[156], (uint8_t)(app_manager->ais[39].init_duration));
  TF_copy_u8(&contents[157], (uint8_t)(app_manager->ais[39].prev));
  TF_copy_u8(&contents[158], (uint8_t)(app_manager->ais[39].min));
  TF_copy_u8(&contents[159], (uint8_t)(app_manager->ais[39].max));
  TF_copy_u8(&contents[160], (uint8_t)(app_manager->ais[40].init_duration));
  TF_copy_u8(&contents[161], (uint8_t)(app_manager->ais[40].prev));
  TF_copy_u8(&contents[162], (uint8_t)(app_manager->ais[40].min));
  TF_copy_u8(&contents[163], (uint8_t)(app_manager->ais[40].max));
  TF_copy_u8(&contents[164], (uint8_t)(app_manager->ais[41].init_duration));
  TF_copy_u8(&contents[165], (uint8_t)(app_manager->ais[41].prev));
  TF_copy_u8(&contents[166], (uint8_t)(app_manager->ais[41].min));
  TF_copy_u8(&contents[167], (uint8_t)(app_manager->ais[41].max));
  TF_copy_u8(&contents[168], (uint8_t)(app_manager->ais[42].init_duration));
  TF_copy_u8(&contents[169], (uint8_t)(app_manager->ais[42].prev));
  TF_copy_u8(&contents[170], (uint8_t)(app_manager->ais[42].min));
  TF_copy_u8(&contents[171], (uint8_t)(app_manager->ais[42].max));
  TF_copy_u8(&contents[172], (uint8_t)(app_manager->ais[43].init_duration));
  TF_copy_u8(&contents[173], (uint8_t)(app_manager->ais[43].prev));
  TF_copy_u8(&contents[174], (uint8_t)(app_manager->ais[43].min));
  TF_copy_u8(&contents[175], (uint8_t)(app_manager->ais[43].max));
  TF_copy_u8(&contents[176], (uint8_t)(app_manager->ais[44].init_duration));
  TF_copy_u8(&contents[177], (uint8_t)(app_manager->ais[44].prev));
  TF_copy_u8(&contents[178], (uint8_t)(app_manager->ais[44].min));
  TF_copy_u8(&contents[179], (uint8_t)(app_manager->ais[44].max));
  TF_copy_u8(&contents[180], (uint8_t)(app_manager->ais[45].init_duration));
  TF_copy_u8(&contents[181], (uint8_t)(app_manager->ais[45].prev));
  TF_copy_u8(&contents[182], (uint8_t)(app_manager->ais[45].min));
  TF_copy_u8(&contents[183], (uint8_t)(app_manager->ais[45].max));
  TF_copy_u8(&contents[184], (uint8_t)(app_manager->ais[46].init_duration));
  TF_copy_u8(&contents[185], (uint8_t)(app_manager->ais[46].prev));
  TF_copy_u8(&contents[186], (uint8_t)(app_manager->ais[46].min));
  TF_copy_u8(&contents[187], (uint8_t)(app_manager->ais[46].max));
  TF_copy_u8(&contents[188], (uint8_t)(app_manager->ais[47].init_duration));
  TF_copy_u8(&contents[189], (uint8_t)(app_manager->ais[47].prev));
  TF_copy_u8(&contents[190], (uint8_t)(app_manager->ais[47].min));
  TF_copy_u8(&contents[191], (uint8_t)(app_manager->ais[47].max));
  TF_copy_u8(&contents[192], (uint8_t)(app_manager->ais[48].init_duration));
  TF_copy_u8(&contents[193], (uint8_t)(app_manager->ais[48].prev));
  TF_copy_u8(&contents[194], (uint8_t)(app_manager->ais[48].min));
  TF_copy_u8(&contents[195], (uint8_t)(app_manager->ais[48].max));
  TF_copy_u8(&contents[196], (uint8_t)(app_manager->ais[49].init_duration));
  TF_copy_u8(&contents[197], (uint8_t)(app_manager->ais[49].prev));
  TF_copy_u8(&contents[198], (uint8_t)(app_manager->ais[49].min));
  TF_copy_u8(&contents[199], (uint8_t)(app_manager->ais[49].max));
  TF_copy_u8(&contents[200], (uint8_t)(app_manager->ais[50].init_duration));
  TF_copy_u8(&contents[201], (uint8_t)(app_manager->ais[50].prev));
  TF_copy_u8(&contents[202], (uint8_t)(app_manager->ais[50].min));
  TF_copy_u8(&contents[203], (uint8_t)(app_manager->ais[50].max));
  TF_copy_u8(&contents[204], (uint8_t)(app_manager->ais[51].init_duration));
  TF_copy_u8(&contents[205], (uint8_t)(app_manager->ais[51].prev));
  TF_copy_u8(&contents[206], (uint8_t)(app_manager->ais[51].min));
  TF_copy_u8(&contents[207], (uint8_t)(app_manager->ais[51].max));
  TF_copy_u8(&contents[208], (uint8_t)(app_manager->ais[52].init_duration));
  TF_copy_u8(&contents[209], (uint8_t)(app_manager->ais[52].prev));
  TF_copy_u8(&contents[210], (uint8_t)(app_manager->ais[52].min));
  TF_copy_u8(&contents[211], (uint8_t)(app_manager->ais[52].max));
  TF_copy_u8(&contents[212], (uint8_t)(app_manager->ais[53].init_duration));
  TF_copy_u8(&contents[213], (uint8_t)(app_manager->ais[53].prev));
  TF_copy_u8(&contents[214], (uint8_t)(app_manager->ais[53].min));
  TF_copy_u8(&contents[215], (uint8_t)(app_manager->ais[53].max));
  TF_copy_u8(&contents[216], (uint8_t)(app_manager->ais[54].init_duration));
  TF_copy_u8(&contents[217], (uint8_t)(app_manager->ais[54].prev));
  TF_copy_u8(&contents[218], (uint8_t)(app_manager->ais[54].min));
  TF_copy_u8(&contents[219], (uint8_t)(app_manager->ais[54].max));
  TF_copy_u8(&contents[220], (uint8_t)(app_manager->ais[55].init_duration));
  TF_copy_u8(&contents[221], (uint8_t)(app_manager->ais[55].prev));
  TF_copy_u8(&contents[222], (uint8_t)(app_manager->ais[55].min));
  TF_copy_u8(&contents[223], (uint8_t)(app_manager->ais[55].max));
  TF_copy_u8(&contents[224], (uint8_t)(app_manager->ais[56].init_duration));
  TF_copy_u8(&contents[225], (uint8_t)(app_manager->ais[56].prev));
  TF_copy_u8(&contents[226], (uint8_t)(app_manager->ais[56].min));
  TF_copy_u8(&contents[227], (uint8_t)(app_manager->ais[56].max));
  TF_copy_u8(&contents[228], (uint8_t)(app_manager->ais[57].init_duration));
  TF_copy_u8(&contents[229], (uint8_t)(app_manager->ais[57].prev));
  TF_copy_u8(&contents[230], (uint8_t)(app_manager->ais[57].min));
  TF_copy_u8(&contents[231], (uint8_t)(app_manager->ais[57].max));
  TF_copy_u8(&contents[232], (uint8_t)(app_manager->ais[58].init_duration));
  TF_copy_u8(&contents[233], (uint8_t)(app_manager->ais[58].prev));
  TF_copy_u8(&contents[234], (uint8_t)(app_manager->ais[58].min));
  TF_copy_u8(&contents[235], (uint8_t)(app_manager->ais[58].max));
  TF_copy_u8(&contents[236], (uint8_t)(app_manager->ais[59].init_duration));
  TF_copy_u8(&contents[237], (uint8_t)(app_manager->ais[59].prev));
  TF_copy_u8(&contents[238], (uint8_t)(app_manager->ais[59].min));
  TF_copy_u8(&contents[239], (uint8_t)(app_manager->ais[59].max));
  TF_copy_u8(&contents[240], (uint8_t)(app_manager->ais[60].init_duration));
  TF_copy_u8(&contents[241], (uint8_t)(app_manager->ais[60].prev));
  TF_copy_u8(&contents[242], (uint8_t)(app_manager->ais[60].min));
  TF_copy_u8(&contents[243], (uint8_t)(app_manager->ais[60].max));
  TF_copy_u8(&contents[244], (uint8_t)(app_manager->ais[61].init_duration));
  TF_copy_u8(&contents[245], (uint8_t)(app_manager->ais[61].prev));
  TF_copy_u8(&contents[246], (uint8_t)(app_manager->ais[61].min));
  TF_copy_u8(&contents[247], (uint8_t)(app_manager->ais[61].max));
  TF_copy_u8(&contents[248], (uint8_t)(app_manager->ais[62].init_duration));
  TF_copy_u8(&contents[249], (uint8_t)(app_manager->ais[62].prev));
  TF_copy_u8(&contents[250], (uint8_t)(app_manager->ais[62].min));
  TF_copy_u8(&contents[251], (uint8_t)(app_manager->ais[62].max));
  TF_copy_u8(&contents[252], (uint8_t)(app_manager->ais[63].init_duration));
  TF_copy_u8(&contents[253], (uint8_t)(app_manager->ais[63].prev));
  TF_copy_u8(&contents[254], (uint8_t)(app_manager->ais[63].min));
  TF_copy_u8(&contents[255], (uint8_t)(app_manager->ais[63].max));
  TF_copy_u8(&contents[256], (uint8_t)(app_manager->ais[64].init_duration));
  TF_copy_u8(&contents[257], (uint8_t)(app_manager->ais[64].prev));
  TF_copy_u8(&contents[258], (uint8_t)(app_manager->ais[64].min));
  TF_copy_u8(&contents[259], (uint8_t)(app_manager->ais[64].max));
  TF_copy_u8(&contents[260], (uint8_t)(app_manager->ais[65].init_duration));
  TF_copy_u8(&contents[261], (uint8_t)(app_manager->ais[65].prev));
  TF_copy_u8(&contents[262], (uint8_t)(app_manager->ais[65].min));
  TF_copy_u8(&contents[263], (uint8_t)(app_manager->ais[65].max));
  TF_copy_u8(&contents[264], (uint8_t)(app_manager->ais[66].init_duration));
  TF_copy_u8(&contents[265], (uint8_t)(app_manager->ais[66].prev));
  TF_copy_u8(&contents[266], (uint8_t)(app_manager->ais[66].min));
  TF_copy_u8(&contents[267], (uint8_t)(app_manager->ais[66].max));
  TF_copy_u8(&contents[268], (uint8_t)(app_manager->ais[67].init_duration));
  TF_copy_u8(&contents[269], (uint8_t)(app_manager->ais[67].prev));
  TF_copy_u8(&contents[270], (uint8_t)(app_manager->ais[67].min));
  TF_copy_u8(&contents[271], (uint8_t)(app_manager->ais[67].max));
  TF_copy_u8(&contents[272], (uint8_t)(app_manager->ais[68].init_duration));
  TF_copy_u8(&contents[273], (uint8_t)(app_manager->ais[68].prev));
  TF_copy_u8(&contents[274], (uint8_t)(app_manager->ais[68].min));
  TF_copy_u8(&contents[275], (uint8_t)(app_manager->ais[68].max));
  TF_copy_u8(&contents[276], (uint8_t)(app_manager->ais[69].init_duration));
  TF_copy_u8(&contents[277], (uint8_t)(app_manager->ais[69].prev));
  TF_copy_u8(&contents[278], (uint8_t)(app_manager->ais[69].min));
  TF_copy_u8(&contents[279], (uint8_t)(app_manager->ais[69].max));
  TF_copy_u8(&contents[280], (uint8_t)(app_manager->ais[70].init_duration));
  TF_copy_u8(&contents[281], (uint8_t)(app_manager->ais[70].prev));
  TF_copy_u8(&contents[282], (uint8_t)(app_manager->ais[70].min));
  TF_copy_u8(&contents[283], (uint8_t)(app_manager->ais[70].max));
  TF_copy_u8(&contents[284], (uint8_t)(app_manager->ais[71].init_duration));
  TF_copy_u8(&contents[285], (uint8_t)(app_manager->ais[71].prev));
  TF_copy_u8(&contents[286], (uint8_t)(app_manager->ais[71].min));
  TF_copy_u8(&contents[287], (uint8_t)(app_manager->ais[71].max));
  TF_copy_u8(&contents[288], (uint8_t)(app_manager->ais[72].init_duration));
  TF_copy_u8(&contents[289], (uint8_t)(app_manager->ais[72].prev));
  TF_copy_u8(&contents[290], (uint8_t)(app_manager->ais[72].min));
  TF_copy_u8(&contents[291], (uint8_t)(app_manager->ais[72].max));
  TF_copy_u8(&contents[292], (uint8_t)(app_manager->ais[73].init_duration));
  TF_copy_u8(&contents[293], (uint8_t)(app_manager->ais[73].prev));
  TF_copy_u8(&contents[294], (uint8_t)(app_manager->ais[73].min));
  TF_copy_u8(&contents[295], (uint8_t)(app_manager->ais[73].max));
  TF_copy_u8(&contents[296], (uint8_t)(app_manager->ais[74].init_duration));
  TF_copy_u8(&contents[297], (uint8_t)(app_manager->ais[74].prev));
  TF_copy_u8(&contents[298], (uint8_t)(app_manager->ais[74].min));
  TF_copy_u8(&contents[299], (uint8_t)(app_manager->ais[74].max));
  TF_copy_u8(&contents[300], (uint8_t)(app_manager->ais[75].init_duration));
  TF_copy_u8(&contents[301], (uint8_t)(app_manager->ais[75].prev));
  TF_copy_u8(&contents[302], (uint8_t)(app_manager->ais[75].min));
  TF_copy_u8(&contents[303], (uint8_t)(app_manager->ais[75].max));
  TF_copy_u8(&contents[304], (uint8_t)(app_manager->ais[76].init_duration));
  TF_copy_u8(&contents[305], (uint8_t)(app_manager->ais[76].prev));
  TF_copy_u8(&contents[306], (uint8_t)(app_manager->ais[76].min));
  TF_copy_u8(&contents[307], (uint8_t)(app_manager->ais[76].max));
  TF_copy_u8(&contents[308], (uint8_t)(app_manager->ais[77].init_duration));
  TF_copy_u8(&contents[309], (uint8_t)(app_manager->ais[77].prev));
  TF_copy_u8(&contents[310], (uint8_t)(app_manager->ais[77].min));
  TF_copy_u8(&contents[311], (uint8_t)(app_manager->ais[77].max));
  TF_copy_u8(&contents[312], (uint8_t)(app_manager->ais[78].init_duration));
  TF_copy_u8(&contents[313], (uint8_t)(app_manager->ais[78].prev));
  TF_copy_u8(&contents[314], (uint8_t)(app_manager->ais[78].min));
  TF_copy_u8(&contents[315], (uint8_t)(app_manager->ais[78].max));
  TF_copy_u8(&contents[316], (uint8_t)(app_manager->ais[79].init_duration));
  TF_copy_u8(&contents[317], (uint8_t)(app_manager->ais[79].prev));
  TF_copy_u8(&contents[318], (uint8_t)(app_manager->ais[79].min));
  TF_copy_u8(&contents[319], (uint8_t)(app_manager->ais[79].max));
  TF_copy_u8(&contents[320], (uint8_t)(app_manager->ais[80].init_duration));
  TF_copy_u8(&contents[321], (uint8_t)(app_manager->ais[80].prev));
  TF_copy_u8(&contents[322], (uint8_t)(app_manager->ais[80].min));
  TF_copy_u8(&contents[323], (uint8_t)(app_manager->ais[80].max));
  TF_copy_u8(&contents[324], (uint8_t)(app_manager->ais[81].init_duration));
  TF_copy_u8(&contents[325], (uint8_t)(app_manager->ais[81].prev));
  TF_copy_u8(&contents[326], (uint8_t)(app_manager->ais[81].min));
  TF_copy_u8(&contents[327], (uint8_t)(app_manager->ais[81].max));
  TF_copy_u8(&contents[328], (uint8_t)(app_manager->ais[82].init_duration));
  TF_copy_u8(&contents[329], (uint8_t)(app_manager->ais[82].prev));
  TF_copy_u8(&contents[330], (uint8_t)(app_manager->ais[82].min));
  TF_copy_u8(&contents[331], (uint8_t)(app_manager->ais[82].max));
  TF_copy_u8(&contents[332], (uint8_t)(app_manager->ais[83].init_duration));
  TF_copy_u8(&contents[333], (uint8_t)(app_manager->ais[83].prev));
  TF_copy_u8(&contents[334], (uint8_t)(app_manager->ais[83].min));
  TF_copy_u8(&contents[335], (uint8_t)(app_manager->ais[83].max));
  TF_copy_u8(&contents[336], (uint8_t)(app_manager->ais[84].init_duration));
  TF_copy_u8(&contents[337], (uint8_t)(app_manager->ais[84].prev));
  TF_copy_u8(&contents[338], (uint8_t)(app_manager->ais[84].min));
  TF_copy_u8(&contents[339], (uint8_t)(app_manager->ais[84].max));
  TF_copy_u8(&contents[340], (uint8_t)(app_manager->ais[85].init_duration));
  TF_copy_u8(&contents[341], (uint8_t)(app_manager->ais[85].prev));
  TF_copy_u8(&contents[342], (uint8_t)(app_manager->ais[85].min));
  TF_copy_u8(&contents[343], (uint8_t)(app_manager->ais[85].max));
  TF_copy_u8(&contents[344], (uint8_t)(app_manager->ais[86].init_duration));
  TF_copy_u8(&contents[345], (uint8_t)(app_manager->ais[86].prev));
  TF_copy_u8(&contents[346], (uint8_t)(app_manager->ais[86].min));
  TF_copy_u8(&contents[347], (uint8_t)(app_manager->ais[86].max));
  TF_copy_u8(&contents[348], (uint8_t)(app_manager->ais[87].init_duration));
  TF_copy_u8(&contents[349], (uint8_t)(app_manager->ais[87].prev));
  TF_copy_u8(&contents[350], (uint8_t)(app_manager->ais[87].min));
  TF_copy_u8(&contents[351], (uint8_t)(app_manager->ais[87].max));
  TF_copy_u8(&contents[352], (uint8_t)(app_manager->ais[88].init_duration));
  TF_copy_u8(&contents[353], (uint8_t)(app_manager->ais[88].prev));
  TF_copy_u8(&contents[354], (uint8_t)(app_manager->ais[88].min));
  TF_copy_u8(&contents[355], (uint8_t)(app_manager->ais[88].max));
  TF_copy_u8(&contents[356], (uint8_t)(app_manager->ais[89].init_duration));
  TF_copy_u8(&contents[357], (uint8_t)(app_manager->ais[89].prev));
  TF_copy_u8(&contents[358], (uint8_t)(app_manager->ais[89].min));
  TF_copy_u8(&contents[359], (uint8_t)(app_manager->ais[89].max));
  TF_copy_u8(&contents[360], (uint8_t)(app_manager->ais[90].init_duration));
  TF_copy_u8(&contents[361], (uint8_t)(app_manager->ais[90].prev));
  TF_copy_u8(&contents[362], (uint8_t)(app_manager->ais[90].min));
  TF_copy_u8(&contents[363], (uint8_t)(app_manager->ais[90].max));
  TF_copy_u8(&contents[364], (uint8_t)(app_manager->ais[91].init_duration));
  TF_copy_u8(&contents[365], (uint8_t)(app_manager->ais[91].prev));
  TF_copy_u8(&contents[366], (uint8_t)(app_manager->ais[91].min));
  TF_copy_u8(&contents[367], (uint8_t)(app_manager->ais[91].max));
  TF_copy_u8(&contents[368], (uint8_t)(app_manager->ais[92].init_duration));
  TF_copy_u8(&contents[369], (uint8_t)(app_manager->ais[92].prev));
  TF_copy_u8(&contents[370], (uint8_t)(app_manager->ais[92].min));
  TF_copy_u8(&contents[371], (uint8_t)(app_manager->ais[92].max));
  TF_copy_u8(&contents[372], (uint8_t)(app_manager->ais[93].init_duration));
  TF_copy_u8(&contents[373], (uint8_t)(app_manager->ais[93].prev));
  TF_copy_u8(&contents[374], (uint8_t)(app_manager->ais[93].min));
  TF_copy_u8(&contents[375], (uint8_t)(app_manager->ais[93].max));
  TF_copy_u8(&contents[376], (uint8_t)(app_manager->ais[94].init_duration));
  TF_copy_u8(&contents[377], (uint8_t)(app_manager->ais[94].prev));
  TF_copy_u8(&contents[378], (uint8_t)(app_manager->ais[94].min));
  TF_copy_u8(&contents[379], (uint8_t)(app_manager->ais[94].max));
  TF_copy_u8(&contents[380], (uint8_t)(app_manager->ais[95].init_duration));
  TF_copy_u8(&contents[381], (uint8_t)(app_manager->ais[95].prev));
  TF_copy_u8(&contents[382], (uint8_t)(app_manager->ais[95].min));
  TF_copy_u8(&contents[383], (uint8_t)(app_manager->ais[95].max));
  TF_copy_u8(&contents[384], (uint8_t)(app_manager->ais[96].init_duration));
  TF_copy_u8(&contents[385], (uint8_t)(app_manager->ais[96].prev));
  TF_copy_u8(&contents[386], (uint8_t)(app_manager->ais[96].min));
  TF_copy_u8(&contents[387], (uint8_t)(app_manager->ais[96].max));
  TF_copy_u8(&contents[388], (uint8_t)(app_manager->ais[97].init_duration));
  TF_copy_u8(&contents[389], (uint8_t)(app_manager->ais[97].prev));
  TF_copy_u8(&contents[390], (uint8_t)(app_manager->ais[97].min));
  TF_copy_u8(&contents[391], (uint8_t)(app_manager->ais[97].max));
  TF_copy_u8(&contents[392], (uint8_t)(app_manager->ais[98].init_duration));
  TF_copy_u8(&contents[393], (uint8_t)(app_manager->ais[98].prev));
  TF_copy_u8(&contents[394], (uint8_t)(app_manager->ais[98].min));
  TF_copy_u8(&contents[395], (uint8_t)(app_manager->ais[98].max));
  TF_copy_u8(&contents[396], (uint8_t)(app_manager->ais[99].init_duration));
  TF_copy_u8(&contents[397], (uint8_t)(app_manager->ais[99].prev));
  TF_copy_u8(&contents[398], (uint8_t)(app_manager->ais[99].min));
  TF_copy_u8(&contents[399], (uint8_t)(app_manager->ais[99].max));
#endif

  return 400;
}

static int Tlm_EL_(unsigned char* contents, int max_len)
{
  if (386 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u32(&contents[0], event_logger->statistics.record_counter_total);
  TF_copy_u32(&contents[4], event_logger->statistics.record_counters[EL_ERROR_LEVEL_HIGH]);
  TF_copy_u32(&contents[8], event_logger->statistics.record_counters[EL_ERROR_LEVEL_MIDDLE]);
  TF_copy_u32(&contents[12], event_logger->statistics.record_counters[EL_ERROR_LEVEL_LOW]);
  TF_copy_u32(&contents[16], event_logger->statistics.record_counters[EL_ERROR_LEVEL_EL]);
  TF_copy_u32(&contents[20], event_logger->statistics.record_counters[EL_ERROR_LEVEL_EH]);
  TF_copy_u8(&contents[24], event_logger->tlm_info.tlog.page_no);
  TF_copy_u8(&contents[25], (uint8_t)event_logger->tlm_info.tlog.err_level);
  TF_copy_u8(&contents[26], event_logger->tlm_info.clog.page_no);
  TF_copy_u8(&contents[27], (uint8_t)event_logger->tlm_info.clog.err_level);
  TF_copy_u32(&contents[28], (uint32_t)event_logger->latest_event.group);
  TF_copy_u32(&contents[32], event_logger->latest_event.local);
  TF_copy_u8(&contents[36], (uint8_t)event_logger->latest_event.err_level);
  TF_copy_u32(&contents[37], event_logger->latest_event.time.total_cycle);
  TF_copy_u8(&contents[41], (uint8_t)event_logger->latest_event.time.step);
  TF_copy_u32(&contents[42], event_logger->latest_event.note);
  TF_copy_u8(&contents[46], event_logger->is_logging_enable[0]);
  TF_copy_u8(&contents[47], event_logger->is_logging_enable[1]);
  TF_copy_u8(&contents[48], event_logger->is_logging_enable[2]);
  TF_copy_u8(&contents[49], event_logger->is_logging_enable[3]);
  TF_copy_u8(&contents[50], event_logger->is_logging_enable[4]);
  TF_copy_u8(&contents[51], event_logger->is_logging_enable[5]);
  TF_copy_u8(&contents[52], event_logger->is_logging_enable[6]);
  TF_copy_u8(&contents[53], event_logger->is_logging_enable[7]);
  TF_copy_u8(&contents[54], event_logger->is_logging_enable[8]);
  TF_copy_u8(&contents[55], event_logger->is_logging_enable[9]);
  TF_copy_u8(&contents[56], event_logger->is_logging_enable[10]);
  TF_copy_u8(&contents[57], event_logger->is_logging_enable[11]);
  TF_copy_u8(&contents[58], event_logger->is_logging_enable[12]);
  TF_copy_u8(&contents[59], event_logger->is_logging_enable[13]);
  TF_copy_u8(&contents[60], event_logger->is_logging_enable[14]);
  TF_copy_u8(&contents[61], event_logger->is_logging_enable[15]);
  TF_copy_u8(&contents[62], event_logger->is_logging_enable[16]);
  TF_copy_u8(&contents[63], event_logger->is_logging_enable[17]);
  TF_copy_u8(&contents[64], event_logger->is_logging_enable[18]);
  TF_copy_u8(&contents[65], event_logger->is_logging_enable[19]);
  TF_copy_u8(&contents[66], event_logger->is_logging_enable[20]);
  TF_copy_u8(&contents[67], event_logger->is_logging_enable[21]);
  TF_copy_u8(&contents[68], event_logger->is_logging_enable[22]);
  TF_copy_u8(&contents[69], event_logger->is_logging_enable[23]);
  TF_copy_u8(&contents[70], event_logger->is_logging_enable[24]);
  TF_copy_u8(&contents[71], event_logger->is_logging_enable[25]);
  TF_copy_u8(&contents[72], event_logger->is_logging_enable[26]);
  TF_copy_u8(&contents[73], event_logger->is_logging_enable[27]);
  TF_copy_u8(&contents[74], event_logger->is_logging_enable[28]);
  TF_copy_u8(&contents[75], event_logger->is_logging_enable[29]);
  TF_copy_u8(&contents[76], event_logger->is_logging_enable[30]);
  TF_copy_u8(&contents[77], event_logger->is_logging_enable[31]);
  TF_copy_u8(&contents[78], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->group);
  TF_copy_u32(&contents[79], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->local);
  TF_copy_u32(&contents[83], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->time.total_cycle);
  TF_copy_u8(&contents[87], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->time.step);
  TF_copy_u32(&contents[88], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->note);
  TF_copy_u8(&contents[92], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 1)->group);
  TF_copy_u32(&contents[93], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 1)->local);
  TF_copy_u32(&contents[97], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 1)->time.total_cycle);
  TF_copy_u8(&contents[101], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 1)->time.step);
  TF_copy_u32(&contents[102], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 1)->note);
  TF_copy_u8(&contents[106], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 2)->group);
  TF_copy_u32(&contents[107], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 2)->local);
  TF_copy_u32(&contents[111], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 2)->time.total_cycle);
  TF_copy_u8(&contents[115], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 2)->time.step);
  TF_copy_u32(&contents[116], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 2)->note);
  TF_copy_u8(&contents[120], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 3)->group);
  TF_copy_u32(&contents[121], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 3)->local);
  TF_copy_u32(&contents[125], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 3)->time.total_cycle);
  TF_copy_u8(&contents[129], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 3)->time.step);
  TF_copy_u32(&contents[130], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 3)->note);
  TF_copy_u8(&contents[134], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 0)->group);
  TF_copy_u32(&contents[135], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 0)->local);
  TF_copy_u32(&contents[139], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 0)->time.total_cycle);
  TF_copy_u8(&contents[143], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 0)->time.step);
  TF_copy_u32(&contents[144], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 0)->note);
  TF_copy_u8(&contents[148], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 1)->group);
  TF_copy_u32(&contents[149], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 1)->local);
  TF_copy_u32(&contents[153], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 1)->time.total_cycle);
  TF_copy_u8(&contents[157], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 1)->time.step);
  TF_copy_u32(&contents[158], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 1)->note);
  TF_copy_u8(&contents[162], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 2)->group);
  TF_copy_u32(&contents[163], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 2)->local);
  TF_copy_u32(&contents[167], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 2)->time.total_cycle);
  TF_copy_u8(&contents[171], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 2)->time.step);
  TF_copy_u32(&contents[172], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 2)->note);
  TF_copy_u8(&contents[176], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 3)->group);
  TF_copy_u32(&contents[177], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 3)->local);
  TF_copy_u32(&contents[181], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 3)->time.total_cycle);
  TF_copy_u8(&contents[185], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 3)->time.step);
  TF_copy_u32(&contents[186], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_MIDDLE, 3)->note);
  TF_copy_u8(&contents[190], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 0)->group);
  TF_copy_u32(&contents[191], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 0)->local);
  TF_copy_u32(&contents[195], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 0)->time.total_cycle);
  TF_copy_u8(&contents[199], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 0)->time.step);
  TF_copy_u32(&contents[200], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 0)->note);
  TF_copy_u8(&contents[204], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 1)->group);
  TF_copy_u32(&contents[205], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 1)->local);
  TF_copy_u32(&contents[209], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 1)->time.total_cycle);
  TF_copy_u8(&contents[213], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 1)->time.step);
  TF_copy_u32(&contents[214], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 1)->note);
  TF_copy_u8(&contents[218], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 2)->group);
  TF_copy_u32(&contents[219], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 2)->local);
  TF_copy_u32(&contents[223], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 2)->time.total_cycle);
  TF_copy_u8(&contents[227], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 2)->time.step);
  TF_copy_u32(&contents[228], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 2)->note);
  TF_copy_u8(&contents[232], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 3)->group);
  TF_copy_u32(&contents[233], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 3)->local);
  TF_copy_u32(&contents[237], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 3)->time.total_cycle);
  TF_copy_u8(&contents[241], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 3)->time.step);
  TF_copy_u32(&contents[242], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 3)->note);
  TF_copy_u8(&contents[246], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 4)->group);
  TF_copy_u32(&contents[247], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 4)->local);
  TF_copy_u32(&contents[251], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 4)->time.total_cycle);
  TF_copy_u8(&contents[255], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 4)->time.step);
  TF_copy_u32(&contents[256], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 4)->note);
  TF_copy_u8(&contents[260], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 5)->group);
  TF_copy_u32(&contents[261], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 5)->local);
  TF_copy_u32(&contents[265], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 5)->time.total_cycle);
  TF_copy_u8(&contents[269], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 5)->time.step);
  TF_copy_u32(&contents[270], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_LOW, 5)->note);
  TF_copy_u8(&contents[274], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 0)->group);
  TF_copy_u32(&contents[275], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 0)->local);
  TF_copy_u32(&contents[279], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 0)->time.total_cycle);
  TF_copy_u8(&contents[283], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 0)->time.step);
  TF_copy_u32(&contents[284], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 0)->note);
  TF_copy_u8(&contents[288], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 1)->group);
  TF_copy_u32(&contents[289], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 1)->local);
  TF_copy_u32(&contents[293], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 1)->time.total_cycle);
  TF_copy_u8(&contents[297], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 1)->time.step);
  TF_copy_u32(&contents[298], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 1)->note);
  TF_copy_u8(&contents[302], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 2)->group);
  TF_copy_u32(&contents[303], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 2)->local);
  TF_copy_u32(&contents[307], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 2)->time.total_cycle);
  TF_copy_u8(&contents[311], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 2)->time.step);
  TF_copy_u32(&contents[312], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 2)->note);
  TF_copy_u8(&contents[316], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 3)->group);
  TF_copy_u32(&contents[317], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 3)->local);
  TF_copy_u32(&contents[321], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 3)->time.total_cycle);
  TF_copy_u8(&contents[325], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 3)->time.step);
  TF_copy_u32(&contents[326], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EL, 3)->note);
  TF_copy_u8(&contents[330], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 0)->group);
  TF_copy_u32(&contents[331], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 0)->local);
  TF_copy_u32(&contents[335], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 0)->time.total_cycle);
  TF_copy_u8(&contents[339], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 0)->time.step);
  TF_copy_u32(&contents[340], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 0)->note);
  TF_copy_u8(&contents[344], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 1)->group);
  TF_copy_u32(&contents[345], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 1)->local);
  TF_copy_u32(&contents[349], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 1)->time.total_cycle);
  TF_copy_u8(&contents[353], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 1)->time.step);
  TF_copy_u32(&contents[354], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 1)->note);
  TF_copy_u8(&contents[358], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 2)->group);
  TF_copy_u32(&contents[359], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 2)->local);
  TF_copy_u32(&contents[363], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 2)->time.total_cycle);
  TF_copy_u8(&contents[367], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 2)->time.step);
  TF_copy_u32(&contents[368], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 2)->note);
  TF_copy_u8(&contents[372], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 3)->group);
  TF_copy_u32(&contents[373], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 3)->local);
  TF_copy_u32(&contents[377], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 3)->time.total_cycle);
  TF_copy_u8(&contents[381], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 3)->time.step);
  TF_copy_u32(&contents[382], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_EH, 3)->note);
#endif

  return 386;
}

static int Tlm_EL_TLOG_(unsigned char* contents, int max_len)
{
  EL_ERROR_LEVEL err_level = event_logger->tlm_info.tlog.err_level;
  uint16_t offset = EL_TLOG_TLM_PAGE_SIZE * event_logger->tlm_info.tlog.page_no;
  const EL_Event* events = event_logger->tlogs[err_level].events;

  if (410 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_logger->tlm_info.tlog.page_no);
  TF_copy_u8(&contents[1], (uint8_t)((err_level << 4 & 0xf0) | (event_logger->tlogs[err_level].is_enable_overwrite << 3 & 0x08) | ( event_logger->tlogs[err_level].is_table_overflow << 2 & 0x04)));
  TF_copy_u32(&contents[2], event_logger->statistics.record_counter_total);
  TF_copy_u32(&contents[6], event_logger->statistics.record_counters[err_level]);
  TF_copy_u16(&contents[10], event_logger->tlogs[err_level].log_capacity);
  TF_copy_u16(&contents[12], event_logger->tlogs[err_level].log_wp);
  TF_copy_u8(&contents[14], (uint8_t)events[offset+0].group);
  TF_copy_u32(&contents[15], events[offset+0].local);
  TF_copy_u32(&contents[19], events[offset+0].time.total_cycle);
  TF_copy_u8(&contents[23], (uint8_t)events[offset+0].time.step);
  TF_copy_u8(&contents[24], (uint8_t)events[offset+0].note);
  TF_copy_u8(&contents[25], (uint8_t)events[offset+1].group);
  TF_copy_u32(&contents[26], events[offset+1].local);
  TF_copy_u32(&contents[30], events[offset+1].time.total_cycle);
  TF_copy_u8(&contents[34], (uint8_t)events[offset+1].time.step);
  TF_copy_u8(&contents[35], (uint8_t)events[offset+1].note);
  TF_copy_u8(&contents[36], (uint8_t)events[offset+2].group);
  TF_copy_u32(&contents[37], events[offset+2].local);
  TF_copy_u32(&contents[41], events[offset+2].time.total_cycle);
  TF_copy_u8(&contents[45], (uint8_t)events[offset+2].time.step);
  TF_copy_u8(&contents[46], (uint8_t)events[offset+2].note);
  TF_copy_u8(&contents[47], (uint8_t)events[offset+3].group);
  TF_copy_u32(&contents[48], events[offset+3].local);
  TF_copy_u32(&contents[52], events[offset+3].time.total_cycle);
  TF_copy_u8(&contents[56], (uint8_t)events[offset+3].time.step);
  TF_copy_u8(&contents[57], (uint8_t)events[offset+3].note);
  TF_copy_u8(&contents[58], (uint8_t)events[offset+4].group);
  TF_copy_u32(&contents[59], events[offset+4].local);
  TF_copy_u32(&contents[63], events[offset+4].time.total_cycle);
  TF_copy_u8(&contents[67], (uint8_t)events[offset+4].time.step);
  TF_copy_u8(&contents[68], (uint8_t)events[offset+4].note);
  TF_copy_u8(&contents[69], (uint8_t)events[offset+5].group);
  TF_copy_u32(&contents[70], events[offset+5].local);
  TF_copy_u32(&contents[74], events[offset+5].time.total_cycle);
  TF_copy_u8(&contents[78], (uint8_t)events[offset+5].time.step);
  TF_copy_u8(&contents[79], (uint8_t)events[offset+5].note);
  TF_copy_u8(&contents[80], (uint8_t)events[offset+6].group);
  TF_copy_u32(&contents[81], events[offset+6].local);
  TF_copy_u32(&contents[85], events[offset+6].time.total_cycle);
  TF_copy_u8(&contents[89], (uint8_t)events[offset+6].time.step);
  TF_copy_u8(&contents[90], (uint8_t)events[offset+6].note);
  TF_copy_u8(&contents[91], (uint8_t)events[offset+7].group);
  TF_copy_u32(&contents[92], events[offset+7].local);
  TF_copy_u32(&contents[96], events[offset+7].time.total_cycle);
  TF_copy_u8(&contents[100], (uint8_t)events[offset+7].time.step);
  TF_copy_u8(&contents[101], (uint8_t)events[offset+7].note);
  TF_copy_u8(&contents[102], (uint8_t)events[offset+8].group);
  TF_copy_u32(&contents[103], events[offset+8].local);
  TF_copy_u32(&contents[107], events[offset+8].time.total_cycle);
  TF_copy_u8(&contents[111], (uint8_t)events[offset+8].time.step);
  TF_copy_u8(&contents[112], (uint8_t)events[offset+8].note);
  TF_copy_u8(&contents[113], (uint8_t)events[offset+9].group);
  TF_copy_u32(&contents[114], events[offset+9].local);
  TF_copy_u32(&contents[118], events[offset+9].time.total_cycle);
  TF_copy_u8(&contents[122], (uint8_t)events[offset+9].time.step);
  TF_copy_u8(&contents[123], (uint8_t)events[offset+9].note);
  TF_copy_u8(&contents[124], (uint8_t)events[offset+10].group);
  TF_copy_u32(&contents[125], events[offset+10].local);
  TF_copy_u32(&contents[129], events[offset+10].time.total_cycle);
  TF_copy_u8(&contents[133], (uint8_t)events[offset+10].time.step);
  TF_copy_u8(&contents[134], (uint8_t)events[offset+10].note);
  TF_copy_u8(&contents[135], (uint8_t)events[offset+11].group);
  TF_copy_u32(&contents[136], events[offset+11].local);
  TF_copy_u32(&contents[140], events[offset+11].time.total_cycle);
  TF_copy_u8(&contents[144], (uint8_t)events[offset+11].time.step);
  TF_copy_u8(&contents[145], (uint8_t)events[offset+11].note);
  TF_copy_u8(&contents[146], (uint8_t)events[offset+12].group);
  TF_copy_u32(&contents[147], events[offset+12].local);
  TF_copy_u32(&contents[151], events[offset+12].time.total_cycle);
  TF_copy_u8(&contents[155], (uint8_t)events[offset+12].time.step);
  TF_copy_u8(&contents[156], (uint8_t)events[offset+12].note);
  TF_copy_u8(&contents[157], (uint8_t)events[offset+13].group);
  TF_copy_u32(&contents[158], events[offset+13].local);
  TF_copy_u32(&contents[162], events[offset+13].time.total_cycle);
  TF_copy_u8(&contents[166], (uint8_t)events[offset+13].time.step);
  TF_copy_u8(&contents[167], (uint8_t)events[offset+13].note);
  TF_copy_u8(&contents[168], (uint8_t)events[offset+14].group);
  TF_copy_u32(&contents[169], events[offset+14].local);
  TF_copy_u32(&contents[173], events[offset+14].time.total_cycle);
  TF_copy_u8(&contents[177], (uint8_t)events[offset+14].time.step);
  TF_copy_u8(&contents[178], (uint8_t)events[offset+14].note);
  TF_copy_u8(&contents[179], (uint8_t)events[offset+15].group);
  TF_copy_u32(&contents[180], events[offset+15].local);
  TF_copy_u32(&contents[184], events[offset+15].time.total_cycle);
  TF_copy_u8(&contents[188], (uint8_t)events[offset+15].time.step);
  TF_copy_u8(&contents[189], (uint8_t)events[offset+15].note);
  TF_copy_u8(&contents[190], (uint8_t)events[offset+16].group);
  TF_copy_u32(&contents[191], events[offset+16].local);
  TF_copy_u32(&contents[195], events[offset+16].time.total_cycle);
  TF_copy_u8(&contents[199], (uint8_t)events[offset+16].time.step);
  TF_copy_u8(&contents[200], (uint8_t)events[offset+16].note);
  TF_copy_u8(&contents[201], (uint8_t)events[offset+17].group);
  TF_copy_u32(&contents[202], events[offset+17].local);
  TF_copy_u32(&contents[206], events[offset+17].time.total_cycle);
  TF_copy_u8(&contents[210], (uint8_t)events[offset+17].time.step);
  TF_copy_u8(&contents[211], (uint8_t)events[offset+17].note);
  TF_copy_u8(&contents[212], (uint8_t)events[offset+18].group);
  TF_copy_u32(&contents[213], events[offset+18].local);
  TF_copy_u32(&contents[217], events[offset+18].time.total_cycle);
  TF_copy_u8(&contents[221], (uint8_t)events[offset+18].time.step);
  TF_copy_u8(&contents[222], (uint8_t)events[offset+18].note);
  TF_copy_u8(&contents[223], (uint8_t)events[offset+19].group);
  TF_copy_u32(&contents[224], events[offset+19].local);
  TF_copy_u32(&contents[228], events[offset+19].time.total_cycle);
  TF_copy_u8(&contents[232], (uint8_t)events[offset+19].time.step);
  TF_copy_u8(&contents[233], (uint8_t)events[offset+19].note);
  TF_copy_u8(&contents[234], (uint8_t)events[offset+20].group);
  TF_copy_u32(&contents[235], events[offset+20].local);
  TF_copy_u32(&contents[239], events[offset+20].time.total_cycle);
  TF_copy_u8(&contents[243], (uint8_t)events[offset+20].time.step);
  TF_copy_u8(&contents[244], (uint8_t)events[offset+20].note);
  TF_copy_u8(&contents[245], (uint8_t)events[offset+21].group);
  TF_copy_u32(&contents[246], events[offset+21].local);
  TF_copy_u32(&contents[250], events[offset+21].time.total_cycle);
  TF_copy_u8(&contents[254], (uint8_t)events[offset+21].time.step);
  TF_copy_u8(&contents[255], (uint8_t)events[offset+21].note);
  TF_copy_u8(&contents[256], (uint8_t)events[offset+22].group);
  TF_copy_u32(&contents[257], events[offset+22].local);
  TF_copy_u32(&contents[261], events[offset+22].time.total_cycle);
  TF_copy_u8(&contents[265], (uint8_t)events[offset+22].time.step);
  TF_copy_u8(&contents[266], (uint8_t)events[offset+22].note);
  TF_copy_u8(&contents[267], (uint8_t)events[offset+23].group);
  TF_copy_u32(&contents[268], events[offset+23].local);
  TF_copy_u32(&contents[272], events[offset+23].time.total_cycle);
  TF_copy_u8(&contents[276], (uint8_t)events[offset+23].time.step);
  TF_copy_u8(&contents[277], (uint8_t)events[offset+23].note);
  TF_copy_u8(&contents[278], (uint8_t)events[offset+24].group);
  TF_copy_u32(&contents[279], events[offset+24].local);
  TF_copy_u32(&contents[283], events[offset+24].time.total_cycle);
  TF_copy_u8(&contents[287], (uint8_t)events[offset+24].time.step);
  TF_copy_u8(&contents[288], (uint8_t)events[offset+24].note);
  TF_copy_u8(&contents[289], (uint8_t)events[offset+25].group);
  TF_copy_u32(&contents[290], events[offset+25].local);
  TF_copy_u32(&contents[294], events[offset+25].time.total_cycle);
  TF_copy_u8(&contents[298], (uint8_t)events[offset+25].time.step);
  TF_copy_u8(&contents[299], (uint8_t)events[offset+25].note);
  TF_copy_u8(&contents[300], (uint8_t)events[offset+26].group);
  TF_copy_u32(&contents[301], events[offset+26].local);
  TF_copy_u32(&contents[305], events[offset+26].time.total_cycle);
  TF_copy_u8(&contents[309], (uint8_t)events[offset+26].time.step);
  TF_copy_u8(&contents[310], (uint8_t)events[offset+26].note);
  TF_copy_u8(&contents[311], (uint8_t)events[offset+27].group);
  TF_copy_u32(&contents[312], events[offset+27].local);
  TF_copy_u32(&contents[316], events[offset+27].time.total_cycle);
  TF_copy_u8(&contents[320], (uint8_t)events[offset+27].time.step);
  TF_copy_u8(&contents[321], (uint8_t)events[offset+27].note);
  TF_copy_u8(&contents[322], (uint8_t)events[offset+28].group);
  TF_copy_u32(&contents[323], events[offset+28].local);
  TF_copy_u32(&contents[327], events[offset+28].time.total_cycle);
  TF_copy_u8(&contents[331], (uint8_t)events[offset+28].time.step);
  TF_copy_u8(&contents[332], (uint8_t)events[offset+28].note);
  TF_copy_u8(&contents[333], (uint8_t)events[offset+29].group);
  TF_copy_u32(&contents[334], events[offset+29].local);
  TF_copy_u32(&contents[338], events[offset+29].time.total_cycle);
  TF_copy_u8(&contents[342], (uint8_t)events[offset+29].time.step);
  TF_copy_u8(&contents[343], (uint8_t)events[offset+29].note);
  TF_copy_u8(&contents[344], (uint8_t)events[offset+30].group);
  TF_copy_u32(&contents[345], events[offset+30].local);
  TF_copy_u32(&contents[349], events[offset+30].time.total_cycle);
  TF_copy_u8(&contents[353], (uint8_t)events[offset+30].time.step);
  TF_copy_u8(&contents[354], (uint8_t)events[offset+30].note);
  TF_copy_u8(&contents[355], (uint8_t)events[offset+31].group);
  TF_copy_u32(&contents[356], events[offset+31].local);
  TF_copy_u32(&contents[360], events[offset+31].time.total_cycle);
  TF_copy_u8(&contents[364], (uint8_t)events[offset+31].time.step);
  TF_copy_u8(&contents[365], (uint8_t)events[offset+31].note);
  TF_copy_u8(&contents[366], (uint8_t)events[offset+32].group);
  TF_copy_u32(&contents[367], events[offset+32].local);
  TF_copy_u32(&contents[371], events[offset+32].time.total_cycle);
  TF_copy_u8(&contents[375], (uint8_t)events[offset+32].time.step);
  TF_copy_u8(&contents[376], (uint8_t)events[offset+32].note);
  TF_copy_u8(&contents[377], (uint8_t)events[offset+33].group);
  TF_copy_u32(&contents[378], events[offset+33].local);
  TF_copy_u32(&contents[382], events[offset+33].time.total_cycle);
  TF_copy_u8(&contents[386], (uint8_t)events[offset+33].time.step);
  TF_copy_u8(&contents[387], (uint8_t)events[offset+33].note);
  TF_copy_u8(&contents[388], (uint8_t)events[offset+34].group);
  TF_copy_u32(&contents[389], events[offset+34].local);
  TF_copy_u32(&contents[393], events[offset+34].time.total_cycle);
  TF_copy_u8(&contents[397], (uint8_t)events[offset+34].time.step);
  TF_copy_u8(&contents[398], (uint8_t)events[offset+34].note);
  TF_copy_u8(&contents[399], (uint8_t)events[offset+35].group);
  TF_copy_u32(&contents[400], events[offset+35].local);
  TF_copy_u32(&contents[404], events[offset+35].time.total_cycle);
  TF_copy_u8(&contents[408], (uint8_t)events[offset+35].time.step);
  TF_copy_u8(&contents[409], (uint8_t)events[offset+35].note);
#endif

  return 410;
}

static int Tlm_EL_CLOG_(unsigned char* contents, int max_len)
{
  EL_ERROR_LEVEL err_level = event_logger->tlm_info.clog.err_level;
  uint16_t offset = EL_CLOG_TLM_PAGE_SIZE * event_logger->tlm_info.clog.page_no;
  const uint16_t* log_orders = event_logger->clogs[err_level].log_orders;
  const EL_CLogElement* logs = event_logger->clogs[err_level].logs;

  if (408 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_logger->tlm_info.clog.page_no);
  TF_copy_u8(&contents[1], (uint8_t)err_level);
  TF_copy_u32(&contents[2], event_logger->statistics.record_counter_total);
  TF_copy_u32(&contents[6], event_logger->statistics.record_counters[err_level]);
  TF_copy_u16(&contents[10], event_logger->clogs[err_level].log_capacity);
  TF_copy_u8(&contents[12], (uint8_t)logs[log_orders[offset+0]].event.group);
  TF_copy_u32(&contents[13], logs[log_orders[offset+0]].event.local);
  TF_copy_u32(&contents[17], logs[log_orders[offset+0]].event.time.total_cycle);
  TF_copy_u8(&contents[21], (uint8_t)logs[log_orders[offset+0]].event.time.step);
  TF_copy_u8(&contents[22], (uint8_t)logs[log_orders[offset+0]].event.note);
  TF_copy_u16(&contents[23], logs[log_orders[offset+0]].count);
  TF_copy_u32(&contents[25], logs[log_orders[offset+0]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[29], (uint8_t)logs[log_orders[offset+0]].delta_record_time.step);
  TF_copy_u8(&contents[30], (uint8_t)logs[log_orders[offset+1]].event.group);
  TF_copy_u32(&contents[31], logs[log_orders[offset+1]].event.local);
  TF_copy_u32(&contents[35], logs[log_orders[offset+1]].event.time.total_cycle);
  TF_copy_u8(&contents[39], (uint8_t)logs[log_orders[offset+1]].event.time.step);
  TF_copy_u8(&contents[40], (uint8_t)logs[log_orders[offset+1]].event.note);
  TF_copy_u16(&contents[41], logs[log_orders[offset+1]].count);
  TF_copy_u32(&contents[43], logs[log_orders[offset+1]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[47], (uint8_t)logs[log_orders[offset+1]].delta_record_time.step);
  TF_copy_u8(&contents[48], (uint8_t)logs[log_orders[offset+2]].event.group);
  TF_copy_u32(&contents[49], logs[log_orders[offset+2]].event.local);
  TF_copy_u32(&contents[53], logs[log_orders[offset+2]].event.time.total_cycle);
  TF_copy_u8(&contents[57], (uint8_t)logs[log_orders[offset+2]].event.time.step);
  TF_copy_u8(&contents[58], (uint8_t)logs[log_orders[offset+2]].event.note);
  TF_copy_u16(&contents[59], logs[log_orders[offset+2]].count);
  TF_copy_u32(&contents[61], logs[log_orders[offset+2]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[65], (uint8_t)logs[log_orders[offset+2]].delta_record_time.step);
  TF_copy_u8(&contents[66], (uint8_t)logs[log_orders[offset+3]].event.group);
  TF_copy_u32(&contents[67], logs[log_orders[offset+3]].event.local);
  TF_copy_u32(&contents[71], logs[log_orders[offset+3]].event.time.total_cycle);
  TF_copy_u8(&contents[75], (uint8_t)logs[log_orders[offset+3]].event.time.step);
  TF_copy_u8(&contents[76], (uint8_t)logs[log_orders[offset+3]].event.note);
  TF_copy_u16(&contents[77], logs[log_orders[offset+3]].count);
  TF_copy_u32(&contents[79], logs[log_orders[offset+3]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[83], (uint8_t)logs[log_orders[offset+3]].delta_record_time.step);
  TF_copy_u8(&contents[84], (uint8_t)logs[log_orders[offset+4]].event.group);
  TF_copy_u32(&contents[85], logs[log_orders[offset+4]].event.local);
  TF_copy_u32(&contents[89], logs[log_orders[offset+4]].event.time.total_cycle);
  TF_copy_u8(&contents[93], (uint8_t)logs[log_orders[offset+4]].event.time.step);
  TF_copy_u8(&contents[94], (uint8_t)logs[log_orders[offset+4]].event.note);
  TF_copy_u16(&contents[95], logs[log_orders[offset+4]].count);
  TF_copy_u32(&contents[97], logs[log_orders[offset+4]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[101], (uint8_t)logs[log_orders[offset+4]].delta_record_time.step);
  TF_copy_u8(&contents[102], (uint8_t)logs[log_orders[offset+5]].event.group);
  TF_copy_u32(&contents[103], logs[log_orders[offset+5]].event.local);
  TF_copy_u32(&contents[107], logs[log_orders[offset+5]].event.time.total_cycle);
  TF_copy_u8(&contents[111], (uint8_t)logs[log_orders[offset+5]].event.time.step);
  TF_copy_u8(&contents[112], (uint8_t)logs[log_orders[offset+5]].event.note);
  TF_copy_u16(&contents[113], logs[log_orders[offset+5]].count);
  TF_copy_u32(&contents[115], logs[log_orders[offset+5]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[119], (uint8_t)logs[log_orders[offset+5]].delta_record_time.step);
  TF_copy_u8(&contents[120], (uint8_t)logs[log_orders[offset+6]].event.group);
  TF_copy_u32(&contents[121], logs[log_orders[offset+6]].event.local);
  TF_copy_u32(&contents[125], logs[log_orders[offset+6]].event.time.total_cycle);
  TF_copy_u8(&contents[129], (uint8_t)logs[log_orders[offset+6]].event.time.step);
  TF_copy_u8(&contents[130], (uint8_t)logs[log_orders[offset+6]].event.note);
  TF_copy_u16(&contents[131], logs[log_orders[offset+6]].count);
  TF_copy_u32(&contents[133], logs[log_orders[offset+6]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[137], (uint8_t)logs[log_orders[offset+6]].delta_record_time.step);
  TF_copy_u8(&contents[138], (uint8_t)logs[log_orders[offset+7]].event.group);
  TF_copy_u32(&contents[139], logs[log_orders[offset+7]].event.local);
  TF_copy_u32(&contents[143], logs[log_orders[offset+7]].event.time.total_cycle);
  TF_copy_u8(&contents[147], (uint8_t)logs[log_orders[offset+7]].event.time.step);
  TF_copy_u8(&contents[148], (uint8_t)logs[log_orders[offset+7]].event.note);
  TF_copy_u16(&contents[149], logs[log_orders[offset+7]].count);
  TF_copy_u32(&contents[151], logs[log_orders[offset+7]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[155], (uint8_t)logs[log_orders[offset+7]].delta_record_time.step);
  TF_copy_u8(&contents[156], (uint8_t)logs[log_orders[offset+8]].event.group);
  TF_copy_u32(&contents[157], logs[log_orders[offset+8]].event.local);
  TF_copy_u32(&contents[161], logs[log_orders[offset+8]].event.time.total_cycle);
  TF_copy_u8(&contents[165], (uint8_t)logs[log_orders[offset+8]].event.time.step);
  TF_copy_u8(&contents[166], (uint8_t)logs[log_orders[offset+8]].event.note);
  TF_copy_u16(&contents[167], logs[log_orders[offset+8]].count);
  TF_copy_u32(&contents[169], logs[log_orders[offset+8]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[173], (uint8_t)logs[log_orders[offset+8]].delta_record_time.step);
  TF_copy_u8(&contents[174], (uint8_t)logs[log_orders[offset+9]].event.group);
  TF_copy_u32(&contents[175], logs[log_orders[offset+9]].event.local);
  TF_copy_u32(&contents[179], logs[log_orders[offset+9]].event.time.total_cycle);
  TF_copy_u8(&contents[183], (uint8_t)logs[log_orders[offset+9]].event.time.step);
  TF_copy_u8(&contents[184], (uint8_t)logs[log_orders[offset+9]].event.note);
  TF_copy_u16(&contents[185], logs[log_orders[offset+9]].count);
  TF_copy_u32(&contents[187], logs[log_orders[offset+9]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[191], (uint8_t)logs[log_orders[offset+9]].delta_record_time.step);
  TF_copy_u8(&contents[192], (uint8_t)logs[log_orders[offset+10]].event.group);
  TF_copy_u32(&contents[193], logs[log_orders[offset+10]].event.local);
  TF_copy_u32(&contents[197], logs[log_orders[offset+10]].event.time.total_cycle);
  TF_copy_u8(&contents[201], (uint8_t)logs[log_orders[offset+10]].event.time.step);
  TF_copy_u8(&contents[202], (uint8_t)logs[log_orders[offset+10]].event.note);
  TF_copy_u16(&contents[203], logs[log_orders[offset+10]].count);
  TF_copy_u32(&contents[205], logs[log_orders[offset+10]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[209], (uint8_t)logs[log_orders[offset+10]].delta_record_time.step);
  TF_copy_u8(&contents[210], (uint8_t)logs[log_orders[offset+11]].event.group);
  TF_copy_u32(&contents[211], logs[log_orders[offset+11]].event.local);
  TF_copy_u32(&contents[215], logs[log_orders[offset+11]].event.time.total_cycle);
  TF_copy_u8(&contents[219], (uint8_t)logs[log_orders[offset+11]].event.time.step);
  TF_copy_u8(&contents[220], (uint8_t)logs[log_orders[offset+11]].event.note);
  TF_copy_u16(&contents[221], logs[log_orders[offset+11]].count);
  TF_copy_u32(&contents[223], logs[log_orders[offset+11]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[227], (uint8_t)logs[log_orders[offset+11]].delta_record_time.step);
  TF_copy_u8(&contents[228], (uint8_t)logs[log_orders[offset+12]].event.group);
  TF_copy_u32(&contents[229], logs[log_orders[offset+12]].event.local);
  TF_copy_u32(&contents[233], logs[log_orders[offset+12]].event.time.total_cycle);
  TF_copy_u8(&contents[237], (uint8_t)logs[log_orders[offset+12]].event.time.step);
  TF_copy_u8(&contents[238], (uint8_t)logs[log_orders[offset+12]].event.note);
  TF_copy_u16(&contents[239], logs[log_orders[offset+12]].count);
  TF_copy_u32(&contents[241], logs[log_orders[offset+12]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[245], (uint8_t)logs[log_orders[offset+12]].delta_record_time.step);
  TF_copy_u8(&contents[246], (uint8_t)logs[log_orders[offset+13]].event.group);
  TF_copy_u32(&contents[247], logs[log_orders[offset+13]].event.local);
  TF_copy_u32(&contents[251], logs[log_orders[offset+13]].event.time.total_cycle);
  TF_copy_u8(&contents[255], (uint8_t)logs[log_orders[offset+13]].event.time.step);
  TF_copy_u8(&contents[256], (uint8_t)logs[log_orders[offset+13]].event.note);
  TF_copy_u16(&contents[257], logs[log_orders[offset+13]].count);
  TF_copy_u32(&contents[259], logs[log_orders[offset+13]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[263], (uint8_t)logs[log_orders[offset+13]].delta_record_time.step);
  TF_copy_u8(&contents[264], (uint8_t)logs[log_orders[offset+14]].event.group);
  TF_copy_u32(&contents[265], logs[log_orders[offset+14]].event.local);
  TF_copy_u32(&contents[269], logs[log_orders[offset+14]].event.time.total_cycle);
  TF_copy_u8(&contents[273], (uint8_t)logs[log_orders[offset+14]].event.time.step);
  TF_copy_u8(&contents[274], (uint8_t)logs[log_orders[offset+14]].event.note);
  TF_copy_u16(&contents[275], logs[log_orders[offset+14]].count);
  TF_copy_u32(&contents[277], logs[log_orders[offset+14]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[281], (uint8_t)logs[log_orders[offset+14]].delta_record_time.step);
  TF_copy_u8(&contents[282], (uint8_t)logs[log_orders[offset+15]].event.group);
  TF_copy_u32(&contents[283], logs[log_orders[offset+15]].event.local);
  TF_copy_u32(&contents[287], logs[log_orders[offset+15]].event.time.total_cycle);
  TF_copy_u8(&contents[291], (uint8_t)logs[log_orders[offset+15]].event.time.step);
  TF_copy_u8(&contents[292], (uint8_t)logs[log_orders[offset+15]].event.note);
  TF_copy_u16(&contents[293], logs[log_orders[offset+15]].count);
  TF_copy_u32(&contents[295], logs[log_orders[offset+15]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[299], (uint8_t)logs[log_orders[offset+15]].delta_record_time.step);
  TF_copy_u8(&contents[300], (uint8_t)logs[log_orders[offset+16]].event.group);
  TF_copy_u32(&contents[301], logs[log_orders[offset+16]].event.local);
  TF_copy_u32(&contents[305], logs[log_orders[offset+16]].event.time.total_cycle);
  TF_copy_u8(&contents[309], (uint8_t)logs[log_orders[offset+16]].event.time.step);
  TF_copy_u8(&contents[310], (uint8_t)logs[log_orders[offset+16]].event.note);
  TF_copy_u16(&contents[311], logs[log_orders[offset+16]].count);
  TF_copy_u32(&contents[313], logs[log_orders[offset+16]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[317], (uint8_t)logs[log_orders[offset+16]].delta_record_time.step);
  TF_copy_u8(&contents[318], (uint8_t)logs[log_orders[offset+17]].event.group);
  TF_copy_u32(&contents[319], logs[log_orders[offset+17]].event.local);
  TF_copy_u32(&contents[323], logs[log_orders[offset+17]].event.time.total_cycle);
  TF_copy_u8(&contents[327], (uint8_t)logs[log_orders[offset+17]].event.time.step);
  TF_copy_u8(&contents[328], (uint8_t)logs[log_orders[offset+17]].event.note);
  TF_copy_u16(&contents[329], logs[log_orders[offset+17]].count);
  TF_copy_u32(&contents[331], logs[log_orders[offset+17]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[335], (uint8_t)logs[log_orders[offset+17]].delta_record_time.step);
  TF_copy_u8(&contents[336], (uint8_t)logs[log_orders[offset+18]].event.group);
  TF_copy_u32(&contents[337], logs[log_orders[offset+18]].event.local);
  TF_copy_u32(&contents[341], logs[log_orders[offset+18]].event.time.total_cycle);
  TF_copy_u8(&contents[345], (uint8_t)logs[log_orders[offset+18]].event.time.step);
  TF_copy_u8(&contents[346], (uint8_t)logs[log_orders[offset+18]].event.note);
  TF_copy_u16(&contents[347], logs[log_orders[offset+18]].count);
  TF_copy_u32(&contents[349], logs[log_orders[offset+18]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[353], (uint8_t)logs[log_orders[offset+18]].delta_record_time.step);
  TF_copy_u8(&contents[354], (uint8_t)logs[log_orders[offset+19]].event.group);
  TF_copy_u32(&contents[355], logs[log_orders[offset+19]].event.local);
  TF_copy_u32(&contents[359], logs[log_orders[offset+19]].event.time.total_cycle);
  TF_copy_u8(&contents[363], (uint8_t)logs[log_orders[offset+19]].event.time.step);
  TF_copy_u8(&contents[364], (uint8_t)logs[log_orders[offset+19]].event.note);
  TF_copy_u16(&contents[365], logs[log_orders[offset+19]].count);
  TF_copy_u32(&contents[367], logs[log_orders[offset+19]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[371], (uint8_t)logs[log_orders[offset+19]].delta_record_time.step);
  TF_copy_u8(&contents[372], (uint8_t)logs[log_orders[offset+20]].event.group);
  TF_copy_u32(&contents[373], logs[log_orders[offset+20]].event.local);
  TF_copy_u32(&contents[377], logs[log_orders[offset+20]].event.time.total_cycle);
  TF_copy_u8(&contents[381], (uint8_t)logs[log_orders[offset+20]].event.time.step);
  TF_copy_u8(&contents[382], (uint8_t)logs[log_orders[offset+20]].event.note);
  TF_copy_u16(&contents[383], logs[log_orders[offset+20]].count);
  TF_copy_u32(&contents[385], logs[log_orders[offset+20]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[389], (uint8_t)logs[log_orders[offset+20]].delta_record_time.step);
  TF_copy_u8(&contents[390], (uint8_t)logs[log_orders[offset+21]].event.group);
  TF_copy_u32(&contents[391], logs[log_orders[offset+21]].event.local);
  TF_copy_u32(&contents[395], logs[log_orders[offset+21]].event.time.total_cycle);
  TF_copy_u8(&contents[399], (uint8_t)logs[log_orders[offset+21]].event.time.step);
  TF_copy_u8(&contents[400], (uint8_t)logs[log_orders[offset+21]].event.note);
  TF_copy_u16(&contents[401], logs[log_orders[offset+21]].count);
  TF_copy_u32(&contents[403], logs[log_orders[offset+21]].delta_record_time.total_cycle);
  TF_copy_u8(&contents[407], (uint8_t)logs[log_orders[offset+21]].delta_record_time.step);
#endif

  return 408;
}

static int Tlm_EH_(unsigned char* contents, int max_len)
{
  if (74 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_utility->is_enabled_eh_execution);
  TF_copy_u32(&contents[1], event_handler->el_event_counter.counter_total);
  TF_copy_u32(&contents[5], event_handler->el_event_counter.counters[EL_ERROR_LEVEL_HIGH]);
  TF_copy_u32(&contents[9], event_handler->el_event_counter.counters[EL_ERROR_LEVEL_MIDDLE]);
  TF_copy_u32(&contents[13], event_handler->el_event_counter.counters[EL_ERROR_LEVEL_LOW]);
  TF_copy_u32(&contents[17], event_handler->el_event_counter.counters[EL_ERROR_LEVEL_EL]);
  TF_copy_u32(&contents[21], event_handler->el_event_counter.counters[EL_ERROR_LEVEL_EH]);
  TF_copy_u32(&contents[25], event_handler->log_table.respond_counter);
  TF_copy_u16(&contents[29], event_handler->log_table.log_wp);
  TF_copy_u8(&contents[31], event_handler->max_response_num);
  TF_copy_u16(&contents[32], event_handler->max_check_event_num);
  TF_copy_u8(&contents[34], (uint8_t)event_handler->reg_from_cmd.rule_id);
  TF_copy_u8(&contents[35], (uint8_t)event_handler->reg_from_cmd.settings.event.group);
  TF_copy_u32(&contents[36], event_handler->reg_from_cmd.settings.event.local);
  TF_copy_u8(&contents[40], (uint8_t)((((uint8_t)event_handler->reg_from_cmd.settings.event.err_level) << 5 & 0xe0) | (event_handler->reg_from_cmd.settings.should_match_err_level << 4 & 0x10) | (event_handler->reg_from_cmd.settings.is_active << 3 & 0x08) | (((uint8_t)event_handler->reg_from_cmd.settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[41], event_handler->reg_from_cmd.settings.condition.count_threshold);
  TF_copy_u32(&contents[43], event_handler->reg_from_cmd.settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[47], (uint16_t)event_handler->reg_from_cmd.settings.deploy_bct_id);
  TF_copy_u8(&contents[49], (uint8_t)event_handler->reg_from_cmd.register_ack);
  TF_copy_u8(&contents[50], event_handler->tlm_info.rule.page_no);
  TF_copy_u8(&contents[51], (uint8_t)event_handler->tlm_info.rule.target_rule_id);
  TF_copy_u8(&contents[52], event_handler->tlm_info.rule_sorted_index.page_no);
  TF_copy_u8(&contents[53], event_handler->tlm_info.log.page_no);
  TF_copy_u8(&contents[54], (uint8_t)event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.event.group);
  TF_copy_u32(&contents[55], event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.event.local);
  TF_copy_u8(&contents[59], (uint8_t)((((uint8_t)event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.event.err_level) << 5 & 0xe0) | (event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.should_match_err_level << 4 & 0x10) | (event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.is_active << 3 & 0x08) | (((uint8_t)event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[60], event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.condition.count_threshold);
  TF_copy_u32(&contents[62], event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[66], (uint16_t)event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].settings.deploy_bct_id);
  TF_copy_u16(&contents[68], event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].counter);
  TF_copy_u32(&contents[70], (uint32_t)event_handler->rule_table.rules[event_handler->tlm_info.rule.target_rule_id].last_event_time.total_cycle);
#endif

  return 74;
}

static int Tlm_EH_RULE_(unsigned char* contents, int max_len)
{
  uint16_t offset = event_handler->tlm_info.rule.page_no * EH_RULE_TLM_PAGE_SIZE;
  const EH_Rule* rules = event_handler->rule_table.rules;

  if (403 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_handler->tlm_info.rule.page_no);
  TF_copy_u16(&contents[1], event_handler->rule_table.registered_rule_num);
  TF_copy_u8(&contents[3], (uint8_t)rules[0 + offset].settings.event.group);
  TF_copy_u32(&contents[4], rules[0 + offset].settings.event.local);
  TF_copy_u8(&contents[8], (uint8_t)((((uint8_t)rules[0 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[0 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[0 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[0 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[9], rules[0 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[11], rules[0 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[15], (uint16_t)rules[0 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[17], rules[0 + offset].counter);
  TF_copy_u32(&contents[19], (uint32_t)rules[0 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[23], (uint8_t)rules[1 + offset].settings.event.group);
  TF_copy_u32(&contents[24], rules[1 + offset].settings.event.local);
  TF_copy_u8(&contents[28], (uint8_t)((((uint8_t)rules[1 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[1 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[1 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[1 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[29], rules[1 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[31], rules[1 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[35], (uint16_t)rules[1 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[37], rules[1 + offset].counter);
  TF_copy_u32(&contents[39], (uint32_t)rules[1 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[43], (uint8_t)rules[2 + offset].settings.event.group);
  TF_copy_u32(&contents[44], rules[2 + offset].settings.event.local);
  TF_copy_u8(&contents[48], (uint8_t)((((uint8_t)rules[2 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[2 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[2 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[2 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[49], rules[2 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[51], rules[2 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[55], (uint16_t)rules[2 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[57], rules[2 + offset].counter);
  TF_copy_u32(&contents[59], (uint32_t)rules[2 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[63], (uint8_t)rules[3 + offset].settings.event.group);
  TF_copy_u32(&contents[64], rules[3 + offset].settings.event.local);
  TF_copy_u8(&contents[68], (uint8_t)((((uint8_t)rules[3 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[3 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[3 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[3 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[69], rules[3 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[71], rules[3 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[75], (uint16_t)rules[3 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[77], rules[3 + offset].counter);
  TF_copy_u32(&contents[79], (uint32_t)rules[3 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[83], (uint8_t)rules[4 + offset].settings.event.group);
  TF_copy_u32(&contents[84], rules[4 + offset].settings.event.local);
  TF_copy_u8(&contents[88], (uint8_t)((((uint8_t)rules[4 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[4 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[4 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[4 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[89], rules[4 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[91], rules[4 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[95], (uint16_t)rules[4 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[97], rules[4 + offset].counter);
  TF_copy_u32(&contents[99], (uint32_t)rules[4 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[103], (uint8_t)rules[5 + offset].settings.event.group);
  TF_copy_u32(&contents[104], rules[5 + offset].settings.event.local);
  TF_copy_u8(&contents[108], (uint8_t)((((uint8_t)rules[5 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[5 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[5 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[5 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[109], rules[5 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[111], rules[5 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[115], (uint16_t)rules[5 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[117], rules[5 + offset].counter);
  TF_copy_u32(&contents[119], (uint32_t)rules[5 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[123], (uint8_t)rules[6 + offset].settings.event.group);
  TF_copy_u32(&contents[124], rules[6 + offset].settings.event.local);
  TF_copy_u8(&contents[128], (uint8_t)((((uint8_t)rules[6 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[6 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[6 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[6 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[129], rules[6 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[131], rules[6 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[135], (uint16_t)rules[6 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[137], rules[6 + offset].counter);
  TF_copy_u32(&contents[139], (uint32_t)rules[6 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[143], (uint8_t)rules[7 + offset].settings.event.group);
  TF_copy_u32(&contents[144], rules[7 + offset].settings.event.local);
  TF_copy_u8(&contents[148], (uint8_t)((((uint8_t)rules[7 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[7 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[7 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[7 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[149], rules[7 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[151], rules[7 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[155], (uint16_t)rules[7 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[157], rules[7 + offset].counter);
  TF_copy_u32(&contents[159], (uint32_t)rules[7 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[163], (uint8_t)rules[8 + offset].settings.event.group);
  TF_copy_u32(&contents[164], rules[8 + offset].settings.event.local);
  TF_copy_u8(&contents[168], (uint8_t)((((uint8_t)rules[8 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[8 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[8 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[8 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[169], rules[8 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[171], rules[8 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[175], (uint16_t)rules[8 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[177], rules[8 + offset].counter);
  TF_copy_u32(&contents[179], (uint32_t)rules[8 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[183], (uint8_t)rules[9 + offset].settings.event.group);
  TF_copy_u32(&contents[184], rules[9 + offset].settings.event.local);
  TF_copy_u8(&contents[188], (uint8_t)((((uint8_t)rules[9 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[9 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[9 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[9 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[189], rules[9 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[191], rules[9 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[195], (uint16_t)rules[9 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[197], rules[9 + offset].counter);
  TF_copy_u32(&contents[199], (uint32_t)rules[9 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[203], (uint8_t)rules[10 + offset].settings.event.group);
  TF_copy_u32(&contents[204], rules[10 + offset].settings.event.local);
  TF_copy_u8(&contents[208], (uint8_t)((((uint8_t)rules[10 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[10 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[10 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[10 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[209], rules[10 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[211], rules[10 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[215], (uint16_t)rules[10 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[217], rules[10 + offset].counter);
  TF_copy_u32(&contents[219], (uint32_t)rules[10 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[223], (uint8_t)rules[11 + offset].settings.event.group);
  TF_copy_u32(&contents[224], rules[11 + offset].settings.event.local);
  TF_copy_u8(&contents[228], (uint8_t)((((uint8_t)rules[11 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[11 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[11 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[11 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[229], rules[11 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[231], rules[11 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[235], (uint16_t)rules[11 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[237], rules[11 + offset].counter);
  TF_copy_u32(&contents[239], (uint32_t)rules[11 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[243], (uint8_t)rules[12 + offset].settings.event.group);
  TF_copy_u32(&contents[244], rules[12 + offset].settings.event.local);
  TF_copy_u8(&contents[248], (uint8_t)((((uint8_t)rules[12 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[12 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[12 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[12 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[249], rules[12 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[251], rules[12 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[255], (uint16_t)rules[12 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[257], rules[12 + offset].counter);
  TF_copy_u32(&contents[259], (uint32_t)rules[12 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[263], (uint8_t)rules[13 + offset].settings.event.group);
  TF_copy_u32(&contents[264], rules[13 + offset].settings.event.local);
  TF_copy_u8(&contents[268], (uint8_t)((((uint8_t)rules[13 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[13 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[13 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[13 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[269], rules[13 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[271], rules[13 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[275], (uint16_t)rules[13 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[277], rules[13 + offset].counter);
  TF_copy_u32(&contents[279], (uint32_t)rules[13 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[283], (uint8_t)rules[14 + offset].settings.event.group);
  TF_copy_u32(&contents[284], rules[14 + offset].settings.event.local);
  TF_copy_u8(&contents[288], (uint8_t)((((uint8_t)rules[14 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[14 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[14 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[14 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[289], rules[14 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[291], rules[14 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[295], (uint16_t)rules[14 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[297], rules[14 + offset].counter);
  TF_copy_u32(&contents[299], (uint32_t)rules[14 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[303], (uint8_t)rules[15 + offset].settings.event.group);
  TF_copy_u32(&contents[304], rules[15 + offset].settings.event.local);
  TF_copy_u8(&contents[308], (uint8_t)((((uint8_t)rules[15 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[15 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[15 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[15 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[309], rules[15 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[311], rules[15 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[315], (uint16_t)rules[15 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[317], rules[15 + offset].counter);
  TF_copy_u32(&contents[319], (uint32_t)rules[15 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[323], (uint8_t)rules[16 + offset].settings.event.group);
  TF_copy_u32(&contents[324], rules[16 + offset].settings.event.local);
  TF_copy_u8(&contents[328], (uint8_t)((((uint8_t)rules[16 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[16 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[16 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[16 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[329], rules[16 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[331], rules[16 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[335], (uint16_t)rules[16 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[337], rules[16 + offset].counter);
  TF_copy_u32(&contents[339], (uint32_t)rules[16 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[343], (uint8_t)rules[17 + offset].settings.event.group);
  TF_copy_u32(&contents[344], rules[17 + offset].settings.event.local);
  TF_copy_u8(&contents[348], (uint8_t)((((uint8_t)rules[17 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[17 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[17 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[17 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[349], rules[17 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[351], rules[17 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[355], (uint16_t)rules[17 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[357], rules[17 + offset].counter);
  TF_copy_u32(&contents[359], (uint32_t)rules[17 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[363], (uint8_t)rules[18 + offset].settings.event.group);
  TF_copy_u32(&contents[364], rules[18 + offset].settings.event.local);
  TF_copy_u8(&contents[368], (uint8_t)((((uint8_t)rules[18 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[18 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[18 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[18 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[369], rules[18 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[371], rules[18 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[375], (uint16_t)rules[18 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[377], rules[18 + offset].counter);
  TF_copy_u32(&contents[379], (uint32_t)rules[18 + offset].last_event_time.total_cycle);
  TF_copy_u8(&contents[383], (uint8_t)rules[19 + offset].settings.event.group);
  TF_copy_u32(&contents[384], rules[19 + offset].settings.event.local);
  TF_copy_u8(&contents[388], (uint8_t)((((uint8_t)rules[19 + offset].settings.event.err_level) << 5 & 0xe0) | (rules[19 + offset].settings.should_match_err_level << 4 & 0x10) | (rules[19 + offset].settings.is_active << 3 & 0x08) | (((uint8_t)rules[19 + offset].settings.condition.type) & 0x07)));
  TF_copy_u16(&contents[389], rules[19 + offset].settings.condition.count_threshold);
  TF_copy_u32(&contents[391], rules[19 + offset].settings.condition.time_threshold_ms);
  TF_copy_u16(&contents[395], (uint16_t)rules[19 + offset].settings.deploy_bct_id);
  TF_copy_u16(&contents[397], rules[19 + offset].counter);
  TF_copy_u32(&contents[399], (uint32_t)rules[19 + offset].last_event_time.total_cycle);
#endif

  return 403;
}

static int Tlm_EH_LOG_(unsigned char* contents, int max_len)
{
  uint16_t offset = event_handler->tlm_info.log.page_no * EH_LOG_TLM_PAGE_SIZE;

  if (391 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_handler->tlm_info.log.page_no);
  TF_copy_u32(&contents[1], event_handler->log_table.respond_counter);
  TF_copy_u16(&contents[5], event_handler->log_table.log_wp);
  TF_copy_u8(&contents[7], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(0 + offset))->rule_id);
  TF_copy_u32(&contents[8], EH_get_the_nth_log_from_the_latest((uint16_t)(0 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[12], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(0 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[13], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(1 + offset))->rule_id);
  TF_copy_u32(&contents[14], EH_get_the_nth_log_from_the_latest((uint16_t)(1 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[18], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(1 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[19], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(2 + offset))->rule_id);
  TF_copy_u32(&contents[20], EH_get_the_nth_log_from_the_latest((uint16_t)(2 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[24], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(2 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[25], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(3 + offset))->rule_id);
  TF_copy_u32(&contents[26], EH_get_the_nth_log_from_the_latest((uint16_t)(3 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[30], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(3 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[31], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(4 + offset))->rule_id);
  TF_copy_u32(&contents[32], EH_get_the_nth_log_from_the_latest((uint16_t)(4 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[36], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(4 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[37], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(5 + offset))->rule_id);
  TF_copy_u32(&contents[38], EH_get_the_nth_log_from_the_latest((uint16_t)(5 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[42], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(5 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[43], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(6 + offset))->rule_id);
  TF_copy_u32(&contents[44], EH_get_the_nth_log_from_the_latest((uint16_t)(6 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[48], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(6 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[49], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(7 + offset))->rule_id);
  TF_copy_u32(&contents[50], EH_get_the_nth_log_from_the_latest((uint16_t)(7 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[54], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(7 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[55], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(8 + offset))->rule_id);
  TF_copy_u32(&contents[56], EH_get_the_nth_log_from_the_latest((uint16_t)(8 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[60], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(8 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[61], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(9 + offset))->rule_id);
  TF_copy_u32(&contents[62], EH_get_the_nth_log_from_the_latest((uint16_t)(9 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[66], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(9 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[67], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(10 + offset))->rule_id);
  TF_copy_u32(&contents[68], EH_get_the_nth_log_from_the_latest((uint16_t)(10 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[72], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(10 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[73], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(11 + offset))->rule_id);
  TF_copy_u32(&contents[74], EH_get_the_nth_log_from_the_latest((uint16_t)(11 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[78], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(11 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[79], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(12 + offset))->rule_id);
  TF_copy_u32(&contents[80], EH_get_the_nth_log_from_the_latest((uint16_t)(12 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[84], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(12 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[85], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(13 + offset))->rule_id);
  TF_copy_u32(&contents[86], EH_get_the_nth_log_from_the_latest((uint16_t)(13 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[90], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(13 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[91], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(14 + offset))->rule_id);
  TF_copy_u32(&contents[92], EH_get_the_nth_log_from_the_latest((uint16_t)(14 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[96], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(14 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[97], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(15 + offset))->rule_id);
  TF_copy_u32(&contents[98], EH_get_the_nth_log_from_the_latest((uint16_t)(15 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[102], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(15 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[103], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(16 + offset))->rule_id);
  TF_copy_u32(&contents[104], EH_get_the_nth_log_from_the_latest((uint16_t)(16 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[108], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(16 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[109], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(17 + offset))->rule_id);
  TF_copy_u32(&contents[110], EH_get_the_nth_log_from_the_latest((uint16_t)(17 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[114], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(17 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[115], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(18 + offset))->rule_id);
  TF_copy_u32(&contents[116], EH_get_the_nth_log_from_the_latest((uint16_t)(18 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[120], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(18 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[121], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(19 + offset))->rule_id);
  TF_copy_u32(&contents[122], EH_get_the_nth_log_from_the_latest((uint16_t)(19 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[126], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(19 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[127], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(20 + offset))->rule_id);
  TF_copy_u32(&contents[128], EH_get_the_nth_log_from_the_latest((uint16_t)(20 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[132], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(20 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[133], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(21 + offset))->rule_id);
  TF_copy_u32(&contents[134], EH_get_the_nth_log_from_the_latest((uint16_t)(21 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[138], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(21 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[139], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(22 + offset))->rule_id);
  TF_copy_u32(&contents[140], EH_get_the_nth_log_from_the_latest((uint16_t)(22 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[144], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(22 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[145], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(23 + offset))->rule_id);
  TF_copy_u32(&contents[146], EH_get_the_nth_log_from_the_latest((uint16_t)(23 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[150], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(23 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[151], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(24 + offset))->rule_id);
  TF_copy_u32(&contents[152], EH_get_the_nth_log_from_the_latest((uint16_t)(24 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[156], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(24 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[157], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(25 + offset))->rule_id);
  TF_copy_u32(&contents[158], EH_get_the_nth_log_from_the_latest((uint16_t)(25 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[162], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(25 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[163], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(26 + offset))->rule_id);
  TF_copy_u32(&contents[164], EH_get_the_nth_log_from_the_latest((uint16_t)(26 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[168], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(26 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[169], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(27 + offset))->rule_id);
  TF_copy_u32(&contents[170], EH_get_the_nth_log_from_the_latest((uint16_t)(27 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[174], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(27 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[175], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(28 + offset))->rule_id);
  TF_copy_u32(&contents[176], EH_get_the_nth_log_from_the_latest((uint16_t)(28 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[180], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(28 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[181], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(29 + offset))->rule_id);
  TF_copy_u32(&contents[182], EH_get_the_nth_log_from_the_latest((uint16_t)(29 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[186], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(29 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[187], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(30 + offset))->rule_id);
  TF_copy_u32(&contents[188], EH_get_the_nth_log_from_the_latest((uint16_t)(30 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[192], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(30 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[193], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(31 + offset))->rule_id);
  TF_copy_u32(&contents[194], EH_get_the_nth_log_from_the_latest((uint16_t)(31 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[198], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(31 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[199], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(32 + offset))->rule_id);
  TF_copy_u32(&contents[200], EH_get_the_nth_log_from_the_latest((uint16_t)(32 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[204], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(32 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[205], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(33 + offset))->rule_id);
  TF_copy_u32(&contents[206], EH_get_the_nth_log_from_the_latest((uint16_t)(33 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[210], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(33 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[211], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(34 + offset))->rule_id);
  TF_copy_u32(&contents[212], EH_get_the_nth_log_from_the_latest((uint16_t)(34 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[216], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(34 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[217], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(35 + offset))->rule_id);
  TF_copy_u32(&contents[218], EH_get_the_nth_log_from_the_latest((uint16_t)(35 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[222], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(35 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[223], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(36 + offset))->rule_id);
  TF_copy_u32(&contents[224], EH_get_the_nth_log_from_the_latest((uint16_t)(36 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[228], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(36 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[229], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(37 + offset))->rule_id);
  TF_copy_u32(&contents[230], EH_get_the_nth_log_from_the_latest((uint16_t)(37 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[234], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(37 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[235], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(38 + offset))->rule_id);
  TF_copy_u32(&contents[236], EH_get_the_nth_log_from_the_latest((uint16_t)(38 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[240], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(38 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[241], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(39 + offset))->rule_id);
  TF_copy_u32(&contents[242], EH_get_the_nth_log_from_the_latest((uint16_t)(39 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[246], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(39 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[247], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(40 + offset))->rule_id);
  TF_copy_u32(&contents[248], EH_get_the_nth_log_from_the_latest((uint16_t)(40 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[252], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(40 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[253], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(41 + offset))->rule_id);
  TF_copy_u32(&contents[254], EH_get_the_nth_log_from_the_latest((uint16_t)(41 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[258], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(41 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[259], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(42 + offset))->rule_id);
  TF_copy_u32(&contents[260], EH_get_the_nth_log_from_the_latest((uint16_t)(42 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[264], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(42 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[265], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(43 + offset))->rule_id);
  TF_copy_u32(&contents[266], EH_get_the_nth_log_from_the_latest((uint16_t)(43 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[270], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(43 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[271], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(44 + offset))->rule_id);
  TF_copy_u32(&contents[272], EH_get_the_nth_log_from_the_latest((uint16_t)(44 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[276], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(44 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[277], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(45 + offset))->rule_id);
  TF_copy_u32(&contents[278], EH_get_the_nth_log_from_the_latest((uint16_t)(45 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[282], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(45 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[283], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(46 + offset))->rule_id);
  TF_copy_u32(&contents[284], EH_get_the_nth_log_from_the_latest((uint16_t)(46 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[288], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(46 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[289], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(47 + offset))->rule_id);
  TF_copy_u32(&contents[290], EH_get_the_nth_log_from_the_latest((uint16_t)(47 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[294], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(47 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[295], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(48 + offset))->rule_id);
  TF_copy_u32(&contents[296], EH_get_the_nth_log_from_the_latest((uint16_t)(48 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[300], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(48 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[301], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(49 + offset))->rule_id);
  TF_copy_u32(&contents[302], EH_get_the_nth_log_from_the_latest((uint16_t)(49 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[306], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(49 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[307], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(50 + offset))->rule_id);
  TF_copy_u32(&contents[308], EH_get_the_nth_log_from_the_latest((uint16_t)(50 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[312], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(50 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[313], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(51 + offset))->rule_id);
  TF_copy_u32(&contents[314], EH_get_the_nth_log_from_the_latest((uint16_t)(51 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[318], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(51 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[319], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(52 + offset))->rule_id);
  TF_copy_u32(&contents[320], EH_get_the_nth_log_from_the_latest((uint16_t)(52 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[324], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(52 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[325], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(53 + offset))->rule_id);
  TF_copy_u32(&contents[326], EH_get_the_nth_log_from_the_latest((uint16_t)(53 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[330], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(53 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[331], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(54 + offset))->rule_id);
  TF_copy_u32(&contents[332], EH_get_the_nth_log_from_the_latest((uint16_t)(54 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[336], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(54 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[337], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(55 + offset))->rule_id);
  TF_copy_u32(&contents[338], EH_get_the_nth_log_from_the_latest((uint16_t)(55 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[342], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(55 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[343], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(56 + offset))->rule_id);
  TF_copy_u32(&contents[344], EH_get_the_nth_log_from_the_latest((uint16_t)(56 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[348], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(56 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[349], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(57 + offset))->rule_id);
  TF_copy_u32(&contents[350], EH_get_the_nth_log_from_the_latest((uint16_t)(57 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[354], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(57 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[355], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(58 + offset))->rule_id);
  TF_copy_u32(&contents[356], EH_get_the_nth_log_from_the_latest((uint16_t)(58 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[360], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(58 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[361], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(59 + offset))->rule_id);
  TF_copy_u32(&contents[362], EH_get_the_nth_log_from_the_latest((uint16_t)(59 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[366], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(59 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[367], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(60 + offset))->rule_id);
  TF_copy_u32(&contents[368], EH_get_the_nth_log_from_the_latest((uint16_t)(60 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[372], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(60 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[373], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(61 + offset))->rule_id);
  TF_copy_u32(&contents[374], EH_get_the_nth_log_from_the_latest((uint16_t)(61 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[378], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(61 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[379], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(62 + offset))->rule_id);
  TF_copy_u32(&contents[380], EH_get_the_nth_log_from_the_latest((uint16_t)(62 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[384], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(62 + offset))->deploy_cmd_ack);
  TF_copy_u8(&contents[385], (uint8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(63 + offset))->rule_id);
  TF_copy_u32(&contents[386], EH_get_the_nth_log_from_the_latest((uint16_t)(63 + offset))->respond_time_in_master_cycle);
  TF_copy_i8(&contents[390], (int8_t)EH_get_the_nth_log_from_the_latest((uint16_t)(63 + offset))->deploy_cmd_ack);
#endif

  return 391;
}

static int Tlm_EH_INDEX_(unsigned char* contents, int max_len)
{
  uint16_t offset = event_handler->tlm_info.rule_sorted_index.page_no * EH_RULE_TLM_PAGE_SIZE;

  if (141 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], event_handler->tlm_info.rule_sorted_index.page_no);
  TF_copy_u8(&contents[1], (uint8_t)event_handler->sorted_idxes[0 + offset].group);
  TF_copy_u32(&contents[2], event_handler->sorted_idxes[0 + offset].local);
  TF_copy_u8(&contents[6], event_handler->sorted_idxes[0 + offset].duplicate_id);
  TF_copy_u8(&contents[7], (uint8_t)event_handler->sorted_idxes[0 + offset].rule_id);
  TF_copy_u8(&contents[8], (uint8_t)event_handler->sorted_idxes[1 + offset].group);
  TF_copy_u32(&contents[9], event_handler->sorted_idxes[1 + offset].local);
  TF_copy_u8(&contents[13], event_handler->sorted_idxes[1 + offset].duplicate_id);
  TF_copy_u8(&contents[14], (uint8_t)event_handler->sorted_idxes[1 + offset].rule_id);
  TF_copy_u8(&contents[15], (uint8_t)event_handler->sorted_idxes[2 + offset].group);
  TF_copy_u32(&contents[16], event_handler->sorted_idxes[2 + offset].local);
  TF_copy_u8(&contents[20], event_handler->sorted_idxes[2 + offset].duplicate_id);
  TF_copy_u8(&contents[21], (uint8_t)event_handler->sorted_idxes[2 + offset].rule_id);
  TF_copy_u8(&contents[22], (uint8_t)event_handler->sorted_idxes[3 + offset].group);
  TF_copy_u32(&contents[23], event_handler->sorted_idxes[3 + offset].local);
  TF_copy_u8(&contents[27], event_handler->sorted_idxes[3 + offset].duplicate_id);
  TF_copy_u8(&contents[28], (uint8_t)event_handler->sorted_idxes[3 + offset].rule_id);
  TF_copy_u8(&contents[29], (uint8_t)event_handler->sorted_idxes[4 + offset].group);
  TF_copy_u32(&contents[30], event_handler->sorted_idxes[4 + offset].local);
  TF_copy_u8(&contents[34], event_handler->sorted_idxes[4 + offset].duplicate_id);
  TF_copy_u8(&contents[35], (uint8_t)event_handler->sorted_idxes[4 + offset].rule_id);
  TF_copy_u8(&contents[36], (uint8_t)event_handler->sorted_idxes[5 + offset].group);
  TF_copy_u32(&contents[37], event_handler->sorted_idxes[5 + offset].local);
  TF_copy_u8(&contents[41], event_handler->sorted_idxes[5 + offset].duplicate_id);
  TF_copy_u8(&contents[42], (uint8_t)event_handler->sorted_idxes[5 + offset].rule_id);
  TF_copy_u8(&contents[43], (uint8_t)event_handler->sorted_idxes[6 + offset].group);
  TF_copy_u32(&contents[44], event_handler->sorted_idxes[6 + offset].local);
  TF_copy_u8(&contents[48], event_handler->sorted_idxes[6 + offset].duplicate_id);
  TF_copy_u8(&contents[49], (uint8_t)event_handler->sorted_idxes[6 + offset].rule_id);
  TF_copy_u8(&contents[50], (uint8_t)event_handler->sorted_idxes[7 + offset].group);
  TF_copy_u32(&contents[51], event_handler->sorted_idxes[7 + offset].local);
  TF_copy_u8(&contents[55], event_handler->sorted_idxes[7 + offset].duplicate_id);
  TF_copy_u8(&contents[56], (uint8_t)event_handler->sorted_idxes[7 + offset].rule_id);
  TF_copy_u8(&contents[57], (uint8_t)event_handler->sorted_idxes[8 + offset].group);
  TF_copy_u32(&contents[58], event_handler->sorted_idxes[8 + offset].local);
  TF_copy_u8(&contents[62], event_handler->sorted_idxes[8 + offset].duplicate_id);
  TF_copy_u8(&contents[63], (uint8_t)event_handler->sorted_idxes[8 + offset].rule_id);
  TF_copy_u8(&contents[64], (uint8_t)event_handler->sorted_idxes[9 + offset].group);
  TF_copy_u32(&contents[65], event_handler->sorted_idxes[9 + offset].local);
  TF_copy_u8(&contents[69], event_handler->sorted_idxes[9 + offset].duplicate_id);
  TF_copy_u8(&contents[70], (uint8_t)event_handler->sorted_idxes[9 + offset].rule_id);
  TF_copy_u8(&contents[71], (uint8_t)event_handler->sorted_idxes[10 + offset].group);
  TF_copy_u32(&contents[72], event_handler->sorted_idxes[10 + offset].local);
  TF_copy_u8(&contents[76], event_handler->sorted_idxes[10 + offset].duplicate_id);
  TF_copy_u8(&contents[77], (uint8_t)event_handler->sorted_idxes[10 + offset].rule_id);
  TF_copy_u8(&contents[78], (uint8_t)event_handler->sorted_idxes[11 + offset].group);
  TF_copy_u32(&contents[79], event_handler->sorted_idxes[11 + offset].local);
  TF_copy_u8(&contents[83], event_handler->sorted_idxes[11 + offset].duplicate_id);
  TF_copy_u8(&contents[84], (uint8_t)event_handler->sorted_idxes[11 + offset].rule_id);
  TF_copy_u8(&contents[85], (uint8_t)event_handler->sorted_idxes[12 + offset].group);
  TF_copy_u32(&contents[86], event_handler->sorted_idxes[12 + offset].local);
  TF_copy_u8(&contents[90], event_handler->sorted_idxes[12 + offset].duplicate_id);
  TF_copy_u8(&contents[91], (uint8_t)event_handler->sorted_idxes[12 + offset].rule_id);
  TF_copy_u8(&contents[92], (uint8_t)event_handler->sorted_idxes[13 + offset].group);
  TF_copy_u32(&contents[93], event_handler->sorted_idxes[13 + offset].local);
  TF_copy_u8(&contents[97], event_handler->sorted_idxes[13 + offset].duplicate_id);
  TF_copy_u8(&contents[98], (uint8_t)event_handler->sorted_idxes[13 + offset].rule_id);
  TF_copy_u8(&contents[99], (uint8_t)event_handler->sorted_idxes[14 + offset].group);
  TF_copy_u32(&contents[100], event_handler->sorted_idxes[14 + offset].local);
  TF_copy_u8(&contents[104], event_handler->sorted_idxes[14 + offset].duplicate_id);
  TF_copy_u8(&contents[105], (uint8_t)event_handler->sorted_idxes[14 + offset].rule_id);
  TF_copy_u8(&contents[106], (uint8_t)event_handler->sorted_idxes[15 + offset].group);
  TF_copy_u32(&contents[107], event_handler->sorted_idxes[15 + offset].local);
  TF_copy_u8(&contents[111], event_handler->sorted_idxes[15 + offset].duplicate_id);
  TF_copy_u8(&contents[112], (uint8_t)event_handler->sorted_idxes[15 + offset].rule_id);
  TF_copy_u8(&contents[113], (uint8_t)event_handler->sorted_idxes[16 + offset].group);
  TF_copy_u32(&contents[114], event_handler->sorted_idxes[16 + offset].local);
  TF_copy_u8(&contents[118], event_handler->sorted_idxes[16 + offset].duplicate_id);
  TF_copy_u8(&contents[119], (uint8_t)event_handler->sorted_idxes[16 + offset].rule_id);
  TF_copy_u8(&contents[120], (uint8_t)event_handler->sorted_idxes[17 + offset].group);
  TF_copy_u32(&contents[121], event_handler->sorted_idxes[17 + offset].local);
  TF_copy_u8(&contents[125], event_handler->sorted_idxes[17 + offset].duplicate_id);
  TF_copy_u8(&contents[126], (uint8_t)event_handler->sorted_idxes[17 + offset].rule_id);
  TF_copy_u8(&contents[127], (uint8_t)event_handler->sorted_idxes[18 + offset].group);
  TF_copy_u32(&contents[128], event_handler->sorted_idxes[18 + offset].local);
  TF_copy_u8(&contents[132], event_handler->sorted_idxes[18 + offset].duplicate_id);
  TF_copy_u8(&contents[133], (uint8_t)event_handler->sorted_idxes[18 + offset].rule_id);
  TF_copy_u8(&contents[134], (uint8_t)event_handler->sorted_idxes[19 + offset].group);
  TF_copy_u32(&contents[135], event_handler->sorted_idxes[19 + offset].local);
  TF_copy_u8(&contents[139], event_handler->sorted_idxes[19 + offset].duplicate_id);
  TF_copy_u8(&contents[140], (uint8_t)event_handler->sorted_idxes[19 + offset].rule_id);
#endif

  return 141;
}

static int Tlm_GS_(unsigned char* contents, int max_len)
{
  if (111 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], gs_driver->driver_uart.uart_config.ch);
  TF_copy_u32(&contents[1], gs_driver->driver_uart.uart_config.baudrate);
  TF_copy_u8(&contents[5], (uint8_t)gs_driver->driver_uart.uart_config.parity_settings);
  TF_copy_u8(&contents[6], (uint8_t)gs_driver->driver_uart.uart_config.data_length);
  TF_copy_u8(&contents[7], (uint8_t)gs_driver->driver_uart.uart_config.stop_bit);
  TF_copy_u8(&contents[8], (uint8_t)gs_driver->info[0].rec_status);
  TF_copy_u8(&contents[9], (uint8_t)gs_driver->info[0].last_rec_tcf_type);
  TF_copy_u8(&contents[10], (uint8_t)gs_driver->info[0].ad_rec_status);
  TF_copy_u8(&contents[11], (uint8_t)gs_driver->info[0].bc_rec_status);
  TF_copy_u8(&contents[12], (uint8_t)gs_driver->info[0].bd_rec_status);
  TF_copy_u8(&contents[13], (uint8_t)(gs_driver->info[0].tc_frame_validate_status));
  TF_copy_i32(&contents[14], (int32_t)gs_driver->info[0].ret_from_if_rx);
  TF_copy_u32(&contents[18], (uint32_t)gs_driver->info[0].last_rec_time);
  TF_copy_u8(&contents[22], (uint8_t)gs_driver->info[0].cmd_ack);
  TF_copy_u32(&contents[23], (uint32_t)gs_driver->info[0].send_cycle);
  TF_copy_u8(&contents[27], (uint8_t)gs_driver->info[0].vcid);
  TF_copy_u32(&contents[28], gs_driver->info[0].vcdu_counter);
  TF_copy_u8(&contents[32], gs_driver->ccsds_info.buffer_num);
  TF_copy_u8(&contents[33], (uint8_t)gs_driver->info[1].rec_status);
  TF_copy_u8(&contents[34], (uint8_t)gs_driver->info[1].last_rec_tcf_type);
  TF_copy_u8(&contents[35], (uint8_t)gs_driver->info[1].ad_rec_status);
  TF_copy_u8(&contents[36], (uint8_t)gs_driver->info[1].bc_rec_status);
  TF_copy_u8(&contents[37], (uint8_t)gs_driver->info[1].bd_rec_status);
  TF_copy_u8(&contents[38], (uint8_t)(gs_driver->info[1].tc_frame_validate_status));
  TF_copy_i32(&contents[39], (int32_t)gs_driver->info[1].ret_from_if_rx);
  TF_copy_u32(&contents[43], (uint32_t)gs_driver->info[1].last_rec_time);
  TF_copy_u8(&contents[47], (uint8_t)gs_driver->info[1].cmd_ack);
  TF_copy_u32(&contents[48], (uint32_t)gs_driver->info[1].send_cycle);
  TF_copy_u8(&contents[52], (uint8_t)gs_driver->info[1].vcid);
  TF_copy_u32(&contents[53], gs_driver->info[1].vcdu_counter);
  TF_copy_u8(&contents[57], gs_driver->is_ccsds_tx_valid);
  TF_copy_u32(&contents[58], (uint32_t)DI_GS_ms_tlm_packet_handler->tc_packet_to_m_pdu.flush_interval);
  TF_copy_u32(&contents[62], (uint32_t)DI_GS_ms_tlm_packet_handler->tc_packet_to_m_pdu.last_updated);
  TF_copy_u32(&contents[66], (uint32_t)DI_GS_ms_tlm_packet_handler->vcdu_counter);
  TF_copy_u32(&contents[70], (uint32_t)DI_GS_rp_tlm_packet_handler->tc_packet_to_m_pdu.flush_interval);
  TF_copy_u32(&contents[74], (uint32_t)DI_GS_rp_tlm_packet_handler->tc_packet_to_m_pdu.last_updated);
  TF_copy_u32(&contents[78], (uint32_t)DI_GS_rp_tlm_packet_handler->vcdu_counter);
  TF_copy_u8(&contents[82], gs_validate_info->type_a_counter);
  TF_copy_u8(&contents[83], gs_validate_info->type_b_counter);
  TF_copy_u8(&contents[84], gs_validate_info->lockout_flag);
  TF_copy_u8(&contents[85], gs_validate_info->retransmit_flag);
  TF_copy_u8(&contents[86], gs_validate_info->positive_window_width);
  TF_copy_u32(&contents[87], gs_driver->ccsds_info.uip_stat[0]);
  TF_copy_u32(&contents[91], gs_driver->ccsds_info.uip_stat[1]);
  TF_copy_u32(&contents[95], gs_driver->ccsds_info.uip_stat[2]);
  TF_copy_u32(&contents[99], gs_driver->ccsds_info.uip_stat[3]);
  TF_copy_u32(&contents[103], gs_driver->ccsds_info.uip_stat[4]);
  TF_copy_u32(&contents[107], gs_driver->ccsds_info.uip_stat[5]);
#endif

  return 111;
}

static int Tlm_HK_(unsigned char* contents, int max_len)
{
  if (415 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u32(&contents[0], TMGR_get_master_clock().mode_cycle);
  TF_copy_double(&contents[4], TMGR_get_obct_unixtime_info().unixtime_at_ti0);
  TF_copy_u8(&contents[12], (uint8_t)(mode_manager->current_id));
  TF_copy_u8(&contents[13], (uint8_t)( ((uint8_t)(mode_manager->stat) << 7 & 0x80) | ((uint8_t)(mode_manager->previous_id) & 0x7F) ));
  TF_copy_u16(&contents[14], TDSP_info->task_list_id);
  TF_copy_u8(&contents[16], (uint8_t)gs_driver->latest_info->rec_status);
  TF_copy_u32(&contents[17], (uint32_t)gs_driver->latest_info->last_rec_time);
  TF_copy_u8(&contents[21], (uint8_t)(gs_driver->latest_info->cmd_ack));
  TF_copy_u32(&contents[22], PL_count_executed_nodes(&PH_gs_cmd_list));
  TF_copy_u32(&contents[26], gs_command_dispatcher->prev.time.total_cycle);
  TF_copy_u16(&contents[30], (uint16_t)(gs_command_dispatcher->prev.code));
  TF_copy_i8(&contents[32], (int8_t)(gs_command_dispatcher->prev.sts));
  TF_copy_u32(&contents[33], gs_command_dispatcher->prev_err.time.total_cycle);
  TF_copy_u16(&contents[37], (uint16_t)(gs_command_dispatcher->prev_err.code));
  TF_copy_i8(&contents[39], (int8_t)(gs_command_dispatcher->prev_err.sts));
  TF_copy_u32(&contents[40], PL_count_executed_nodes(&PH_tl_cmd_list[0]));
  TF_copy_u8(&contents[44], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[0])));
  TF_copy_u32(&contents[45], timeline_command_dispatcher[0].prev.time.total_cycle);
  TF_copy_u16(&contents[49], (uint16_t)(timeline_command_dispatcher[0].prev.code));
  TF_copy_i8(&contents[51], (int8_t)(timeline_command_dispatcher[0].prev.sts));
  TF_copy_u32(&contents[52], timeline_command_dispatcher[0].prev_err.time.total_cycle);
  TF_copy_u16(&contents[56], (uint16_t)(timeline_command_dispatcher[0].prev_err.code));
  TF_copy_i8(&contents[58], (int8_t)(timeline_command_dispatcher[0].prev_err.sts));
  TF_copy_u32(&contents[59], (PL_is_empty(&(PH_tl_cmd_list[0])) ? 0 : (uint32_t)CCP_get_ti(&(PL_get_head(&(PH_tl_cmd_list[0]))->packet))));
  TF_copy_u16(&contents[63], (uint16_t)(PL_is_empty(&(PH_tl_cmd_list[0])) ? 0 : CCP_get_id(&(PL_get_head(&(PH_tl_cmd_list[0]))->packet))));
  TF_copy_u8(&contents[65], (uint8_t)(((uint8_t)timeline_command_dispatcher[0].stop_on_error << 7 & 0x80) | ((uint8_t)timeline_command_dispatcher[0].lockout << 6 & 0x40) | ((uint8_t)timeline_command_dispatcher[1].stop_on_error << 5 & 0x20) | ((uint8_t)timeline_command_dispatcher[1].lockout << 4 & 0x10) | ((uint8_t)timeline_command_dispatcher[2].stop_on_error << 3 & 0x08) | ((uint8_t)timeline_command_dispatcher[2].lockout << 2 & 0x04) | (wdt_config->is_wdt_enable << 1 & 0x02) | (wdt_config->is_clear_enable & 0x01) ));
  TF_copy_u16(&contents[66], block_command_table->pos.block);
  TF_copy_u8(&contents[68], (uint8_t)(block_command_table->pos.cmd));
  TF_copy_u32(&contents[69], ((block_command_table->pos.cmd == 0) ? 0 : (uint32_t)BCT_get_ti(block_command_table->pos.block, (uint8_t)(block_command_table->pos.cmd-1))));
  TF_copy_u16(&contents[73], (uint16_t)((block_command_table->pos.cmd == 0) ? 0 : BCT_get_id(block_command_table->pos.block, (uint8_t)(block_command_table->pos.cmd-1))));
  TF_copy_u32(&contents[75], event_logger->statistics.record_counter_total);
  TF_copy_u16(&contents[79], (uint16_t)event_logger->statistics.record_counters[EL_ERROR_LEVEL_HIGH]);
  TF_copy_u16(&contents[81], (uint16_t)event_logger->statistics.record_counters[EL_ERROR_LEVEL_MIDDLE]);
  TF_copy_u16(&contents[83], (uint16_t)event_logger->statistics.record_counters[EL_ERROR_LEVEL_LOW]);
  TF_copy_u16(&contents[85], (uint16_t)event_logger->statistics.record_counters[EL_ERROR_LEVEL_EL]);
  TF_copy_u16(&contents[87], (uint16_t)event_logger->statistics.record_counters[EL_ERROR_LEVEL_EH]);
  TF_copy_u8(&contents[89], (uint8_t)event_logger->latest_event.group);
  TF_copy_u32(&contents[90], event_logger->latest_event.local);
  TF_copy_u8(&contents[94], (uint8_t)event_logger->latest_event.err_level);
  TF_copy_u32(&contents[95], event_logger->latest_event.time.total_cycle);
  TF_copy_u8(&contents[99], (uint8_t)event_logger->latest_event.time.step);
  TF_copy_u16(&contents[100], (uint16_t)event_logger->latest_event.note);
  TF_copy_u8(&contents[102], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->group);
  TF_copy_u32(&contents[103], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->local);
  TF_copy_u32(&contents[107], EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->time.total_cycle);
  TF_copy_u8(&contents[111], (uint8_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->time.step);
  TF_copy_u16(&contents[112], (uint16_t)EL_get_the_nth_tlog_from_the_latest(EL_ERROR_LEVEL_HIGH, 0)->note);
  TF_copy_u32(&contents[114], event_handler->log_table.respond_counter);
  TF_copy_u32(&contents[118], (uint32_t)anomaly_logger->counter);
  TF_copy_u32(&contents[122], (uint32_t)anomaly_logger->records[(anomaly_logger->header == 0) ? 0 : anomaly_logger->header - 1].time.total_cycle);
  TF_copy_u8(&contents[126], (uint8_t)(anomaly_logger->records[(anomaly_logger->header == 0) ? 0 : anomaly_logger->header - 1].time.step & 0x000000ff));
  TF_copy_u8(&contents[127], (uint8_t)(anomaly_logger->records[(anomaly_logger->header == 0) ? 0 : anomaly_logger->header - 1].code.group & 0x000000ff));
  TF_copy_u32(&contents[128], anomaly_logger->records[(anomaly_logger->header == 0) ? 0 : anomaly_logger->header - 1].code.local);
  TF_copy_u8(&contents[132], (uint8_t)(anomaly_logger->records[(anomaly_logger->header == 0) ? 0 : anomaly_logger->header - 1].run_length & 0x000000ff));
  TF_copy_u8(&contents[133], (uint8_t)(anomaly_logger->header));
  TF_copy_u32(&contents[134], PL_count_executed_nodes(&PH_tl_cmd_list[1]));
  TF_copy_u32(&contents[138], PL_count_executed_nodes(&PH_tl_cmd_list[2]));
  TF_copy_u8(&contents[142], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[1])));
  TF_copy_u8(&contents[143], (uint8_t)(PL_count_active_nodes(&PH_tl_cmd_list[2])));
  TF_copy_u8(&contents[144], (uint8_t)(anomaly_handler->action_counter));
  TF_copy_u8(&contents[145], (uint8_t)(anomaly_handler->latest_id));
  TF_copy_u32(&contents[146], (uint32_t)(anomaly_handler->respond_at.total_cycle));
  TF_copy_u8(&contents[150], (uint8_t)(gs_command_dispatcher->error_counter));
  TF_copy_u16(&contents[151], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].cmd_code));
  TF_copy_u8(&contents[153], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].status));
  TF_copy_u16(&contents[154], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].exec_counter));
  TF_copy_i8(&contents[156], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].last_exec_sts));
  TF_copy_u32(&contents[157], divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[0]].last_exec_time.total_cycle);
  TF_copy_u16(&contents[161], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].cmd_code));
  TF_copy_u8(&contents[163], (uint8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].status));
  TF_copy_u16(&contents[164], (uint16_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].exec_counter));
  TF_copy_i8(&contents[166], (int8_t)(divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].last_exec_sts));
  TF_copy_u32(&contents[167], divided_cmd_utility->exec_logs[divided_cmd_utility->exec_log_order[1]].last_exec_time.total_cycle);
  TF_copy_u32(&contents[171], GIT_REV_CORE_SHORT);
  TF_copy_u32(&contents[175], GIT_REV_USER_SHORT);
  TF_copy_u32(&contents[179], 0);
  TF_copy_u32(&contents[183], 0);
  TF_copy_u32(&contents[187], 0);
  TF_copy_u32(&contents[191], 0);
  TF_copy_u32(&contents[195], 0);
  TF_copy_u32(&contents[199], 0);
  TF_copy_u32(&contents[203], 0);
  TF_copy_u32(&contents[207], 0);
  TF_copy_u32(&contents[211], 0);
  TF_copy_u32(&contents[215], 0);
  TF_copy_u32(&contents[219], 0);
  TF_copy_u32(&contents[223], 0);
  TF_copy_u32(&contents[227], 0);
  TF_copy_u32(&contents[231], 0);
  TF_copy_u32(&contents[235], 0);
  TF_copy_u32(&contents[239], 0);
  TF_copy_u32(&contents[243], 0);
  TF_copy_u32(&contents[247], 0);
  TF_copy_u32(&contents[251], 0);
  TF_copy_u32(&contents[255], 0);
  TF_copy_u32(&contents[259], 0);
  TF_copy_u32(&contents[263], 0);
  TF_copy_u32(&contents[267], 0);
  TF_copy_u32(&contents[271], 0);
  TF_copy_u32(&contents[275], 0);
  TF_copy_u32(&contents[279], 0);
  TF_copy_u32(&contents[283], 0);
  TF_copy_u32(&contents[287], 0);
  TF_copy_u32(&contents[291], 0);
  TF_copy_u32(&contents[295], 0);
  TF_copy_u32(&contents[299], 0);
  TF_copy_u32(&contents[303], 0);
  TF_copy_u32(&contents[307], 0);
  TF_copy_u32(&contents[311], 0);
  TF_copy_u32(&contents[315], 0);
  TF_copy_u32(&contents[319], 0);
  TF_copy_u32(&contents[323], 0);
  TF_copy_u32(&contents[327], 0);
  TF_copy_u32(&contents[331], 0);
  TF_copy_u32(&contents[335], 0);
  TF_copy_u32(&contents[339], 0);
  TF_copy_u32(&contents[343], 0);
  TF_copy_u32(&contents[347], 0);
  TF_copy_u32(&contents[351], 0);
  TF_copy_u32(&contents[355], 0);
  TF_copy_u32(&contents[359], 0);
  TF_copy_u32(&contents[363], 0);
  TF_copy_u32(&contents[367], 0);
  TF_copy_u32(&contents[371], 0);
  TF_copy_u32(&contents[375], 0);
  TF_copy_u32(&contents[379], 0);
  TF_copy_u32(&contents[383], 0);
  TF_copy_u32(&contents[387], 0);
  TF_copy_u32(&contents[391], 0);
  TF_copy_u32(&contents[395], 0);
  TF_copy_u32(&contents[399], 0);
  TF_copy_u32(&contents[403], 0);
  TF_copy_u32(&contents[407], 0);
  TF_copy_u32(&contents[411], 0);
#endif

  return 415;
}

static int Tlm_GIT_REV_(unsigned char* contents, int max_len)
{
  if (82 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)GIT_REV_CORE[0]);
  TF_copy_u8(&contents[1], (uint8_t)GIT_REV_CORE[1]);
  TF_copy_u8(&contents[2], (uint8_t)GIT_REV_CORE[2]);
  TF_copy_u8(&contents[3], (uint8_t)GIT_REV_CORE[3]);
  TF_copy_u8(&contents[4], (uint8_t)GIT_REV_CORE[4]);
  TF_copy_u8(&contents[5], (uint8_t)GIT_REV_CORE[5]);
  TF_copy_u8(&contents[6], (uint8_t)GIT_REV_CORE[6]);
  TF_copy_u8(&contents[7], (uint8_t)GIT_REV_CORE[7]);
  TF_copy_u8(&contents[8], (uint8_t)GIT_REV_CORE[8]);
  TF_copy_u8(&contents[9], (uint8_t)GIT_REV_CORE[9]);
  TF_copy_u8(&contents[10], (uint8_t)GIT_REV_CORE[10]);
  TF_copy_u8(&contents[11], (uint8_t)GIT_REV_CORE[11]);
  TF_copy_u8(&contents[12], (uint8_t)GIT_REV_CORE[12]);
  TF_copy_u8(&contents[13], (uint8_t)GIT_REV_CORE[13]);
  TF_copy_u8(&contents[14], (uint8_t)GIT_REV_CORE[14]);
  TF_copy_u8(&contents[15], (uint8_t)GIT_REV_CORE[15]);
  TF_copy_u8(&contents[16], (uint8_t)GIT_REV_CORE[16]);
  TF_copy_u8(&contents[17], (uint8_t)GIT_REV_CORE[17]);
  TF_copy_u8(&contents[18], (uint8_t)GIT_REV_CORE[18]);
  TF_copy_u8(&contents[19], (uint8_t)GIT_REV_CORE[19]);
  TF_copy_u8(&contents[20], (uint8_t)GIT_REV_CORE[20]);
  TF_copy_u8(&contents[21], (uint8_t)GIT_REV_CORE[21]);
  TF_copy_u8(&contents[22], (uint8_t)GIT_REV_CORE[22]);
  TF_copy_u8(&contents[23], (uint8_t)GIT_REV_CORE[23]);
  TF_copy_u8(&contents[24], (uint8_t)GIT_REV_CORE[24]);
  TF_copy_u8(&contents[25], (uint8_t)GIT_REV_CORE[25]);
  TF_copy_u8(&contents[26], (uint8_t)GIT_REV_CORE[26]);
  TF_copy_u8(&contents[27], (uint8_t)GIT_REV_CORE[27]);
  TF_copy_u8(&contents[28], (uint8_t)GIT_REV_CORE[28]);
  TF_copy_u8(&contents[29], (uint8_t)GIT_REV_CORE[29]);
  TF_copy_u8(&contents[30], (uint8_t)GIT_REV_CORE[30]);
  TF_copy_u8(&contents[31], (uint8_t)GIT_REV_CORE[31]);
  TF_copy_u8(&contents[32], (uint8_t)GIT_REV_CORE[32]);
  TF_copy_u8(&contents[33], (uint8_t)GIT_REV_CORE[33]);
  TF_copy_u8(&contents[34], (uint8_t)GIT_REV_CORE[34]);
  TF_copy_u8(&contents[35], (uint8_t)GIT_REV_CORE[35]);
  TF_copy_u8(&contents[36], (uint8_t)GIT_REV_CORE[36]);
  TF_copy_u8(&contents[37], (uint8_t)GIT_REV_CORE[37]);
  TF_copy_u8(&contents[38], (uint8_t)GIT_REV_CORE[38]);
  TF_copy_u8(&contents[39], (uint8_t)GIT_REV_CORE[39]);
  TF_copy_u8(&contents[40], (uint8_t)GIT_REV_CORE[40]);
  TF_copy_u8(&contents[41], (uint8_t)GIT_REV_USER[0]);
  TF_copy_u8(&contents[42], (uint8_t)GIT_REV_USER[1]);
  TF_copy_u8(&contents[43], (uint8_t)GIT_REV_USER[2]);
  TF_copy_u8(&contents[44], (uint8_t)GIT_REV_USER[3]);
  TF_copy_u8(&contents[45], (uint8_t)GIT_REV_USER[4]);
  TF_copy_u8(&contents[46], (uint8_t)GIT_REV_USER[5]);
  TF_copy_u8(&contents[47], (uint8_t)GIT_REV_USER[6]);
  TF_copy_u8(&contents[48], (uint8_t)GIT_REV_USER[7]);
  TF_copy_u8(&contents[49], (uint8_t)GIT_REV_USER[8]);
  TF_copy_u8(&contents[50], (uint8_t)GIT_REV_USER[9]);
  TF_copy_u8(&contents[51], (uint8_t)GIT_REV_USER[10]);
  TF_copy_u8(&contents[52], (uint8_t)GIT_REV_USER[11]);
  TF_copy_u8(&contents[53], (uint8_t)GIT_REV_USER[12]);
  TF_copy_u8(&contents[54], (uint8_t)GIT_REV_USER[13]);
  TF_copy_u8(&contents[55], (uint8_t)GIT_REV_USER[14]);
  TF_copy_u8(&contents[56], (uint8_t)GIT_REV_USER[15]);
  TF_copy_u8(&contents[57], (uint8_t)GIT_REV_USER[16]);
  TF_copy_u8(&contents[58], (uint8_t)GIT_REV_USER[17]);
  TF_copy_u8(&contents[59], (uint8_t)GIT_REV_USER[18]);
  TF_copy_u8(&contents[60], (uint8_t)GIT_REV_USER[19]);
  TF_copy_u8(&contents[61], (uint8_t)GIT_REV_USER[20]);
  TF_copy_u8(&contents[62], (uint8_t)GIT_REV_USER[21]);
  TF_copy_u8(&contents[63], (uint8_t)GIT_REV_USER[22]);
  TF_copy_u8(&contents[64], (uint8_t)GIT_REV_USER[23]);
  TF_copy_u8(&contents[65], (uint8_t)GIT_REV_USER[24]);
  TF_copy_u8(&contents[66], (uint8_t)GIT_REV_USER[25]);
  TF_copy_u8(&contents[67], (uint8_t)GIT_REV_USER[26]);
  TF_copy_u8(&contents[68], (uint8_t)GIT_REV_USER[27]);
  TF_copy_u8(&contents[69], (uint8_t)GIT_REV_USER[28]);
  TF_copy_u8(&contents[70], (uint8_t)GIT_REV_USER[29]);
  TF_copy_u8(&contents[71], (uint8_t)GIT_REV_USER[30]);
  TF_copy_u8(&contents[72], (uint8_t)GIT_REV_USER[31]);
  TF_copy_u8(&contents[73], (uint8_t)GIT_REV_USER[32]);
  TF_copy_u8(&contents[74], (uint8_t)GIT_REV_USER[33]);
  TF_copy_u8(&contents[75], (uint8_t)GIT_REV_USER[34]);
  TF_copy_u8(&contents[76], (uint8_t)GIT_REV_USER[35]);
  TF_copy_u8(&contents[77], (uint8_t)GIT_REV_USER[36]);
  TF_copy_u8(&contents[78], (uint8_t)GIT_REV_USER[37]);
  TF_copy_u8(&contents[79], (uint8_t)GIT_REV_USER[38]);
  TF_copy_u8(&contents[80], (uint8_t)GIT_REV_USER[39]);
  TF_copy_u8(&contents[81], (uint8_t)GIT_REV_USER[40]);
#endif

  return 82;
}

static int Tlm_UART_TEST_(unsigned char* contents, int max_len)
{
  if (25 > max_len) return TF_TOO_SHORT_LEN;

#ifndef BUILD_SETTINGS_FAST_BUILD
  TF_copy_u8(&contents[0], (uint8_t)(uart_test_instance->driver.super.config.rec_status_.ret_from_if_rx));
  TF_copy_u32(&contents[1], uart_test_instance->driver.super.config.rx_count_);
  TF_copy_u8(&contents[5], (uint8_t)(uart_test_instance->driver.super.stream_config[0].rec_status_.status_code));
  TF_copy_u16(&contents[6], uart_test_instance->driver.super.stream_config[0].rec_status_.fixed_frame_len);
  TF_copy_u32(&contents[8], uart_test_instance->driver.super.stream_config[0].rx_frame_fix_count_);
  TF_copy_u16(&contents[12], uart_test_instance->driver.super.stream_config[0].rx_frame_rec_len_);
  TF_copy_u8(&contents[14], uart_test_instance->driver.super.stream_config[0].is_rx_buffer_carry_over_);
  TF_copy_u8(&contents[15], (uint8_t)(uart_test_instance->driver.super.stream_config[1].rec_status_.status_code));
  TF_copy_u16(&contents[16], uart_test_instance->driver.super.stream_config[1].rec_status_.fixed_frame_len);
  TF_copy_u32(&contents[18], uart_test_instance->driver.super.stream_config[1].rx_frame_fix_count_);
  TF_copy_u16(&contents[22], uart_test_instance->driver.super.stream_config[1].rx_frame_rec_len_);
  TF_copy_u8(&contents[24], uart_test_instance->driver.super.stream_config[1].is_rx_buffer_carry_over_);
#endif

  return 25;
}

#pragma section
